# Pant React

[![codecov](https://codecov.io/gh/webyom/pant-react/branch/master/graph/badge.svg)](https://codecov.io/gh/webyom/pant-react)
[![Commitizen friendly](https://img.shields.io/badge/commitizen-friendly-brightgreen.svg)](http://commitizen.github.io/cz-cli/)

Mobile UI Components built on React

Ported from [Vant](https://github.com/youzan/vant)

### Install

```bash
# Using npm
npm i pant-react -S

# Using yarn
yarn add pant-react
```

### Import base style

Import base style in your bootstrap file.

```js
import 'pant-react/es/styles/base.scss';
```

### Import component on demand

```js
import { Button } from 'pant-react/es/button';
```

### Components

- Basic Components
  - [Button](https://webyom.github.io/pant-react/#/components/button)
  - [Cell](https://webyom.github.io/pant-react/#/components/cell)
  - [Image](https://webyom.github.io/pant-react/#/components/img)
  - [Layout](https://webyom.github.io/pant-react/#/components/layout)
  - [Popup](https://webyom.github.io/pant-react/#/components/popup)
  - [Built-in Styles](https://webyom.github.io/pant-react/#/components/styles)
- Form Components
  - [Cascader](https://webyom.github.io/pant-react/#/components/cascader)
  - [Checkbox](https://webyom.github.io/pant-react/#/components/checkbox)
  - [DatetimePicker](https://webyom.github.io/pant-react/#/components/datetime-picker)
  - [Field](https://webyom.github.io/pant-react/#/components/field)
  - [Form](https://webyom.github.io/pant-react/#/components/form)
  - [NumberKeyboard](https://webyom.github.io/pant-react/#/components/number-keyboard)
  - [PasswordInput](https://webyom.github.io/pant-react/#/components/password-input)
  - [Picker](https://webyom.github.io/pant-react/#/components/picker)
  - [Radio](https://webyom.github.io/pant-react/#/components/radio)
  - [Search](https://webyom.github.io/pant-react/#/components/search)
  - [SearchablePicker](https://webyom.github.io/pant-react/#/components/searchable-picker)
  - [Switch](https://webyom.github.io/pant-react/#/components/switch)
- Action Components
  - [ActionSheet](https://webyom.github.io/pant-react/#/components/action-sheet)
  - [Dialog](https://webyom.github.io/pant-react/#/components/dialog)
  - [Loading](https://webyom.github.io/pant-react/#/components/loading)
  - [Notify](https://webyom.github.io/pant-react/#/components/notify)
  - [Overlay](https://webyom.github.io/pant-react/#/components/overlay)
  - [PullRefresh](https://webyom.github.io/pant-react/#/components/pull-refresh)
  - [Toast](https://webyom.github.io/pant-react/#/components/toast)
- Diaplay Components
  - [DataList](https://webyom.github.io/pant-react/#/components/data-list)
  - [Lazyload](https://webyom.github.io/pant-react/#/components/lazyload)
  - [List](https://webyom.github.io/pant-react/#/components/list)
  - [Skeleton](https://webyom.github.io/pant-react/#/components/skeleton)
  - [Sticky](https://webyom.github.io/pant-react/#/components/sticky)
  - [Tag](https://webyom.github.io/pant-react/#/components/tag)
- Navigation Components
  - [Tab](https://webyom.github.io/pant-react/#/components/tab)
- Business Components
  - [Card](https://webyom.github.io/pant-react/#/components/card)
  - [SubmitBar](https://webyom.github.io/pant-react/#/components/submit-bar)

### Preview

You can scan the following QR code to access the demo on mobile

<img src="https://webyom.github.io/pant-react/assets/qr-code.png" width="220" height="220" />

### Docs

https://webyom.github.io/pant-react/
