var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import clsx from 'clsx';
import { Popup } from '../popup';
import { Loading } from '../loading';
import { Icon } from '../icon';
import { createBEM } from '../utils/bem';
import { BORDER_TOP } from '../utils/constant';
import './index.scss';
var bem = createBEM('pant-action-sheet');
export var ActionSheet = function (props) {
    var show = props.show, title = props.title, cancelText = props.cancelText;
    function Header() {
        if (title) {
            return (_jsxs("div", __assign({ className: bem('header') }, { children: [title, _jsx(Icon, { name: props.closeIcon, className: bem('close'), onClick: props.onCancel }, void 0)] }), void 0));
        }
    }
    function Content() {
        if (props.children) {
            return _jsx("div", __assign({ className: bem('content') }, { children: props.children }), void 0);
        }
    }
    function Option(item, index) {
        var disabled = item.disabled, loading = item.loading;
        function onClickOption(event) {
            event.stopPropagation();
            if (disabled || loading) {
                return;
            }
            props.onSelect && props.onSelect(item, index);
        }
        function OptionContent() {
            if (loading) {
                return _jsx(Loading, { size: "20px" }, void 0);
            }
            return [
                _jsx("span", __assign({ className: bem('name') }, { children: item.name }), "name"),
                item.subname && (_jsx("span", __assign({ className: bem('subname') }, { children: item.subname }), "subname")),
            ];
        }
        return (_jsx("button", __assign({ type: "button", className: clsx(bem('item', { disabled: disabled, loading: loading }), item.className, BORDER_TOP), style: { color: item.color }, onClick: onClickOption }, { children: OptionContent() }), index));
    }
    function CancelText() {
        if (cancelText) {
            return (_jsx("button", __assign({ type: "button", className: bem('cancel'), onClick: props.onCancel }, { children: cancelText }), void 0));
        }
    }
    var Description = props.description && _jsx("div", __assign({ className: bem('description') }, { children: props.description }), void 0);
    return (_jsx(Popup, __assign({ className: bem(), show: show, position: props.position || 'bottom', zIndex: props.zIndex, round: props.round, overlay: props.overlay, duration: props.duration, lazyRender: props.lazyRender, closeOnClickOverlay: props.closeOnClickOverlay, safeAreaInsetBottom: props.safeAreaInsetBottom, onClickClose: props.onCancel, onOpened: show ? props.onOpened : null, onClosed: show ? null : props.onClosed }, { children: _jsxs(_Fragment, { children: [Header(), Description, props.actions && props.actions.map(Option), Content(), CancelText()] }, void 0) }), void 0));
};
ActionSheet.defaultProps = {
    round: true,
    safeAreaInsetBottom: true,
    closeOnClickOverlay: true,
};
