var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import clsx from 'clsx';
import { BORDER_SURROUND, WHITE } from '../utils/constant';
import { createBEM } from '../utils/bem';
import { Icon } from '../icon';
import { Loading } from '../loading';
import './index.scss';
var bem = createBEM('pant-button');
export var Button = function (props) {
    var _a;
    var url = props.url, icon = props.icon, type = props.type, color = props.color, plain = props.plain, disabled = props.disabled, loading = props.loading, hairline = props.hairline, loadingText = props.loadingText;
    var style = {};
    if (color) {
        style.color = plain ? color : WHITE;
        if (!plain) {
            // Use background instead of backgroundColor to make linear-gradient work
            style.background = color;
        }
        // hide border when color is linear-gradient
        if (color.indexOf('gradient') !== -1) {
            style.border = '0';
        }
        else {
            style.borderColor = color;
        }
    }
    style = __assign(__assign({}, style), props.style);
    function onClick(event) {
        if (!loading && !disabled && props.onClick) {
            props.onClick(event);
        }
    }
    var classes = [
        bem([
            type,
            props.size,
            {
                plain: plain,
                loading: loading,
                disabled: disabled,
                hairline: hairline,
                block: props.block,
                round: props.round,
                square: props.square,
            },
        ]),
        (_a = {}, _a[BORDER_SURROUND] = hairline, _a),
        props.className,
    ];
    function Content() {
        var content = [];
        if (loading) {
            content.push(_jsx(Loading, { className: bem('loading'), size: props.loadingSize, type: props.loadingType, color: "currentColor" }, "loading"));
        }
        else if (icon) {
            content.push(_jsx(Icon, { name: icon, className: bem('icon') }, "icon"));
        }
        var text;
        if (loading) {
            text = loadingText;
        }
        else {
            text = props.children || props.text;
        }
        if (text) {
            content.push(_jsx("span", __assign({ className: bem('text') }, { children: text }), "text"));
        }
        return content;
    }
    if (url) {
        return (_jsx("a", __assign({ href: url, style: style, className: clsx(classes), disabled: disabled, target: props.targetBlank ? '_blank' : undefined }, { children: Content() }), void 0));
    }
    else {
        return (_jsx("button", __assign({ style: style, className: clsx(classes), type: props.nativeType, disabled: disabled, onClick: onClick }, { children: Content() }), void 0));
    }
};
Button.defaultProps = {
    type: 'default',
    size: 'normal',
    loadingSize: '20px',
};
