var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import clsx from 'clsx';
import { Tag } from '../tag';
import { Img } from '../img';
import { isDef } from '../utils';
import { createBEM } from '../utils/bem';
import './index.scss';
var bem = createBEM('pant-card');
export var Card = function (props) {
    var thumb = props.thumb;
    var showNum = isDef(props.num);
    var showPrice = isDef(props.price);
    var showOriginPrice = isDef(props.originPrice);
    var showBottom = showNum || showPrice || showOriginPrice || isDef(props.bottomNode);
    function ThumbTag() {
        if (props.tagNode || props.tag) {
            return (_jsx("div", __assign({ className: bem('tag') }, { children: props.tagNode ? (props.tagNode) : (_jsx(Tag, __assign({ mark: true, type: "danger" }, { children: props.tag }), void 0)) }), void 0));
        }
    }
    function Thumb() {
        if (props.thumbNode || thumb) {
            return (_jsxs("a", __assign({ href: props.thumbLink, className: bem('thumb'), onClick: props.onClickThumb }, { children: [props.thumbNode ? (props.thumbNode) : (_jsx(Img, { src: thumb, width: "100%", height: "100%", fit: "cover", lazyLoad: props.lazyLoad }, void 0)), ThumbTag()] }), void 0));
        }
    }
    function Title() {
        if (props.titleNode) {
            return props.titleNode;
        }
        if (props.title) {
            return _jsx("div", __assign({ className: clsx(bem('title'), 'van-multi-ellipsis--l2') }, { children: props.title }), void 0);
        }
    }
    function Desc() {
        if (props.descNode) {
            return props.descNode;
        }
        if (props.desc) {
            return _jsx("div", __assign({ className: clsx(bem('desc'), 'van-ellipsis') }, { children: props.desc }), void 0);
        }
    }
    function PriceContent() {
        var priceArr = props.price.toString().split('.');
        return (_jsxs("div", { children: [_jsx("span", __assign({ className: bem('price-currency') }, { children: props.currency }), void 0),
                _jsx("span", __assign({ className: bem('price-integer') }, { children: priceArr[0] }), void 0), ".", _jsx("span", __assign({ className: bem('price-decimal') }, { children: priceArr[1] }), void 0)] }, void 0));
    }
    function Price() {
        if (showPrice) {
            return _jsx("div", __assign({ className: bem('price') }, { children: props.priceNode ? props.priceNode : PriceContent() }), void 0);
        }
    }
    function OriginPrice() {
        if (showOriginPrice) {
            return (_jsx("div", __assign({ className: bem('origin-price') }, { children: props.originPriceNode ? props.originPriceNode : props.currency + " " + props.originPrice }), void 0));
        }
    }
    function Num() {
        if (showNum) {
            return _jsx("div", __assign({ className: bem('num') }, { children: props.numNode ? props.numNode : "x" + props.num }), void 0);
        }
    }
    function Footer() {
        if (props.footerNode) {
            return _jsx("div", __assign({ className: bem('footer') }, { children: props.footerNode }), void 0);
        }
    }
    return (_jsxs("div", __assign({ className: bem() }, { children: [_jsxs("div", __assign({ className: bem('header') }, { children: [Thumb(), _jsxs("div", __assign({ className: bem('content', { centered: props.centered }) }, { children: [_jsxs("div", { children: [Title(), Desc(), props.tagsNode] }, void 0),
                            showBottom && (_jsxs("div", __assign({ className: "van-card__bottom" }, { children: [props.priceTopNode, Price(), OriginPrice(), Num(), props.bottomNode] }), void 0))] }), void 0)] }), void 0), Footer()] }), void 0));
};
Card.defaultProps = {
    currency: '¥',
};
