var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Icon } from '../icon';
import { createBEM } from '../utils/bem';
var bem = createBEM('pant-cascader');
export var CascaderColumn = function (props) {
    var width = props.width, index = props.index, value = props.value, items = props.items, checkedIcon = props.checkedIcon, uncheckedIcon = props.uncheckedIcon, isItemSelected = props.isItemSelected, hasChildrenSelected = props.hasChildrenSelected, normalizeItem = props.normalizeItem, onClick = props.onClick;
    var style = { width: width + 'px' };
    var genChildrenSelectedMark = function (item) {
        if (item.children && hasChildrenSelected(index, item)) {
            return _jsx("div", { className: bem('children-selected') }, void 0);
        }
    };
    var genItemSelectedMark = function (item) {
        if (item.children) {
            return;
        }
        var selected = isItemSelected(index, item);
        return (_jsx("div", __assign({ className: bem('item-selection', { selected: selected }) }, { children: selected ? (checkedIcon !== undefined ? (checkedIcon) : (_jsx(Icon, { name: "passed" }, void 0))) : uncheckedIcon !== undefined ? (uncheckedIcon) : (_jsx(Icon, { name: "circle" }, void 0)) }), void 0));
    };
    return (_jsx("div", __assign({ className: bem('column'), style: style }, { children: items.map(function (item) {
            var stdItem = normalizeItem(item);
            return (_jsxs("div", __assign({ className: bem('item', { selected: item.value === value }), onClick: function () { return onClick(index, stdItem); } }, { children: [item.label, genChildrenSelectedMark(stdItem), genItemSelectedMark(stdItem)] }), item.value));
        }) }), void 0));
};
