var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import clsx from 'clsx';
import { Icon } from '../icon';
import { isDef } from '../utils';
import { createBEM } from '../utils/bem';
import './index.scss';
var bem = createBEM('pant-cell');
export var Cell = function (props) {
    var icon = props.icon, title = props.title, label = props.label, rightIcon = props.rightIcon;
    var showTitle = isDef(title);
    function Label() {
        if (isDef(label)) {
            return _jsx("div", __assign({ className: bem('label') }, { children: label }), void 0);
        }
    }
    function Title() {
        if (showTitle) {
            return (_jsxs("div", __assign({ className: clsx(bem('title'), props.titleClassName), style: props.titleStyle }, { children: [typeof title === 'string' ? _jsx("span", { children: title }, void 0) : title, Label()] }), void 0));
        }
    }
    function Value() {
        if (isDef(props.children)) {
            return _jsx("div", __assign({ className: clsx(bem('value', { alone: !showTitle }), props.valueClassName) }, { children: props.children }), void 0);
        }
    }
    function LeftIcon() {
        if (typeof icon === 'string') {
            return _jsx(Icon, { className: bem('left-icon'), name: icon }, void 0);
        }
        else if (icon) {
            return icon;
        }
    }
    function RightIcon() {
        if (typeof rightIcon === 'string') {
            return _jsx(Icon, { className: bem('right-icon'), name: rightIcon }, void 0);
        }
        else if (rightIcon) {
            return rightIcon;
        }
    }
    function onClick(event) {
        props.onClick && props.onClick(event);
    }
    var clickable = !!props.onClick;
    var classes = {
        clickable: clickable,
        large: props.size === 'large',
        center: props.center,
        required: props.required,
        borderless: !props.border,
    };
    return (_jsxs("div", __assign({ className: clsx(bem(classes), props.className), role: clickable ? 'button' : null, tabIndex: clickable ? 0 : null, onClick: onClick, style: props.style }, { children: [LeftIcon(), Title(), Value(), RightIcon()] }), void 0));
};
Cell.defaultProps = {
    border: true,
};
