import React from 'react';
import { CellGroupProps } from '../cell-group';
import { CheckboxBaseProps, CheckboxProps, CheckboxRole } from '../checkbox';
import './index.scss';
export declare type CheckboxGroupOption = string | {
    [key: string]: any;
    label: string;
    value: string;
    disabled?: boolean;
};
export declare type CheckboxGroupOptions = CheckboxGroupOption[];
export declare type CheckboxGroupBaseProps = CheckboxBaseProps & {
    cellGroup?: boolean | CellGroupProps;
    options?: CheckboxGroupOptions;
    valueKey?: string | string[];
    labelKey?: string | string[];
    onClick?(event: Event, checkboxProps: CheckboxProps): void;
    onChange?(value: string[], props: CheckboxGroupProps): void;
};
export declare type CheckboxGroupProps = CheckboxGroupBaseProps & {
    role?: CheckboxRole;
    defaultValue?: string[];
    max?: number | string;
    onMaxLimit?(props: CheckboxGroupProps): void;
};
declare type CheckboxGroupState = {
    value: string[];
};
export declare class CheckboxGroup extends React.PureComponent<CheckboxGroupProps, CheckboxGroupState> {
    static defaultProps: {
        disabled: boolean;
        labelPosition: string;
        shape: string;
        direction: string;
        options: CheckboxGroupOptions[];
        valueKey: string;
        labelKey: string;
        defaultValue: string[];
    };
    bindedOnClick: any;
    state: {
        value: string[];
    };
    getValue(): string[];
    toggleAll(on?: boolean): void;
    private setNewValue;
    private normalizeOption;
    private onClick;
    private onCellClick;
    private genOption;
    private genOptions;
    render(): JSX.Element;
}
export {};
