import React from 'react';
import './index.scss';
export declare type CheckboxRole = 'checkbox' | 'radio';
export declare type CheckboxBaseProps = {
    name?: string;
    disabled?: boolean;
    iconSize?: number | string;
    checkedColor?: string;
    labelPosition?: 'left' | 'right';
    labelDisabled?: boolean;
    shape?: 'square' | 'round';
    direction?: 'horizontal' | 'vertical';
    iconNode?: React.ReactNode;
    activeIconNode?: React.ReactNode;
    inactiveIconNode?: React.ReactNode;
};
export declare type CheckboxProps = CheckboxBaseProps & {
    value?: string;
    checked?: boolean;
    role?: CheckboxRole;
    children?: React.ReactNode;
    onClick?(event: React.MouseEvent, props: CheckboxProps): void;
};
export declare const Checkbox: React.FC<CheckboxProps>;
