var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { useContext } from 'react';
import { Button } from '../../../button';
import { actionSheet } from '../../../action-sheet';
import { i18n } from '../../../locale';
import { SelectableContext } from '../selectable';
import './index.scss';
export function batchActions(options) {
    return {
        onInjectToolbar: function (render) { return function (props) {
            return (_jsxs(_Fragment, { children: [render(props), _jsx(BatchActions, __assign({}, options), void 0)] }, void 0));
        }; },
    };
}
function BatchActions(_a) {
    var render = _a.render, getActions = _a.getActions, cancelText = _a.cancelText;
    var selectable = useContext(SelectableContext);
    var showActions = function () {
        if (!getActions) {
            return;
        }
        var actions = getActions(selectable);
        actionSheet({
            position: 'top',
            round: false,
            actions: actions.slice(1),
            cancelText: typeof cancelText === 'undefined' ? i18n().cancel : cancelText,
            onSelect: function (_a) {
                var action = _a.action;
                action(selectable);
            },
        });
    };
    if (render) {
        return _jsx("div", __assign({ className: "pant-data-list__batch-actions" }, { children: render(selectable, showActions) }), void 0);
    }
    var actions = getActions(selectable);
    var firstAction = actions[0];
    var secondAction = actions[1];
    var performFirstAction = function () {
        firstAction.action(selectable);
    };
    var performSecondAction = function () {
        secondAction.action(selectable);
    };
    return (_jsxs("div", __assign({ className: "pant-data-list__batch-actions" }, { children: [firstAction ? (_jsx(Button, __assign({ size: "small", type: "info", plain: true, onClick: performFirstAction }, { children: firstAction.name }), void 0)) : null,
            actions.length > 2 ? (_jsx(Button, __assign({ size: "small", onClick: showActions }, { children: "More ..." }), void 0)) : secondAction ? (_jsx(Button, __assign({ size: "small", onClick: performSecondAction }, { children: secondAction.name }), void 0)) : null] }), void 0));
}
