import React from 'react';
import { DatetimePickerProps, DatetimeRangeProps } from '../../../datetime-picker';
import { CascaderProps } from '../../../cascader';
import { SearchablePickerProps } from '../../../searchable-picker';
import { DataListAddon } from '../..';
import './index.scss';
export declare type FilterableColumn = {
    key: string;
    header: React.ReactNode;
    placeholder?: string;
    type?: 'input' | 'switch' | 'cascader' | 'searchable-picker' | 'datetime' | 'datetime-range';
    component?: React.PureComponent<CascaderProps | SearchablePickerProps | DatetimePickerProps | DatetimeRangeProps>;
    componentProps?: CascaderProps | SearchablePickerProps | DatetimePickerProps | DatetimeRangeProps;
};
export declare type FilterableOptions = {
    columns: FilterableColumn[];
    value?: Record<string, any>;
    filterButton?: JSX.Element;
    filterTitle?: string;
    cancelButtonText?: string;
    confirmButtonText?: string;
    onChange: (value: Record<string, any>) => void;
    onPopup?: (event: React.SyntheticEvent) => boolean;
};
export declare function filterable(options: FilterableOptions): DataListAddon;
