var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { useState, useEffect, useRef } from 'react';
import { Icon } from '../../../icon';
import { Popup } from '../../../popup';
import { PopupToolbar } from '../../../popup/toolbar';
import { Form } from '../../../form';
import { Field } from '../../../field';
import { DatetimePicker, DatetimeRange, } from '../../../datetime-picker';
import { Cascader } from '../../../cascader';
import { SearchablePicker } from '../../../searchable-picker';
import { createBEM } from '../../../utils/bem';
import { addClass, removeClass } from '../../../utils/dom';
import { i18n } from '../../../locale';
import './index.scss';
export function filterable(options) {
    return {
        onInjectToolbar: function (render) { return function (props) {
            return (_jsxs(_Fragment, { children: [render(props), _jsx(Filterable, __assign({}, options), void 0)] }, void 0));
        }; },
    };
}
var bem = createBEM('pant-data-list__filter');
function formatDatetime(date, type) {
    var y = date.getFullYear();
    var m = date.getMonth() + 1;
    var d = date.getDate();
    var h = date.getHours();
    var mm = date.getMinutes();
    var dd = y + "-" + (m < 10 ? '0' + m : m) + "-" + (d < 10 ? '0' + d : d);
    var tt = (h < 10 ? '0' + h : h) + ":" + (mm < 10 ? '0' + mm : mm);
    if (type === 'datetime') {
        return dd + ' ' + tt;
    }
    else if (type === 'time') {
        return tt;
    }
    else {
        return dd;
    }
}
function Filterable(_a) {
    var _b = _a.columns, columns = _b === void 0 ? [] : _b, _c = _a.value, value = _c === void 0 ? {} : _c, filterButton = _a.filterButton, filterTitle = _a.filterTitle, cancelButtonText = _a.cancelButtonText, confirmButtonText = _a.confirmButtonText, onPopup = _a.onPopup, onChange = _a.onChange;
    var submitBtnRef = useRef();
    var _d = useState(false), show = _d[0], setShow = _d[1];
    var onClick = function (event) {
        if (onPopup && onPopup(event) === false) {
            return;
        }
        setShow(true);
        addClass(document.body, 'pant-overflow-hidden');
    };
    var hide = function () {
        removeClass(document.body, 'pant-overflow-hidden');
        setShow(false);
    };
    var confirm = function () {
        submitBtnRef.current.click();
        hide();
    };
    useEffect(function () {
        return function () {
            if (show) {
                removeClass(document.body, 'pant-overflow-hidden');
            }
        };
    }, [show]);
    return (_jsxs(_Fragment, { children: [_jsx("div", __assign({ className: bem(), onClick: onClick }, { children: filterButton || (_jsxs(_Fragment, { children: [_jsx("span", { children: i18n().filter }, void 0),
                        _jsx(Icon, { name: "filter-o" }, void 0)] }, void 0)) }), void 0),
            _jsx(Popup, __assign({ show: show, position: "right", onClickClose: hide, style: { width: '85%', height: '100%' }, lazyRender: true }, { children: _jsxs("div", __assign({ className: bem('popup') }, { children: [_jsx(PopupToolbar, { className: bem('title'), title: filterTitle || i18n().filter }, void 0),
                        _jsx("div", __assign({ className: bem('list') }, { children: _jsxs(Form, __assign({ onSubmit: function (promise) {
                                    promise.then(function (res) {
                                        onChange && onChange(res.data);
                                    });
                                } }, { children: [columns.map(function (_a) {
                                        var key = _a.key, header = _a.header, _b = _a.type, type = _b === void 0 ? 'input' : _b, CustomComponent = _a.component, _c = _a.componentProps, componentProps = _c === void 0 ? {} : _c, placeholder = _a.placeholder;
                                        if (type === 'cascader') {
                                            var Comp = CustomComponent || Cascader;
                                            return (_jsx(Field, __assign({ name: key, title: header, placeholder: placeholder, direction: "column", clearable: true, displayValueFormatter: function (value) {
                                                    if (!value || !value.length) {
                                                        return '';
                                                    }
                                                    if (typeof value[0] === 'string') {
                                                        return value.join('/');
                                                    }
                                                    else if (Array.isArray(value[0])) {
                                                        return value.map(function (item) { return item.join('/'); }).join(', ');
                                                    }
                                                    return '';
                                                } }, { children: _jsx(Popup, __assign({ position: "bottom", closeOnClickOverlay: true }, { children: _jsx(Comp, __assign({}, componentProps, { defaultValue: value[key] }), void 0) }), void 0) }), key));
                                        }
                                        else if (type === 'searchable-picker') {
                                            var Comp = CustomComponent || SearchablePicker;
                                            return (_jsx(Field, __assign({ name: key, title: header, placeholder: placeholder, direction: "column", clearable: true, displayValueFormatter: function (value) {
                                                    if (typeof value === 'string') {
                                                        return value;
                                                    }
                                                    else if (Array.isArray(value)) {
                                                        return value && value.join(', ');
                                                    }
                                                    return '';
                                                } }, { children: _jsx(Popup, __assign({ position: "bottom", closeOnClickOverlay: true }, { children: _jsx(Comp, __assign({}, componentProps, { defaultValue: value[key] }), void 0) }), void 0) }), key));
                                        }
                                        else if (type === 'datetime') {
                                            var Comp = CustomComponent || DatetimePicker;
                                            var props = componentProps;
                                            var datetimeType_1 = props.type || 'date';
                                            return (_jsx(Field, __assign({ name: key, title: header, placeholder: placeholder, direction: "column", clearable: true, displayValueFormatter: function (value) {
                                                    return value && formatDatetime(value, datetimeType_1);
                                                } }, { children: _jsx(Popup, __assign({ position: "bottom", closeOnClickOverlay: true }, { children: _jsx(Comp, __assign({}, props, { defaultValue: value[key] }), void 0) }), void 0) }), key));
                                        }
                                        else if (type === 'datetime-range') {
                                            var Comp = CustomComponent || DatetimeRange;
                                            var props = componentProps;
                                            var datetimeType_2 = props.type || 'date';
                                            return (_jsx(Field, __assign({ name: key, title: header, placeholder: placeholder, direction: "column", clearable: true, displayValueFormatter: function (value) {
                                                    return (value &&
                                                        value.length &&
                                                        formatDatetime(value[0], datetimeType_2) + " ~ " + formatDatetime(value[1], datetimeType_2));
                                                } }, { children: _jsx(Comp, __assign({}, props, { defaultValue: value[key] }), void 0) }), key));
                                        }
                                        else if (type === 'switch') {
                                            return (_jsx(Field, { className: "flex-direction-row", type: "switch", inputAlign: "right", defaultValue: value[key], name: key, title: header }, key));
                                        }
                                        return (_jsx(Field, { defaultValue: value[key], placeholder: placeholder, name: key, title: header, clearable: true, clearTrigger: "always", direction: "column" }, key));
                                    }),
                                    _jsx("button", { ref: submitBtnRef, type: "submit", style: { display: 'none' } }, void 0)] }), void 0) }), void 0),
                        _jsx(PopupToolbar, { className: bem('footer'), onCancel: hide, onConfirm: confirm, cancelButtonText: cancelButtonText, confirmButtonText: confirmButtonText }, void 0)] }), void 0) }), void 0)] }, void 0));
}
