var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { useState } from 'react';
import { Icon } from '../icon';
import { createBEM } from '../utils/bem';
import { i18n } from '../locale';
import { useMiddleware } from './use-middleware';
var bem = createBEM('pant-data-list__record');
export var DataListRecord = function (props) {
    var addons = props.addons;
    var _a = useState(true), collapsed = _a[0], setCollapsed = _a[1];
    var toggle = function () {
        setCollapsed(!collapsed);
    };
    var defaultColumnRender = function (_a) {
        var record = _a.record, column = _a.column;
        return record[column.key];
    };
    var renderRecord = useMiddleware(addons, 'onInjectRecord')(function (_a) {
        var columns = _a.columns, recordRender = _a.recordRender, expandButton = _a.expandButton, collapseButton = _a.collapseButton, record = _a.record, recordIndex = _a.recordIndex;
        if (recordRender) {
            return _jsx("div", __assign({ className: bem('fields-wrapper') }, { children: recordRender(record, recordIndex) }), void 0);
        }
        if (!columns) {
            return;
        }
        var expandable = columns.length > 4;
        return (_jsxs("div", __assign({ className: bem('fields-wrapper') }, { children: [_jsx("div", __assign({ className: bem('fields') }, { children: columns
                        .map(function (column, columnIndex) {
                        if (expandable && collapsed && columnIndex >= 3) {
                            return;
                        }
                        var columnRender = column.render || defaultColumnRender;
                        return (_jsxs("div", __assign({ className: bem('field') }, { children: [_jsx("div", __assign({ className: bem('title') }, { children: typeof column.header === 'function' ? column.header(column) : column.header }), void 0),
                                _jsx("div", __assign({ className: bem('value') }, { children: columnRender({ record: record, recordIndex: recordIndex, column: column, columnIndex: columnIndex }) }), void 0)] }), column.key));
                    })
                        .filter(Boolean) }), void 0),
                expandable ? (_jsx("div", __assign({ className: bem('expand'), onClick: toggle }, { children: expandButton && collapsed ? (expandButton) : collapseButton && !collapsed ? (collapseButton) : (_jsxs(_Fragment, { children: [_jsx("span", { children: collapsed ? i18n().expand : i18n().collapse }, void 0),
                            _jsx(Icon, { name: collapsed ? 'arrow-down' : 'arrow-up' }, void 0)] }, void 0)) }), void 0)) : null] }), void 0));
    });
    return _jsx("div", __assign({ className: bem() }, { children: renderRecord(props) }), void 0);
};
