var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
import { jsx as _jsx } from "react/jsx-runtime";
import React from 'react';
import { Picker } from '../picker';
import { createBEM } from '../utils/bem';
import './index.scss';
var bem = createBEM('pant-datetime-picker');
function getDefaultMinMax(max) {
    var now = new Date();
    var nowYear = now.getFullYear();
    return max ? new Date(nowYear + 5, 11, 31, 23, 59, 59) : new Date(nowYear - 5, 0, 1, 0, 0, 0);
}
var DatetimePicker = /** @class */ (function (_super) {
    __extends(DatetimePicker, _super);
    function DatetimePicker(props) {
        var _this = _super.call(this, props) || this;
        var pickerValue = _this.genPickerValue();
        _this.state = {
            columns: _this.genColumns(pickerValue),
            pickerValue: pickerValue,
            viewPickerValue: pickerValue.length ? pickerValue : _this.genPickerValue(new Date()),
        };
        _this.onChange = _this.onChange.bind(_this);
        _this.onConfirm = _this.onConfirm.bind(_this);
        _this.onCancel = _this.onCancel.bind(_this);
        return _this;
    }
    DatetimePicker.prototype.getValue = function (value) {
        var _a = this.props, type = _a.type, seconds = _a.seconds;
        var pickerValue = this.state.pickerValue;
        value = value || pickerValue;
        if (!value.length) {
            return null;
        }
        if (type === 'time') {
            var _b = value.map(function (v) { return parseInt(v); }), h = _b[0], mm = _b[1], s = _b[2];
            var now = new Date();
            return new Date(now.getFullYear(), now.getMonth(), now.getDate(), h, mm, seconds ? s : 0);
        }
        else {
            var _c = value.map(function (v) { return parseInt(v); }), y = _c[0], m = _c[1], d = _c[2], h = _c[3], mm = _c[4], s = _c[5];
            if (type === 'datetime') {
                return new Date(y, m, d, h, mm, seconds ? s : 0);
            }
            else if (type === 'yearmonth') {
                return new Date(y, m);
            }
            else {
                return new Date(y, m, d);
            }
        }
    };
    DatetimePicker.prototype.clearValue = function (cb) {
        this.setState({ pickerValue: [], viewPickerValue: this.genPickerValue(new Date()) }, cb);
    };
    DatetimePicker.prototype.range = function (start, end) {
        if (start > end) {
            return [];
        }
        var res = [];
        for (var i = start; i <= end; i++) {
            res.push(i);
        }
        return res;
    };
    DatetimePicker.prototype.prefixZero = function (n) {
        if (this.props.prefixZero && n < 10) {
            return '0' + n;
        }
        return '' + n;
    };
    DatetimePicker.prototype.getMonthDays = function (year, month) {
        if (typeof year === 'string') {
            year = parseInt(year);
        }
        if (typeof month === 'string') {
            month = parseInt(month);
        }
        if (month === 1) {
            if (year % 100 === 0) {
                if ((year / 100) % 4 === 0) {
                    return 29;
                }
                else {
                    return 28;
                }
            }
            else if (year % 4 === 0) {
                return 29;
            }
            else {
                return 28;
            }
        }
        else if ([0, 2, 4, 6, 7, 9, 11].includes(month)) {
            return 31;
        }
        else {
            return 30;
        }
    };
    DatetimePicker.prototype.genTimePickerColumns = function (pickerValue) {
        var _a, _b;
        var _this = this;
        var _c = this.props, min = _c.min, max = _c.max, seconds = _c.seconds, formatter = _c.formatter;
        var minH = min.getHours();
        var minMM = min.getMinutes();
        var minS = min.getSeconds();
        var maxH = max.getHours();
        var maxMM = max.getMinutes();
        var maxS = max.getSeconds();
        var pickH, pickMM;
        if (pickerValue.length) {
            _a = pickerValue.map(function (s) { return parseInt(s); }), pickH = _a[0], pickMM = _a[1];
        }
        else {
            _b = [minH, minMM], pickH = _b[0], pickMM = _b[1];
        }
        var res = [];
        res.push(this.range(minH, maxH).map(function (item) { return ({ value: item + '', label: formatter(_this.prefixZero(item), 'h') }); }));
        var minV, maxV;
        if (pickH === minH) {
            minV = minMM;
            if (pickH === maxH) {
                maxV = maxMM;
            }
            else {
                maxV = 59;
            }
        }
        else if (pickH === maxH) {
            minV = 0;
            maxV = maxMM;
        }
        else {
            minV = 0;
            maxV = 59;
        }
        res.push(this.range(minV, maxV).map(function (item) { return ({ value: item + '', label: formatter(_this.prefixZero(item), 'mm') }); }));
        if (seconds) {
            if (pickH === minH && pickMM === minMM) {
                minV = minS;
                if (pickH === maxH && pickMM === maxMM) {
                    maxV = maxS;
                }
                else {
                    maxV = 59;
                }
            }
            else if (pickH === maxH && pickMM === maxMM) {
                minV = 0;
                maxV = maxS;
            }
            else {
                minV = 0;
                maxV = 59;
            }
            res.push(this.range(minV, maxV).map(function (item) { return ({ value: item + '', label: formatter(_this.prefixZero(item), 's') }); }));
        }
        return res;
    };
    DatetimePicker.prototype.genColumns = function (pickerValue) {
        var _a, _b;
        var _this = this;
        var _c = this.props, type = _c.type, min = _c.min, max = _c.max, seconds = _c.seconds, formatter = _c.formatter;
        if (type === 'time') {
            return this.genTimePickerColumns(pickerValue);
        }
        var minY = min.getFullYear();
        var minM = min.getMonth();
        var minD = min.getDate();
        var minH = min.getHours();
        var minMM = min.getMinutes();
        var minS = min.getSeconds();
        var maxY = max.getFullYear();
        var maxM = max.getMonth();
        var maxD = max.getDate();
        var maxH = max.getHours();
        var maxMM = max.getMinutes();
        var maxS = max.getSeconds();
        var pickY, pickM, pickD, pickH, pickMM;
        if (pickerValue.length) {
            _a = pickerValue.map(function (s) { return parseInt(s); }), pickY = _a[0], pickM = _a[1], pickD = _a[2], pickH = _a[3], pickMM = _a[4];
        }
        else {
            _b = [minY, minM, minD, minH, minMM], pickY = _b[0], pickM = _b[1], pickD = _b[2], pickH = _b[3], pickMM = _b[4];
        }
        var res = [];
        res.push(this.range(minY, maxY).map(function (item) { return ({ value: item + '', label: formatter(item + '', 'y') }); }));
        var minV, maxV;
        if (pickY === minY) {
            minV = minM;
            if (pickY === maxY) {
                maxV = maxM;
            }
            else {
                maxV = 11;
            }
        }
        else if (pickY === maxY) {
            minV = 0;
            maxV = maxM;
        }
        else {
            minV = 0;
            maxV = 11;
        }
        res.push(this.range(minV, maxV).map(function (item) { return ({ value: item + '', label: formatter(_this.prefixZero(item + 1), 'm') }); }));
        if (type === 'yearmonth') {
            return res;
        }
        if (pickY === minY && pickM === minM) {
            minV = minD;
            if (pickY === maxY && pickM === maxM) {
                maxV = maxD;
            }
            else {
                maxV = this.getMonthDays(pickY, pickM);
            }
        }
        else if (pickY === maxY && pickM === maxM) {
            minV = 1;
            maxV = maxD;
        }
        else {
            minV = 1;
            maxV = this.getMonthDays(pickY, pickM);
        }
        res.push(this.range(minV, maxV).map(function (item) { return ({ value: item + '', label: formatter(_this.prefixZero(item), 'd') }); }));
        if (type === 'datetime') {
            if (pickY === minY && pickM === minM && pickD === minD) {
                minV = minH;
                if (pickY === maxY && pickM === maxM && pickD === maxD) {
                    maxV = maxH;
                }
                else {
                    maxV = 23;
                }
            }
            else if (pickY === maxY && pickM === maxM && pickD === maxD) {
                minV = 0;
                maxV = maxH;
            }
            else {
                minV = 0;
                maxV = 23;
            }
            res.push(this.range(minV, maxV).map(function (item) { return ({ value: item + '', label: formatter(_this.prefixZero(item), 'h') }); }));
            if (pickY === minY && pickM === minM && pickD === minD && pickH === minH) {
                minV = minMM;
                if (pickY === maxY && pickM === maxM && pickD === maxD && pickH === maxH) {
                    maxV = maxMM;
                }
                else {
                    maxV = 59;
                }
            }
            else if (pickY === maxY && pickM === maxM && pickD === maxD && pickH === maxH) {
                minV = 0;
                maxV = maxMM;
            }
            else {
                minV = 0;
                maxV = 59;
            }
            res.push(this.range(minV, maxV).map(function (item) { return ({ value: item + '', label: formatter(_this.prefixZero(item), 'mm') }); }));
            if (seconds) {
                if (pickY === minY && pickM === minM && pickD === minD && pickH === minH && pickMM === minMM) {
                    minV = minS;
                    if (pickY === maxY && pickM === maxM && pickD === maxD && pickH === maxH && pickMM === maxMM) {
                        maxV = maxS;
                    }
                    else {
                        maxV = 59;
                    }
                }
                else if (pickY === maxY && pickM === maxM && pickD === maxD && pickH === maxH && pickMM === maxMM) {
                    minV = 0;
                    maxV = maxS;
                }
                else {
                    minV = 0;
                    maxV = 59;
                }
                res.push(this.range(minV, maxV).map(function (item) { return ({ value: item + '', label: formatter(_this.prefixZero(item), 's') }); }));
            }
        }
        return res;
    };
    DatetimePicker.prototype.genPickerValue = function (date) {
        var _a = this.props, type = _a.type, min = _a.min, max = _a.max, seconds = _a.seconds, defaultValue = _a.defaultValue;
        if (min > max) {
            throw new Error('min must not be greater than max');
        }
        if (!date) {
            var defaultDate = defaultValue;
            if (type === 'time' && defaultValue) {
                defaultDate = new Date(min.getFullYear(), min.getMonth(), min.getDate(), defaultValue.getHours(), defaultValue.getMinutes(), defaultValue.getSeconds());
            }
            if (defaultDate && defaultDate >= min && defaultDate <= max) {
                date = defaultDate;
            }
            else {
                return [];
            }
        }
        var res = [];
        if (type === 'date' || type === 'datetime') {
            res.push(date.getFullYear() + '');
            res.push(date.getMonth() + '');
            res.push(date.getDate() + '');
        }
        else if (type === 'yearmonth') {
            res.push(date.getFullYear() + '');
            res.push(date.getMonth() + '');
        }
        if (type === 'datetime' || type === 'time') {
            res.push(date.getHours() + '');
            res.push(date.getMinutes() + '');
            if (seconds) {
                res.push(date.getSeconds() + '');
            }
        }
        return res;
    };
    DatetimePicker.prototype.onChange = function (pickerValue) {
        var _this = this;
        var columns = this.genColumns(pickerValue);
        var newPickerValue = pickerValue.map(function (v, i) {
            var val = parseInt(v);
            var column = columns[i];
            var min = parseInt(column[0].value);
            var max = parseInt(column[column.length - 1].value);
            if (val < min) {
                return min + '';
            }
            else if (val > max) {
                return max + '';
            }
            else {
                return val + '';
            }
        });
        this.setState({
            columns: columns,
            viewPickerValue: newPickerValue,
        }, function () {
            var onChange = _this.props.onChange;
            onChange && onChange(_this.getValue(newPickerValue));
        });
    };
    DatetimePicker.prototype.onConfirm = function () {
        var _this = this;
        var _a = this.state, viewPickerValue = _a.viewPickerValue, columns = _a.columns;
        var newPickerValue = __spreadArray([], viewPickerValue);
        columns.forEach(function (item, index) {
            if (item && item.length) {
                if (typeof newPickerValue[index] === 'undefined') {
                    newPickerValue[index] = item[0].value;
                }
            }
        });
        this.setState({ pickerValue: newPickerValue, viewPickerValue: newPickerValue }, function () {
            var _a = _this.props, closePopup = _a.closePopup, onConfirm = _a.onConfirm;
            closePopup && closePopup(true);
            onConfirm && onConfirm(_this.getValue());
        });
    };
    DatetimePicker.prototype.onCancel = function () {
        var _this = this;
        var pickerValue = this.state.pickerValue;
        this.setState({ pickerValue: pickerValue, viewPickerValue: pickerValue }, function () {
            var _a = _this.props, closePopup = _a.closePopup, onCancel = _a.onCancel;
            closePopup && closePopup();
            onCancel && onCancel();
        });
    };
    DatetimePicker.prototype.render = function () {
        var _a = this.props, type = _a.type, title = _a.title, seconds = _a.seconds, seperator = _a.seperator, showToolbar = _a.showToolbar, toolbarPosition = _a.toolbarPosition, confirmButtonText = _a.confirmButtonText, cancelButtonText = _a.cancelButtonText;
        var _b = this.state, columns = _b.columns, viewPickerValue = _b.viewPickerValue;
        return (_jsx("div", __assign({ className: bem([type, { seconds: seconds, seperator: seperator }]) }, { children: _jsx(Picker, { showToolbar: showToolbar, toolbarPosition: toolbarPosition, title: title, confirmButtonText: confirmButtonText, cancelButtonText: cancelButtonText, columns: columns, defaultValue: viewPickerValue, cols: columns.length, onChange: this.onChange, onConfirm: this.onConfirm, onCancel: this.onCancel }, viewPickerValue.join('_')) }), void 0));
    };
    DatetimePicker.defaultProps = {
        type: 'date',
        showToolbar: true,
        toolbarPosition: 'top',
        seconds: false,
        prefixZero: true,
        seperator: true,
        formatter: function (text) { return text; },
        min: getDefaultMinMax(),
        max: getDefaultMinMax(true),
    };
    return DatetimePicker;
}(React.PureComponent));
export { DatetimePicker };
