import React from 'react';
import { PickerProps } from '../picker';
import './index.scss';
export declare type DatetimeRangeProps = Pick<PickerProps, 'showToolbar' | 'toolbarPosition' | 'cancelButtonText' | 'confirmButtonText'> & {
    show?: boolean;
    type: 'date' | 'datetime' | 'time' | 'yearmonth';
    seconds?: boolean;
    min?: Date;
    max?: Date;
    defaultValue?: Date[];
    titleStart?: string;
    titleEnd?: string;
    prefixZero?: boolean;
    seperator?: boolean;
    roundPopup?: boolean;
    formatter?: (text: string, type: 'y' | 'm' | 'd' | 'h' | 'mm' | 's') => string;
    closePopup?: (confirm?: boolean) => void;
    onConfirm?: (value: [Date, Date]) => void;
    onCancel?: () => void;
};
declare type DatetimeRangeState = {
    step: number;
    startDate?: Date;
    endDate?: Date;
};
export declare class DatetimeRange extends React.PureComponent<DatetimeRangeProps, DatetimeRangeState> {
    static readonly __FIELD_BEHAVIOR__ = "Popup";
    static defaultProps: {
        roundPopup: boolean;
        titleStart: string;
        titleEnd: string;
        defaultValue: Date[];
    };
    constructor(props: DatetimeRangeProps);
    getValue(): [Date, Date];
    clearValue(cb: () => void): void;
    closePopup(confirm: boolean): void;
    onConfirm1(date: Date): void;
    onConfirm2(date: Date): void;
    render(): JSX.Element;
}
export {};
