var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useRef } from 'react';
import clsx from 'clsx';
import { Button } from '../button';
import { Overlay } from '../overlay';
import { Transition } from '../transition';
import { addUnit, getIncrementalZIndex } from '../utils';
import { i18n } from '../locale';
import { createBEM } from '../utils/bem';
import { BORDER_TOP, BORDER_LEFT } from '../utils/constant';
import './index.scss';
var bem = createBEM('pant-dialog');
function genButtons(props) {
    var _a;
    var showConfirmButton = props.showConfirmButton, showCancelButton = props.showCancelButton;
    var multiple = showConfirmButton && showCancelButton;
    if (!showConfirmButton && !showCancelButton) {
        return;
    }
    return (_jsxs("div", __assign({ className: clsx(BORDER_TOP, bem('footer', { buttons: multiple })) }, { children: [props.showCancelButton && (_jsx(Button, { size: "large", className: bem('cancel'), loading: props.cancelLoading, text: props.cancelButtonText || i18n().cancel, style: { color: props.cancelButtonColor }, onClick: props.onCancelClick }, void 0)),
            props.showConfirmButton && (_jsx(Button, { size: "large", className: clsx(bem('confirm'), (_a = {}, _a[BORDER_LEFT] = multiple, _a)), loading: props.confirmLoading, text: props.confirmButtonText || i18n().confirm, style: { color: props.confirmButtonColor }, onClick: props.onConfirmClick }, void 0))] }), void 0));
}
export var Dialog = function (props) {
    var _a;
    var containerRef = useRef();
    var show = props.show, zIndex = props.zIndex, html = props.html, message = props.message, messageAlign = props.messageAlign;
    var messageNode = props.messageNode;
    var title = props.titleNode || props.title;
    var zIndexRef = useRef();
    if (!zIndexRef.current) {
        zIndexRef.current = zIndex || getIncrementalZIndex();
    }
    var Title = title && _jsx("div", __assign({ className: bem('header', { isolated: !message && !messageNode }) }, { children: title }), void 0);
    var messageClassName = bem('message', (_a = {
            'has-title': title
        },
        _a[messageAlign] = messageAlign,
        _a));
    var Content = (messageNode || message) && (_jsx("div", __assign({ className: bem('content') }, { children: messageNode ? (messageNode) : html ? (_jsx("div", { dangerouslySetInnerHTML: { __html: message }, className: messageClassName }, void 0)) : (_jsx("div", __assign({ className: messageClassName }, { children: message }), void 0)) }), void 0));
    return (_jsxs(React.Fragment, { children: [props.overlay ? (_jsx(Overlay, { show: show, zIndex: zIndexRef.current, lockScroll: props.lockScroll, onClick: props.cancelOnClickOverlay ? props.onCancelClick : null }, void 0)) : null,
            _jsx(Transition, __assign({ customName: props.transition, stage: show ? 'enter' : 'leave', onAfterEnter: show ? props.onOpened : null, onAfterLeave: show ? null : props.onClosed }, { children: _jsxs("div", __assign({ ref: containerRef, role: "dialog", "aria-labelledby": props.title || message, className: clsx(bem(), props.className), style: { width: addUnit(props.width), zIndex: zIndexRef.current } }, { children: [Title, Content, genButtons(props)] }), void 0) }), void 0)] }, void 0));
};
Dialog.defaultProps = {
    transition: 'dialog-bounce',
    lockScroll: true,
    overlay: true,
    showConfirmButton: true,
    cancelOnClickOverlay: false,
};
