var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import clsx from 'clsx';
import { isDef, addUnit } from '../utils';
import { closest } from '../utils/dom';
import { createBEM } from '../utils/bem';
import { Icon } from '../icon';
import { Cell } from '../cell';
import { Checkbox } from '../checkbox';
import { Switch } from '../switch';
import './index.scss';
var bem = createBEM('pant-field');
function isFnValidatorType(type) {
    return typeof type.validator === 'function';
}
function isInputType(type, children) {
    return (!type && !children) || (!!type && !['checkbox', 'switch'].includes(type));
}
function normalizeDefaultValue(dv, isInputType) {
    if (isDef(dv)) {
        return dv;
    }
    else if (isInputType) {
        return '';
    }
    else {
        return dv;
    }
}
var NO_MATCHED_RULE_FLAG = '__NO_MATCHED_RULE_FLAG__';
var Field = /** @class */ (function (_super) {
    __extends(Field, _super);
    function Field(props) {
        var _this = _super.call(this, props) || this;
        _this.isPopup = false;
        _this.inputRef = React.createRef();
        _this.bodyRef = React.createRef();
        var iit = isInputType(props.type, props.children);
        var value = normalizeDefaultValue(props.defaultValue, iit);
        _this.state = {
            isInputType: iit,
            focused: false,
            showPopup: false,
            popupValue: value,
            value: value,
            validateMessage: '',
            prevProps: props,
        };
        _this.onFocus = _this.onFocus.bind(_this);
        _this.onBlur = _this.onBlur.bind(_this);
        _this.onInputChange = _this.onInputChange.bind(_this);
        _this.onCheckboxClick = _this.onCheckboxClick.bind(_this);
        _this.onSwitchClick = _this.onSwitchClick.bind(_this);
        _this.onPopupControlClick = _this.onPopupControlClick.bind(_this);
        _this.clearInput = _this.clearInput.bind(_this);
        _this.closePopup = _this.closePopup.bind(_this);
        return _this;
    }
    Field.getDerivedStateFromProps = function (props, state) {
        var defaultValueChanged = props.defaultValue !== state.prevProps.defaultValue;
        var iit = isInputType(props.type, props.children);
        var value = normalizeDefaultValue(props.defaultValue, iit);
        return {
            isInputType: iit,
            focused: state.focused,
            showPopup: state.showPopup,
            popupValue: defaultValueChanged ? value : state.popupValue,
            value: defaultValueChanged ? value : state.value,
            validateMessage: defaultValueChanged ? '' : state.validateMessage,
            prevProps: props,
        };
    };
    Field.prototype.componentDidMount = function () {
        this.adjustSize();
        if (this.isPopup) {
            this.setState({ popupValue: this.formatReturnValue(this.getRawValue()) });
        }
    };
    Field.prototype.componentDidUpdate = function () {
        this.adjustSize();
    };
    Field.prototype.isEmptyValue = function (popupValue) {
        if (Array.isArray(popupValue)) {
            return popupValue.length === 0;
        }
        return popupValue == null || popupValue === '';
    };
    Object.defineProperty(Field.prototype, "showClear", {
        get: function () {
            var _a = this.props, clearable = _a.clearable, clearTrigger = _a.clearTrigger, readOnly = _a.readOnly, disabled = _a.disabled;
            var _b = this.state, isInputType = _b.isInputType, focused = _b.focused, value = _b.value, popupValue = _b.popupValue;
            if (this.isPopup && !readOnly && !disabled && !this.isEmptyValue(popupValue)) {
                return clearable;
            }
            return (isInputType &&
                clearable &&
                !readOnly &&
                (clearTrigger === 'always' || focused) &&
                value !== '' &&
                isDef(value));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "showError", {
        get: function () {
            var errorMessage = this.props.errorMessage;
            var validateMessage = this.state.validateMessage;
            return !!validateMessage || !!errorMessage;
        },
        enumerable: false,
        configurable: true
    });
    Field.prototype.getName = function () {
        return this.props.name;
    };
    Field.prototype.getRawValue = function () {
        var _a;
        var type = this.props.type;
        var _b = this.state, isInputType = _b.isInputType, value = _b.value;
        if (this.isCustomChild()) {
            return (_a = this.inputRef.current) === null || _a === void 0 ? void 0 : _a.getValue();
        }
        else if (isInputType) {
            return value;
        }
        else if (type === 'checkbox' || type === 'switch') {
            return !!value;
        }
    };
    Field.prototype.getValue = function () {
        if (this.isPopup) {
            return this.state.popupValue;
        }
        return this.formatReturnValue(this.getRawValue());
    };
    Field.prototype.isCustomChild = function () {
        var _a = this.props, type = _a.type, children = _a.children;
        if (!type && children) {
            return true;
        }
        return false;
    };
    Field.prototype.onFocus = function (evt) {
        this.setState({ focused: true });
        this.props.onFocus && this.props.onFocus(evt);
    };
    Field.prototype.onBlur = function (evt) {
        var _this = this;
        this.setState({ focused: false }, function () {
            _this.validateWithTrigger('blur').then(function (msg) {
                msg === NO_MATCHED_RULE_FLAG || _this.setState({ validateMessage: msg || '' });
            });
        });
        this.props.onBlur && this.props.onBlur(evt);
    };
    Field.prototype.onCustomChange = function (onChange) {
        var _this = this;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        this.validateWithTrigger('change').then(function (msg) {
            msg === NO_MATCHED_RULE_FLAG || _this.setState({ validateMessage: msg || '' });
        });
        if (onChange) {
            onChange.apply(void 0, args);
        }
        this.props.onChange && this.props.onChange(this.getValue());
    };
    Field.prototype.onInputChange = function (evt) {
        var _this = this;
        var _a = this.props, onInputChange = _a.onInputChange, onChange = _a.onChange;
        var returnValue = onInputChange && onInputChange(evt);
        this.setState({ value: returnValue !== undefined ? String(returnValue) : evt.target.value }, function () {
            _this.validateWithTrigger('change').then(function (msg) {
                msg === NO_MATCHED_RULE_FLAG || _this.setState({ validateMessage: msg || '' });
            });
            onChange && onChange(_this.getValue());
        });
    };
    Field.prototype.onCheckboxClick = function (evt, props) {
        var _this = this;
        this.setState({ value: !props.checked }, function () {
            _this.validateWithTrigger('change').then(function (msg) {
                msg === NO_MATCHED_RULE_FLAG || _this.setState({ validateMessage: msg || '' });
            });
            _this.props.onChange && _this.props.onChange(_this.getValue());
        });
    };
    Field.prototype.onSwitchClick = function (evt, props) {
        var _this = this;
        this.setState({ value: !props.on }, function () {
            _this.validateWithTrigger('change').then(function (msg) {
                msg === NO_MATCHED_RULE_FLAG || _this.setState({ validateMessage: msg || '' });
            });
            _this.props.onChange && _this.props.onChange(_this.getValue());
        });
    };
    Field.prototype.openPopup = function () {
        if (!this.isPopup) {
            return;
        }
        this.setState({ showPopup: true });
    };
    Field.prototype.closePopup = function (confirm) {
        var _this = this;
        if (!this.isPopup) {
            return;
        }
        var _a = this.props, onClosePopup = _a.onClosePopup, onChange = _a.onChange;
        if (confirm) {
            this.setState({ showPopup: false, popupValue: this.formatReturnValue(this.getRawValue()) }, function () {
                _this.validateWithTrigger('change').then(function (msg) {
                    msg === NO_MATCHED_RULE_FLAG || _this.setState({ validateMessage: msg || '' });
                });
                onClosePopup && onClosePopup(_this, confirm);
                onChange && onChange(_this.getValue());
            });
        }
        else {
            this.setState({ showPopup: false }, function () {
                onClosePopup && onClosePopup(_this, confirm);
            });
        }
    };
    Field.prototype.onPopupControlClick = function (evt) {
        if (closest(evt.target, '.pant-field__clear', true)) {
            return;
        }
        var _a = this.props, disabled = _a.disabled, readOnly = _a.readOnly;
        if (this.isPopup && !disabled && !readOnly) {
            var target = evt.target;
            var field = closest(target, '.pant-field', true);
            if (field && field.querySelector('.pant-field__body') === this.bodyRef.current) {
                this.openPopup();
            }
        }
    };
    Field.prototype.clearInput = function () {
        var _this = this;
        if (this.isPopup) {
            this.inputRef.current.clearValue(function () {
                _this.setState({ popupValue: _this.formatReturnValue(_this.getRawValue()) }, function () {
                    var onChange = _this.props.onChange;
                    onChange && onChange(_this.getValue());
                });
            });
        }
        else {
            var value = '';
            this.setState({ value: value }, function () {
                var onChange = _this.props.onChange;
                onChange && onChange(_this.getValue());
            });
        }
    };
    Field.prototype.adjustSize = function () {
        var input = this.inputRef.current;
        var _a = this.props, type = _a.type, autosize = _a.autosize;
        if (!(type === 'textarea' && autosize) || !input) {
            return;
        }
        input.style.height = 'auto';
        var height = input.scrollHeight;
        if (typeof autosize === 'object') {
            var maxHeight = autosize.maxHeight, minHeight = autosize.minHeight;
            if (maxHeight) {
                height = Math.min(height, maxHeight);
            }
            else if (minHeight) {
                height = Math.max(height, minHeight);
            }
        }
        if (height) {
            input.style.height = height + 'px';
        }
    };
    Field.prototype.validateWithTrigger = function (trigger) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, validateTrigger, rules, matchedRules;
            return __generator(this, function (_c) {
                _a = this.props, _b = _a.validateTrigger, validateTrigger = _b === void 0 ? [] : _b, rules = _a.rules;
                if (typeof rules === 'function') {
                    if (validateTrigger.includes(trigger)) {
                        return [2 /*return*/, this.validate(rules)];
                    }
                }
                else if (rules && rules.length) {
                    matchedRules = rules.filter(function (rule) {
                        if (typeof rule === 'function') {
                            return validateTrigger.includes(trigger);
                        }
                        else {
                            return ((rule.trigger && rule.trigger.includes(trigger)) || (!rule.trigger && validateTrigger.includes(trigger)));
                        }
                    });
                    if (matchedRules.length) {
                        return [2 /*return*/, this.validate(matchedRules)];
                    }
                }
                return [2 /*return*/, NO_MATCHED_RULE_FLAG];
            });
        });
    };
    Field.prototype.validate = function (rules) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, type, propRules, value_1;
            var _this = this;
            return __generator(this, function (_b) {
                _a = this.props, type = _a.type, propRules = _a.rules;
                rules = rules || propRules;
                if (rules) {
                    value_1 = this.getValue();
                    if (typeof rules === 'function') {
                        return [2 /*return*/, rules(value_1)];
                    }
                    else if (rules.length) {
                        return [2 /*return*/, rules.reduce(function (promise, rule) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    return [2 /*return*/, promise.then(function (msg) {
                                            if (msg) {
                                                return msg;
                                            }
                                            else {
                                                if (typeof rule === 'function') {
                                                    return rule(value_1);
                                                }
                                                else if (isFnValidatorType(rule)) {
                                                    return rule.validator(value_1);
                                                }
                                                else {
                                                    if (typeof rule.pattern === 'string') {
                                                        if (rule.pattern === 'required') {
                                                            if (type === 'checkbox' || type === 'switch') {
                                                                if (!value_1) {
                                                                    return rule.message;
                                                                }
                                                            }
                                                            else {
                                                                if (!isDef(value_1) || (typeof value_1 === 'string' && value_1.trim() === '')) {
                                                                    return rule.message;
                                                                }
                                                            }
                                                        }
                                                    }
                                                    else {
                                                        if (isDef(value_1) && !rule.pattern.test(value_1 + '')) {
                                                            return rule.message;
                                                        }
                                                    }
                                                }
                                            }
                                        })];
                                });
                            }); }, Promise.resolve(''))];
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    Field.prototype.formatReturnValue = function (value) {
        var valueFormatter = this.props.valueFormatter;
        if (!isDef(value) || !valueFormatter) {
            return value;
        }
        return valueFormatter(value);
    };
    Field.prototype.formatDisplayValue = function (value) {
        var displayValueFormatter = this.props.displayValueFormatter;
        if (!isDef(value)) {
            return '';
        }
        if (displayValueFormatter) {
            return displayValueFormatter(value);
        }
        if (typeof value === 'string') {
            return value;
        }
        return String(value);
    };
    Field.prototype.doValidate = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, this.validate().then(function (msg) {
                        _this.setState({ validateMessage: msg || '' });
                        return msg;
                    })];
            });
        });
    };
    Field.prototype.genInput = function () {
        var _this = this;
        var props = this.props;
        var type = props.type, name = props.name, inputAlign = props.inputAlign, readOnly = props.readOnly, children = props.children;
        var _a = this.state, showPopup = _a.showPopup, popupValue = _a.popupValue, isInputType = _a.isInputType, value = _a.value;
        if (this.isCustomChild()) {
            var childrenWithProps = [].concat(children).map(function (child, index) {
                var _a;
                var isPopup = (_this.isPopup = ((_a = child.type) === null || _a === void 0 ? void 0 : _a.__FIELD_BEHAVIOR__) === 'Popup');
                if (!child.type || typeof child.type === 'string') {
                    return child;
                }
                return React.cloneElement(child, {
                    key: index,
                    ref: _this.inputRef,
                    onChange: _this.onCustomChange.bind(_this, child.props.onChange),
                    show: isPopup ? showPopup : undefined,
                    closePopup: isPopup ? _this.closePopup : undefined,
                });
            });
            if (this.isPopup) {
                var displayValue = this.formatDisplayValue(popupValue);
                return (_jsxs(React.Fragment, { children: [displayValue ? (_jsx("div", __assign({ className: bem('control', [inputAlign, 'custom']) }, { children: displayValue }), void 0)) : (_jsx("input", { className: bem('control', [inputAlign, 'custom']), value: "", placeholder: readOnly ? '' : props.placeholder, readOnly: true }, void 0)), childrenWithProps] }, void 0));
            }
            else {
                return _jsx("div", __assign({ className: bem('control', [inputAlign, 'custom']) }, { children: childrenWithProps }), void 0);
            }
        }
        if (isInputType) {
            var inputProps = {
                value: isDef(value) ? value + '' : '',
                className: bem('control', inputAlign),
                name: name,
                disabled: props.disabled,
                readOnly: props.readOnly,
                placeholder: props.placeholder,
                onFocus: this.onFocus,
                onBlur: this.onBlur,
                onChange: this.onInputChange,
                onKeyDown: props.onInputKeyDown,
                ref: this.inputRef,
            };
            if (type === 'textarea') {
                return _jsx("textarea", __assign({ rows: 1 }, inputProps), void 0);
            }
            var inputType = type || 'text';
            var inputMode = void 0;
            // type="number" is weired in iOS, and can't prevent dot in Android
            // so use inputmode to set keyboard in mordern browers
            if (type === 'number') {
                inputType = 'text';
                inputMode = 'decimal';
            }
            else if (type === 'digit') {
                inputType = 'tel';
                inputMode = 'numeric';
            }
            return _jsx("input", __assign({ type: inputType, inputMode: inputMode, maxLength: +props.maxlength || undefined }, inputProps), void 0);
        }
        else if (type === 'checkbox') {
            return (_jsx("div", __assign({ className: bem('control', [inputAlign, 'custom']) }, { children: _jsx(Checkbox, { name: name, shape: "square", checked: !!value, onClick: this.onCheckboxClick }, void 0) }), void 0));
        }
        else if (type === 'switch') {
            return (_jsx("div", __assign({ className: bem('control', [inputAlign, 'custom']) }, { children: _jsx(Switch, { name: name, size: "20", on: !!value, onClick: this.onSwitchClick }, void 0) }), void 0));
        }
    };
    Field.prototype.genRightIcon = function () {
        var rightIcon = this.props.rightIcon;
        if (typeof rightIcon === 'string') {
            return _jsx(Icon, { name: rightIcon }, void 0);
        }
        else if (rightIcon) {
            return rightIcon;
        }
    };
    Field.prototype.genWordLimit = function () {
        var _a = this.props, showWordLimit = _a.showWordLimit, maxlength = _a.maxlength;
        var _b = this.state, isInputType = _b.isInputType, value = _b.value;
        if (isInputType && showWordLimit && maxlength) {
            var count = (value || '').toString().length;
            var full = count >= maxlength;
            return (_jsxs("div", __assign({ className: bem('word-limit') }, { children: [_jsx("span", __assign({ className: bem('word-num', { full: full }) }, { children: count }), void 0), "/", maxlength] }), void 0));
        }
    };
    Field.prototype.genMessage = function () {
        var _a = this.props, errorMessage = _a.errorMessage, errorMessageAlign = _a.errorMessageAlign;
        var validateMessage = this.state.validateMessage;
        var message = validateMessage || errorMessage;
        if (message) {
            return _jsx("div", __assign({ className: bem('error-message', errorMessageAlign) }, { children: message }), void 0);
        }
    };
    Field.prototype.render = function () {
        var _a;
        var props = this.props;
        var disabled = props.disabled, readOnly = props.readOnly, clearTrigger = props.clearTrigger, labelAlign = props.labelAlign, labelWidth = props.labelWidth, style = props.style, bodyStyle = props.bodyStyle;
        var input = this.genInput();
        var onClick = typeof props.onClick === 'function' ? props.onClick : this.isPopup ? this.onPopupControlClick : null;
        return (_jsxs(Cell, __assign({ label: props.label, title: props.title, icon: props.icon, center: props.center, border: props.border, required: props.required, className: clsx(bem({
                row: props.direction !== 'column',
                column: props.direction === 'column',
                error: this.showError,
                disabled: disabled,
                readonly: readOnly,
                'min-height': props.type === 'textarea' && !props.autosize,
            }), props.className), titleClassName: bem('title', (_a = {}, _a["" + labelAlign] = labelAlign, _a)), titleStyle: labelWidth ? { width: addUnit(labelWidth) } : undefined, valueClassName: bem('value'), onClick: (!disabled && !readOnly && onClick) || null, style: style }, { children: [_jsxs("div", __assign({ ref: this.bodyRef, className: bem('body'), style: bodyStyle }, { children: [input, this.showClear && (_jsx(Icon, { name: "clear", className: bem('clear'), onClick: this.isPopup || clearTrigger === 'always' ? this.clearInput : undefined, onTouchStart: !this.isPopup && clearTrigger === 'focus' ? this.clearInput : undefined }, void 0)), this.genRightIcon(), props.button && _jsx("div", __assign({ className: bem('button') }, { children: props.button }), void 0)] }), void 0), this.genWordLimit(), this.genMessage()] }), void 0));
    };
    Field.defaultProps = {
        clearTrigger: 'focus',
    };
    return Field;
}(React.PureComponent));
export { Field };
