import React from 'react';
import './index.scss';
export declare type ImgProps = {
    src: string;
    fit?: string;
    alt?: string;
    round?: boolean;
    width?: number | string;
    height?: number | string;
    radius?: number | string;
    className?: string;
    lazyLoad?: boolean;
    showError?: boolean;
    showLoading?: boolean;
    errorNode?: React.ReactNode;
    loadingNode?: React.ReactNode;
    errorIcon?: string;
    loadingIcon?: string;
    onClick?(event: React.MouseEvent): void;
};
declare type ImgState = {
    error: boolean;
    loading: boolean;
};
export declare class Img extends React.PureComponent<ImgProps, ImgState> {
    static defaultProps: {
        round: boolean;
        showError: boolean;
        showLoading: boolean;
        errorIcon: string;
        loadingIcon: string;
    };
    constructor(props: ImgProps);
    genImage(): JSX.Element;
    genPlaceholder(): JSX.Element;
    genStyle(): Record<string, string>;
    render(): JSX.Element;
}
export {};
