var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import clsx from 'clsx';
import { Icon } from '../icon';
import { isDef, addUnit } from '../utils';
import { createBEM } from '../utils/bem';
import './index.scss';
var bem = createBEM('pant-img');
var Img = /** @class */ (function (_super) {
    __extends(Img, _super);
    function Img(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            error: false,
            loading: true,
        };
        return _this;
    }
    Img.prototype.genImage = function () {
        var _this = this;
        var props = this.props;
        var imgData = {
            className: bem('img'),
            alt: props.alt,
            style: {
                objectFit: props.fit,
            },
        };
        if (this.state.error) {
            return;
        }
        if (props.lazyLoad) {
            // TODO
        }
        return (_jsx("img", __assign({ src: props.src, onLoad: function () { return _this.setState({ loading: false }); }, onError: function () { return _this.setState({ loading: false, error: true }); } }, imgData), void 0));
    };
    Img.prototype.genPlaceholder = function () {
        var props = this.props;
        if (this.state.loading && props.showLoading) {
            return (_jsx("div", __assign({ className: bem('loading') }, { children: props.loadingNode || _jsx(Icon, { name: props.loadingIcon, className: bem('loading-icon') }, void 0) }), void 0));
        }
        if (this.state.error && props.showError) {
            return (_jsx("div", __assign({ className: bem('error') }, { children: props.errorNode || _jsx(Icon, { name: props.errorIcon, className: bem('error-icon') }, void 0) }), void 0));
        }
    };
    Img.prototype.genStyle = function () {
        var props = this.props;
        var style = {};
        if (isDef(props.width)) {
            style.width = addUnit(props.width);
        }
        if (isDef(props.height)) {
            style.height = addUnit(props.height);
        }
        if (isDef(props.radius)) {
            style.overflow = 'hidden';
            style.borderRadius = addUnit(props.radius);
        }
        return style;
    };
    Img.prototype.render = function () {
        var props = this.props;
        return (_jsxs("div", __assign({ className: clsx(bem({ round: props.round }), props.className), style: this.genStyle(), onClick: this.props.onClick }, { children: [this.genImage(), this.genPlaceholder()] }), void 0));
    };
    Img.defaultProps = {
        round: false,
        showError: true,
        showLoading: true,
        errorIcon: 'warning-o',
        loadingIcon: 'photo-o',
    };
    return Img;
}(React.PureComponent));
export { Img };
