var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import React from 'react';
import clsx from 'clsx';
import { addUnit } from '../utils';
import { createBEM } from '../utils/bem';
import { getVisibleHeight, getVisibleTop, getVisibleBottom } from '../utils/scroll';
var bem = createBEM('pant-lazyload');
var Lazyload = /** @class */ (function (_super) {
    __extends(Lazyload, _super);
    function Lazyload() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            loaded: false,
        };
        _this.placeholder = null;
        _this.bindedSetPlaceholder = _this.setPlaceholder.bind(_this);
        _this.bindedOnScroll = _this.onScroll.bind(_this);
        return _this;
    }
    Lazyload.prototype.setPlaceholder = function (el) {
        this.placeholder = el;
    };
    Lazyload.prototype.onScroll = function () {
        var _a = this.props, preloadOffset = _a.preloadOffset, scroller = _a.scroller;
        var placeholder = this.placeholder;
        var isWindowScroller = window === scroller;
        var scrollerTop = isWindowScroller ? 0 : getVisibleTop(scroller);
        var scrollerBottom = isWindowScroller ? getVisibleHeight(window) : getVisibleBottom(scroller);
        var placeholderTop = getVisibleTop(placeholder) - preloadOffset;
        var placeholderBottom = getVisibleBottom(placeholder) + preloadOffset;
        if ((placeholderTop >= scrollerTop && placeholderTop <= scrollerBottom) ||
            (placeholderBottom >= scrollerTop && placeholderBottom <= scrollerBottom) ||
            (placeholderTop <= scrollerTop && placeholderBottom >= scrollerBottom)) {
            scroller.removeEventListener('scroll', this.bindedOnScroll);
            this.setState({ loaded: true });
        }
    };
    Lazyload.prototype.componentDidMount = function () {
        this.props.scroller.addEventListener('scroll', this.bindedOnScroll, { passive: true });
        this.onScroll();
    };
    Lazyload.prototype.componentWillUnmount = function () {
        this.props.scroller.removeEventListener('scroll', this.bindedOnScroll);
    };
    Lazyload.prototype.render = function () {
        var props = this.props;
        if (this.state.loaded) {
            return _jsx(React.Fragment, { children: props.children }, void 0);
        }
        var style = __assign(__assign({}, props.style), { width: addUnit(props.width), height: addUnit(props.height) });
        if (props.inline) {
            style.display = 'inline-block';
        }
        return _jsx("div", { ref: this.bindedSetPlaceholder, className: clsx(bem(), props.className), style: style }, void 0);
    };
    Lazyload.defaultProps = {
        preloadOffset: 0,
        scroller: window,
    };
    return Lazyload;
}(React.PureComponent));
export { Lazyload };
