import React from 'react';
import './index.scss';
declare type ListDirection = 'up' | 'down';
export declare type ListLoadResult = {
    finished?: boolean;
    error?: boolean;
    errorText?: string;
    errorNode?: React.ReactNode;
};
export declare type ListProps = {
    direction?: ListDirection;
    offset?: number | string;
    loadingText?: string;
    finishedText?: string;
    errorText?: string;
    loadingNode?: React.ReactNode;
    finishedNode?: React.ReactNode;
    errorNode?: React.ReactNode;
    onLoad(error?: boolean): Promise<ListLoadResult | void>;
};
declare type ListState = {
    loading: boolean;
    loadResult: ListLoadResult;
};
export declare class List extends React.PureComponent<ListProps, ListState> {
    static defaultProps: {
        direction: string;
        offset: number;
    };
    private containerRef;
    private placeholderRef;
    private scroller;
    constructor(props: ListProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    reset(callback?: () => void): void;
    check(): void;
    private load;
    private genLoading;
    private genFinishedText;
    private genErrorText;
    private onClickError;
    render(): JSX.Element;
}
export {};
