var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import clsx from 'clsx';
import { addUnit } from '../utils';
import { createBEM } from '../utils/bem';
import './index.scss';
var bem = createBEM('pant-loading');
var LoadingIcon = function (props) {
    if (props.type === 'spinner') {
        var Spin = [];
        for (var i = 0; i < 12; i++) {
            Spin.push(_jsx("i", {}, i));
        }
        return _jsx(React.Fragment, { children: Spin }, void 0);
    }
    return (_jsx("svg", __assign({ className: bem('circular'), viewBox: "25 25 50 50" }, { children: _jsx("circle", { cx: "50", cy: "50", r: "20", fill: "none" }, void 0) }), void 0));
};
var LoadingText = function (props) {
    var children = props.children;
    if (children) {
        var style = props.textSize && {
            fontSize: addUnit(props.textSize),
        };
        return (_jsx("span", __assign({ className: bem('text'), style: style }, { children: children }), void 0));
    }
    return null;
};
export var Loading = function (props) {
    var color = props.color, size = props.size, type = props.type;
    var style = { color: color };
    if (size) {
        var iconSize = addUnit(size);
        style.width = iconSize;
        style.height = iconSize;
    }
    return (_jsxs("div", __assign({ className: clsx(bem([type, { vertical: props.vertical }]), props.className) }, { children: [_jsx("span", __assign({ className: bem('spinner', type), style: style }, { children: _jsx(LoadingIcon, __assign({}, props), void 0) }), void 0),
            _jsx(LoadingText, __assign({}, props), void 0)] }), void 0));
};
Loading.defaultProps = {
    type: 'circular',
};
