var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import React from 'react';
import { createBEM } from '../utils/bem';
import { DeleteIcon } from './delete-icon';
import { CollapseIcon } from './collapse-icon';
import { TouchHandler } from '../utils/touch-handler';
import './index.scss';
var bem = createBEM('pant-key');
var Key = /** @class */ (function (_super) {
    __extends(Key, _super);
    function Key(props) {
        var _this = _super.call(this, props) || this;
        _this.elRef = React.createRef();
        _this.state = {
            active: false,
        };
        return _this;
    }
    Key.prototype.componentDidMount = function () {
        this.touchHandler = new TouchHandler(this.elRef.current, {
            onTouchStart: this.onTouchStart.bind(this),
            onTouchMove: this.onTouchMove.bind(this),
            onTouchEnd: this.onTouchEnd.bind(this),
        });
    };
    Key.prototype.componentWillUnmount = function () {
        this.touchHandler.destroy();
        this.touchHandler = null;
    };
    Key.prototype.onTouchStart = function (event) {
        // compatible with Vue 2.6 event bubble bug
        event.stopPropagation();
        this.setState({
            active: true,
        });
    };
    Key.prototype.onTouchMove = function () {
        if (this.touchHandler.state.direction) {
            this.setState({
                active: false,
            });
        }
    };
    Key.prototype.onTouchEnd = function () {
        var _a = this.props, text = _a.text, type = _a.type;
        if (this.state.active) {
            // eliminate tap delay on safari
            event.preventDefault();
            this.setState({
                active: false,
            });
            this.props.onPress && this.props.onPress(text, type);
        }
    };
    Key.prototype.genContent = function () {
        var _a = this.props, type = _a.type, text = _a.text;
        var isExtra = type === 'extra';
        var isDelete = type === 'delete';
        if (isDelete) {
            return text || _jsx(DeleteIcon, { className: bem('delete-icon') }, void 0);
        }
        if (isExtra) {
            return text || _jsx(CollapseIcon, { className: bem('collapse-icon') }, void 0);
        }
        return text;
    };
    Key.prototype.render = function () {
        var _a = this.props, wider = _a.wider, color = _a.color, large = _a.large, type = _a.type;
        var active = this.state.active;
        return (_jsx("div", __assign({ ref: this.elRef, className: bem('wrapper', { wider: wider }) }, { children: _jsx("div", __assign({ role: "button", className: bem([
                    color,
                    {
                        large: large,
                        active: active,
                        delete: type === 'delete',
                    },
                ]) }, { children: this.genContent() }), void 0) }), void 0));
    };
    return Key;
}(React.PureComponent));
export { Key };
