var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useRef, useCallback } from 'react';
import clsx from 'clsx';
import { Transition } from '../transition';
import { createBEM } from '../utils/bem';
import { addClass, removeClass } from '../utils/dom';
import { pantConfig } from '../';
import './index.scss';
var bem = createBEM('pant-overlay');
var count = 1;
export var Overlay = function (props) {
    var countRef = useRef();
    if (!countRef.current) {
        countRef.current = count++;
    }
    var style = __assign(__assign({ backgroundColor: pantConfig('defaultOverlayBgColor') }, props.style), { zIndex: props.zIndex });
    if (props.duration > 0) {
        style.animationDuration = props.duration + "s";
    }
    useEffect(function () {
        if (props.lockScroll) {
            return function () { return removeClass(document.body, "pant-overflow-hidden-" + countRef.current); };
        }
    }, []);
    var onAfterEnter = useCallback(function () {
        props.lockScroll && addClass(document.body, "pant-overflow-hidden-" + countRef.current);
        props.onAfterEnter && props.onAfterEnter();
    }, [props.onAfterEnter]);
    var onAfterLeave = useCallback(function () {
        props.lockScroll && removeClass(document.body, "pant-overflow-hidden-" + countRef.current);
        props.onAfterLeave && props.onAfterLeave();
    }, [props.onAfterLeave]);
    return (_jsx(Transition, __assign({ name: "fade", stage: props.show ? 'enter' : 'leave', onAfterEnter: onAfterEnter, onAfterLeave: onAfterLeave }, { children: _jsx("div", __assign({ style: style, className: clsx(bem(), props.className), onClick: props.onClick }, { children: props.children }), void 0) }), void 0));
};
Overlay.defaultProps = {
    lockScroll: true,
};
