var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import clsx from 'clsx';
import { get } from 'lodash-es';
import { removeUnit } from '../utils';
import { BORDER_UNSET_TOP_BOTTOM } from '../utils/constant';
import { createBEM } from '../utils/bem';
import { i18n } from '../locale';
import { DEFAULT_ITEM_HEIGHT } from './constant';
import { PickerColumn } from './picker-column';
import { Loading } from '../loading';
import './index.scss';
var bem = createBEM('pant-picker');
// 生成formattedColumns
var getFormatted = function (columns, valueKey, labelKey, pickerValue, cols, cascade) {
    var formatted = [];
    var filter = __spreadArray([], columns);
    // 多列非联动，columns类型为ColumnItem[][]
    if (cols > 1 && !cascade) {
        var _loop_1 = function (i) {
            if (filter[i] && filter[i].length) {
                var options_1 = [];
                filter[i].forEach(function (item) {
                    if (typeof item === 'string') {
                        options_1.push({
                            value: item,
                            label: item,
                        });
                    }
                    else {
                        var value = get(item, valueKey, '') + '';
                        options_1.push({
                            value: value,
                            label: get(item, labelKey, value),
                        });
                    }
                });
                formatted.push(options_1);
            }
            else {
                formatted.push([]);
            }
        };
        for (var i = 0; i < cols; i++) {
            _loop_1(i);
        }
        return formatted;
    }
    var _loop_2 = function (i) {
        if (filter.length) {
            var options_2 = [];
            filter.forEach(function (item) {
                if (typeof item === 'string') {
                    options_2.push({
                        value: item,
                        label: item,
                    });
                }
                else {
                    var value = get(item, valueKey, '') + '';
                    options_2.push({
                        value: value,
                        label: get(item, labelKey, value),
                    });
                }
            });
            formatted.push(options_2);
            if (i === cols - 1) {
                return "break";
            }
            // 当某一列的pickerValue为空时，默认展示pickerValue为0时的数据
            if (pickerValue[i] === undefined) {
                filter = filter[0].children || [];
            }
            else {
                // 当存在item.value === pickerValue[i]时，展示该数据下的children；当不存在时，filter=[]
                filter = filter.filter(function (item) { return item.value === pickerValue[i]; });
                if (filter.length !== 0) {
                    filter = filter[0].children || [];
                }
            }
        }
        else {
            formatted.push([]);
        }
    };
    // 单列或多列联动，columns类型为ColumnItem[]
    for (var i = 0; i < cols; i++) {
        var state_1 = _loop_2(i);
        if (state_1 === "break")
            break;
    }
    return formatted;
};
var Picker = /** @class */ (function (_super) {
    __extends(Picker, _super);
    function Picker(props) {
        var _this = _super.call(this, props) || this;
        _this.priChildren = [];
        var defaultValue = typeof props.defaultValue === 'string'
            ? props.defaultValue
                ? [props.defaultValue]
                : undefined
            : props.defaultValue;
        _this.state = {
            formattedColumns: [],
            children: [],
            prevColumns: [],
            pickerValue: defaultValue || [],
        };
        _this.injectChildren = _this.injectChildren.bind(_this);
        _this.onCancel = _this.onCancel.bind(_this);
        _this.onConfirm = _this.onConfirm.bind(_this);
        return _this;
    }
    Picker.getDerivedStateFromProps = function (nextProps, state) {
        var valueKey = nextProps.valueKey, columns = nextProps.columns, labelKey = nextProps.labelKey, cols = nextProps.cols, cascade = nextProps.cascade;
        var prevColumns = state.prevColumns;
        if (columns !== prevColumns) {
            var defaultValue = typeof nextProps.defaultValue === 'string'
                ? nextProps.defaultValue
                    ? [nextProps.defaultValue]
                    : undefined
                : nextProps.defaultValue;
            var newPickerValue = defaultValue || [];
            var formattedColumns = getFormatted(columns, valueKey, labelKey, newPickerValue, cols, cascade);
            return __assign(__assign({}, state), { pickerValue: newPickerValue, formattedColumns: formattedColumns, prevColumns: columns });
        }
        else {
            return null;
        }
    };
    // 将pickerColumn实例注入到state.children
    Picker.prototype.injectChildren = function (children) {
        this.priChildren.push(children);
        if (this.state.children.length < this.priChildren.length) {
            this.setState({ children: this.priChildren });
        }
    };
    Picker.prototype.itemPxHeight = function () {
        var itemHeight = this.props.itemHeight;
        return itemHeight ? removeUnit(itemHeight) : DEFAULT_ITEM_HEIGHT;
    };
    Picker.prototype.genToolbar = function () {
        var props = this.props;
        if (props.showToolbar) {
            return (_jsx("div", __assign({ className: bem('toolbar') }, { children: [
                    _jsx("button", __assign({ type: "button", className: bem('cancel'), onClick: this.onCancel }, { children: props.cancelButtonText || i18n().cancel }), "cancel"),
                    _jsx("div", __assign({ className: clsx(bem('title'), 'pant-ellipsis') }, { children: props.title }), "title"),
                    _jsx("button", __assign({ type: "button", className: bem('confirm'), onClick: this.onConfirm }, { children: props.confirmButtonText || i18n().confirm }), "confirm"),
                ] }), void 0));
        }
    };
    Picker.prototype.onCascadeChange = function (selectedIndex, columnIndex) {
        var _a = this.state, formattedColumns = _a.formattedColumns, pickerValue = _a.pickerValue;
        var _b = this.props, valueKey = _b.valueKey, columns = _b.columns, cols = _b.cols, labelKey = _b.labelKey, cascade = _b.cascade, onChange = _b.onChange;
        var newPickerValue = [];
        for (var i = 0; i < columnIndex; i++) {
            if (typeof pickerValue[i] === 'undefined') {
                newPickerValue[i] = formattedColumns[i][0].value;
            }
            else {
                newPickerValue[i] = pickerValue[i];
            }
        }
        newPickerValue[columnIndex] = formattedColumns[columnIndex][selectedIndex].value;
        var newFormattedColumns = getFormatted(columns, valueKey, labelKey, newPickerValue, cols, cascade);
        for (var i = columnIndex + 1; i < cols; i++) {
            newPickerValue[i] = newFormattedColumns[i][0] && newFormattedColumns[i][0].value;
        }
        this.setState({ formattedColumns: newFormattedColumns, pickerValue: newPickerValue }, function () {
            onChange && onChange(cols === 1 ? newPickerValue[0] : newPickerValue);
        });
    };
    Picker.prototype.onChange = function (selectedIndex, columnIndex) {
        var _a = this.props, cascade = _a.cascade, cols = _a.cols, onChange = _a.onChange;
        var _b = this.state, formattedColumns = _b.formattedColumns, pickerValue = _b.pickerValue;
        if (cascade) {
            this.onCascadeChange(selectedIndex, columnIndex);
        }
        else {
            var newPickerValue_1 = formattedColumns.map(function (column, i) {
                if (i === columnIndex) {
                    return column[selectedIndex].value;
                }
                if (typeof pickerValue[i] === 'undefined') {
                    return column[0].value;
                }
                return pickerValue[i];
            });
            this.setState({ pickerValue: newPickerValue_1 }, function () {
                onChange && onChange(cols === 1 ? newPickerValue_1[0] : newPickerValue_1);
            });
        }
    };
    Picker.prototype.getValue = function () {
        var cols = this.props.cols;
        var pickerValue = this.state.pickerValue;
        if (cols === 1) {
            return pickerValue[0];
        }
        return __spreadArray([], pickerValue);
    };
    Picker.prototype.clearValue = function (cb) {
        this.setState({ pickerValue: [] }, cb);
    };
    Picker.prototype.onConfirm = function () {
        var _this = this;
        this.state.children.forEach(function (child) { return child.stopMomentum(); });
        var newPickerValue = __spreadArray([], this.state.pickerValue);
        this.state.formattedColumns.forEach(function (item, index) {
            if (item && item.length) {
                if (typeof newPickerValue[index] === 'undefined') {
                    newPickerValue[index] = item[0].value;
                }
            }
        });
        this.setState({ pickerValue: newPickerValue }, function () {
            _this.emit('onConfirm');
            var closePopup = _this.props.closePopup;
            closePopup && closePopup(true);
        });
    };
    Picker.prototype.onCancel = function () {
        this.emit('onCancel');
        var closePopup = this.props.closePopup;
        closePopup && closePopup();
    };
    Picker.prototype.emit = function (event) {
        var cols = this.props.cols;
        var newPickerValue = __spreadArray([], this.state.pickerValue);
        // 单列时，value返回string
        if (cols === 1) {
            newPickerValue = newPickerValue[0];
        }
        if (this.props[event]) {
            this.props[event](newPickerValue);
        }
    };
    Picker.prototype.genColumns = function () {
        var props = this.props;
        var itemPxHeight = this.itemPxHeight();
        var wrapHeight = itemPxHeight * props.visibleItemCount;
        var frameStyle = { height: itemPxHeight + "px" };
        var columnsStyle = { height: wrapHeight + "px" };
        var maskStyle = {
            backgroundSize: "100% " + (wrapHeight - itemPxHeight) / 2 + "px",
        };
        return (_jsxs("div", __assign({ className: bem('columns'), style: columnsStyle }, { children: [this.genColumnItems(), _jsx("div", { className: bem('mask'), style: maskStyle }, void 0),
                _jsx("div", { className: clsx(bem('frame'), BORDER_UNSET_TOP_BOTTOM), style: frameStyle }, void 0)] }), void 0));
    };
    Picker.prototype.genColumnItems = function () {
        var _this = this;
        var _a = this.props, columnClassName = _a.columnClassName, swipeDuration = _a.swipeDuration, disabledValue = _a.disabledValue, visibleItemCount = _a.visibleItemCount;
        var _b = this.state, pickerValue = _b.pickerValue, formattedColumns = _b.formattedColumns;
        return formattedColumns.map(function (item, columnIndex) { return (_jsx(PickerColumn, { value: pickerValue[columnIndex] || (item[0] && item[0].value), disabledValue: disabledValue && disabledValue[columnIndex], className: columnClassName, itemHeight: _this.itemPxHeight(), swipeDuration: swipeDuration, visibleItemCount: visibleItemCount, options: item, onChange: function (selectedIndex) {
                _this.onChange(selectedIndex, columnIndex);
            }, injectChildren: _this.injectChildren }, columnIndex)); });
    };
    Picker.prototype.render = function () {
        var props = this.props;
        return (_jsxs("div", __assign({ className: bem() }, { children: [props.toolbarPosition === 'top' ? this.genToolbar() : null, props.loading ? _jsx(Loading, { className: bem('loading') }, void 0) : null, this.genColumns(), props.toolbarPosition === 'bottom' ? this.genToolbar() : null] }), void 0));
    };
    Picker.defaultProps = {
        showToolbar: true,
        toolbarPosition: 'top',
        itemHeight: 44,
        visibleItemCount: 6,
        valueKey: 'value',
        labelKey: 'label',
        swipeDuration: 1000,
        loading: false,
        cols: 1,
        cascade: false,
    };
    return Picker;
}(React.PureComponent));
export { Picker };
