import React from 'react';
import './index.scss';
export declare type PullRefreshProps = {
    disabled?: boolean;
    successText?: string;
    pullingText?: string;
    loosingText?: string;
    loadingText?: string;
    successNode?: React.ReactNode;
    pullingNode?: JSX.Element;
    loosingNode?: React.ReactNode;
    loadingNode?: React.ReactNode;
    successDuration?: number | string;
    animationDuration?: number | string;
    headHeight?: number | string;
    onRefresh?(): Promise<void>;
};
declare type PullRefreshStatus = 'normal' | 'pulling' | 'loosing' | 'loading' | 'success';
declare type PullRefreshState = {
    status: PullRefreshStatus;
    distance: number;
};
export declare class PullRefresh extends React.PureComponent<PullRefreshProps, PullRefreshState> {
    static defaultProps: {
        successDuration: number;
        animationDuration: number;
        headHeight: number;
    };
    private containerRef;
    private ceiling;
    private scroller;
    private touchHandler;
    constructor(props: PullRefreshProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    private get touchable();
    private checkPullStart;
    private onBeforeTouchStart;
    private onBeforeTouchMove;
    private onTouchMove;
    private onTouchEnd;
    private ease;
    private setStatus;
    private genStatus;
    render(): JSX.Element;
}
export {};
