var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useRef } from 'react';
import { Field } from '../field';
import { i18n } from '../locale';
import { createBEM } from '../utils/bem';
import './index.scss';
var bem = createBEM('pant-search');
export var Search = function (props) {
    var fieldRef = useRef();
    function Label() {
        if (props.label) {
            return _jsx("div", __assign({ className: bem('label') }, { children: props.label }), void 0);
        }
    }
    function Action() {
        if (!props.showAction) {
            return;
        }
        function onSearch() {
            if (props.disabled) {
                return;
            }
            props.onSearch && props.onSearch(fieldRef.current.getValue());
        }
        if (props.actionNode) {
            return (_jsx("div", __assign({ className: bem('custom-action'), onClick: onSearch }, { children: props.actionNode }), void 0));
        }
        return (_jsx("div", __assign({ className: bem('action', { disabled: props.disabled }), role: "button", tabIndex: 0, onClick: onSearch }, { children: props.actionText || i18n().search }), void 0));
    }
    return (_jsxs("div", __assign({ className: bem({ 'show-action': props.showAction }), style: { background: props.background } }, { children: [_jsxs("div", __assign({ className: bem('content', props.shape) }, { children: [Label(), _jsx(Field, { ref: fieldRef, name: "search", type: "search", border: false, placeholder: props.placeholder, inputAlign: props.inputAlign, disabled: props.disabled, defaultValue: props.defaultValue, icon: props.icon || undefined, clearable: props.clearable, clearTrigger: props.clearTrigger, onChange: props.onChange }, void 0)] }), void 0), Action()] }), void 0));
};
Search.defaultProps = {
    shape: 'sqaure',
    icon: 'search',
    clearable: true,
};
