var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { addUnit } from '../utils';
import { createBEM } from '../utils/bem';
import './index.scss';
var DEFAULT_ROW_WIDTH = '100%';
var DEFAULT_LAST_ROW_WIDTH = '60%';
var bem = createBEM('pant-skeleton');
export var Skeleton = function (props) {
    if (!props.loading) {
        return _jsx(React.Fragment, { children: props.children }, void 0);
    }
    function Title() {
        if (props.title) {
            return _jsx("h3", { className: bem('title'), style: { width: addUnit(props.titleWidth) } }, void 0);
        }
    }
    function Rows() {
        var Rows = [];
        var rowWidth = props.rowWidth;
        function getRowWidth(index) {
            if (rowWidth === DEFAULT_ROW_WIDTH && index === +props.row - 1) {
                return DEFAULT_LAST_ROW_WIDTH;
            }
            if (Array.isArray(rowWidth)) {
                return rowWidth[index];
            }
            return rowWidth;
        }
        for (var i = 0; i < props.row; i++) {
            Rows.push(_jsx("div", { className: bem('row'), style: { width: addUnit(getRowWidth(i)) } }, i));
        }
        return Rows;
    }
    function Avatar() {
        if (props.avatar) {
            var size = addUnit(props.avatarSize);
            return _jsx("div", { className: bem('avatar', props.avatarShape), style: { width: size, height: size } }, void 0);
        }
    }
    return (_jsxs("div", __assign({ className: bem({ animate: props.animate }) }, { children: [Avatar(), _jsxs("div", __assign({ className: bem('content') }, { children: [Title(), Rows()] }), void 0)] }), void 0));
};
Skeleton.defaultProps = {
    row: 0,
    loading: true,
    animate: true,
    avatarSize: '32px',
    avatarShape: 'round',
    titleWidth: '40%',
    rowWidth: DEFAULT_ROW_WIDTH,
};
