import React from 'react';
import { ScrollElement } from '../utils/scroll';
import './index.scss';
export declare type StickyProps = {
    keepWidth?: boolean;
    zIndex?: number | string;
    offsetTop?: number | string;
    offsetBottom?: number | string;
    stickBottom?: boolean;
    container?: React.RefObject<HTMLElement>;
    scroller?: ScrollElement;
};
declare type StickyState = {
    fixed: boolean;
    height: number;
    left: number;
    width: number;
    transform: number;
};
export declare class Sticky extends React.PureComponent<StickyProps, StickyState> {
    static defaultProps: {
        keepWidth: boolean;
        offsetTop: number;
        offsetBottom: number;
    };
    private domRef;
    private bindedOnScroll;
    private bindedOnRootScroll;
    private scroller;
    private toRef;
    state: {
        fixed: boolean;
        height: number;
        left: number;
        width: number;
        transform: number;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    private getStyle;
    get fixed(): boolean;
    stick(isRootScroll?: boolean): void;
    stickBottom(isRootScroll?: boolean): void;
    onScroll(_: Event, isRootScroll?: boolean): void;
    onRootScroll(evt?: Event): void;
    render(): JSX.Element;
}
export {};
