var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Icon } from '../icon';
import { Button } from '../button';
import { i18n } from '../locale';
import { createBEM } from '../utils/bem';
import './index.scss';
var bem = createBEM('pant-submit-bar');
export var SubmitBar = function (props) {
    var tip = props.tip, price = props.price, tipIcon = props.tipIcon;
    function Text() {
        if (typeof price === 'number') {
            var priceArr = (price / 100).toFixed(props.decimalLength).split('.');
            var decimalStr = props.decimalLength ? "." + priceArr[1] : '';
            return (_jsxs("div", __assign({ style: { textAlign: props.textAlign ? props.textAlign : undefined }, className: bem('text') }, { children: [_jsx("span", { children: props.label }, void 0),
                    _jsxs("span", __assign({ className: bem('price') }, { children: [props.currency, _jsx("span", __assign({ className: bem('price', 'integer') }, { children: priceArr[0] }), void 0), decimalStr] }), void 0),
                    props.suffixLabel && _jsx("span", __assign({ className: bem('suffix-label') }, { children: props.suffixLabel }), void 0)] }), void 0));
        }
    }
    function Tip() {
        if (props.tip || props.tipNode) {
            return (_jsxs("div", __assign({ className: bem('tip') }, { children: [tipIcon && _jsx(Icon, { className: bem('tip-icon'), name: tipIcon }, void 0),
                    tip && _jsx("span", __assign({ className: bem('tip-text') }, { children: tip }), void 0), props.tipNode] }), void 0));
        }
    }
    return (_jsxs("div", __assign({ className: bem({ 'safe-area-inset-bottom': props.safeAreaInsetBottom }) }, { children: [props.topNode, Tip(), _jsxs("div", __assign({ className: bem('bar') }, { children: [props.children, Text(), _jsx(Button, { round: true, className: bem('button', props.buttonType), type: props.buttonType, loading: props.loading, disabled: props.disabled, text: props.loading ? '' : props.buttonText || i18n().submit, onClick: props.onSubmit }, void 0)] }), void 0)] }), void 0));
};
SubmitBar.defaultProps = {
    decimalLength: 2,
    currency: '¥',
    buttonType: 'danger',
};
