var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import { Loading } from '../loading';
import { addUnit } from '../utils';
import { createBEM } from '../utils/bem';
import { BLUE } from '../utils/constant';
import './index.scss';
var bem = createBEM('pant-switch');
export var Switch = function (props) {
    var on = props.on, loading = props.loading, disabled = props.disabled;
    var style = __assign(__assign({}, props.style), { fontSize: addUnit(props.size), backgroundColor: on ? props.activeColor : props.inactiveColor });
    function onClick(event) {
        if (loading || disabled) {
            return;
        }
        props.onClick && props.onClick(event, props);
    }
    function genLoading() {
        if (props.loading) {
            var color = on ? props.activeColor || BLUE : props.inactiveColor || '';
            return _jsx(Loading, { className: bem('loading'), color: color }, void 0);
        }
    }
    return (_jsx("div", __assign({ className: bem({
            on: on,
            loading: loading,
            disabled: disabled,
        }), role: "switch", style: style, "aria-checked": !!on, onClick: onClick }, { children: _jsx("div", __assign({ className: bem('node') }, { children: genLoading() }), void 0) }), void 0));
};
