import React from 'react';
import { TitleParentProps } from './title';
import './index.scss';
export declare type TabsProps = TitleParentProps & {
    activeIndex?: number | string;
    activeName?: string;
    bordered?: boolean;
    animated?: boolean;
    swipeable?: boolean;
    sticky?: boolean;
    scrollspy?: boolean;
    duration?: number | string;
    lineHeight?: number | string;
    lineWidth?: number | string;
    background?: string;
    navLeft?: React.ReactNode;
    navRight?: React.ReactNode;
    onClick?(event: Event, info: TabInfo): void;
    onBeforeChange?(info: TabInfo): Promise<boolean>;
};
declare type TabsState = {
    activeIndex: number;
};
export declare type TabInfo = {
    index: number;
    title: string;
    name?: string;
    disabled?: boolean;
};
export declare class Tabs extends React.PureComponent<TabsProps, TabsState> {
    static defaultProps: {
        type: string;
        bordered: boolean;
        activeIndex: number;
        duration: number;
    };
    private containerRef;
    private tabListRef;
    private contentRef;
    private lineRef;
    private stickyRef;
    private touchHandler;
    private scroller;
    private bindedOnScroll;
    private lockScroll;
    private tabHeight;
    constructor(props: React.PropsWithChildren<TabsProps>);
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    private getCurrentIndexOnScroll;
    private onScroll;
    private onTouchEnd;
    private scrollIntoView;
    private updateLine;
    private setActiveIndex;
    private scrollToContent;
    private onTitleClick;
    private genNavs;
    private warpAnimatedContents;
    private genContents;
    render(): JSX.Element;
}
export {};
