var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import clsx from 'clsx';
import { createBEM } from '../utils/bem';
import { BORDER_TOP_BOTTOM } from '../utils/constant';
import { scrollLeftTo, scrollTopTo, setRootScrollTop, getElementTop, getVisibleTop, getScroller, getVisibleHeight, } from '../utils/scroll';
import { isDef, addUnit } from '../utils';
import { on, off } from '../utils/event';
import { TouchHandler } from '../utils/touch-handler';
import { Sticky } from '../sticky';
import { Title } from './title';
import './index.scss';
var MIN_SWIPE_DISTANCE = 50;
var bem = createBEM('pant-tabs');
var Tabs = /** @class */ (function (_super) {
    __extends(Tabs, _super);
    function Tabs(props) {
        var _this = _super.call(this, props) || this;
        _this.containerRef = React.createRef();
        _this.tabListRef = React.createRef();
        _this.contentRef = React.createRef();
        _this.lineRef = React.createRef();
        _this.stickyRef = React.createRef();
        _this.bindedOnScroll = _this.onScroll.bind(_this);
        var activeName = props.activeName, children = props.children;
        var activeIndex;
        if (activeName) {
            activeIndex = [].concat(children).findIndex(function (item) { return item.props.name === activeName; });
        }
        else {
            activeIndex = +props.activeIndex;
        }
        _this.state = {
            activeIndex: activeIndex >= 0 ? activeIndex : 0,
        };
        return _this;
    }
    Tabs.prototype.componentDidMount = function () {
        var _a = this.props, activeName = _a.activeName, children = _a.children, swipeable = _a.swipeable, scrollspy = _a.scrollspy;
        this.tabHeight = getVisibleHeight(this.tabListRef.current.parentNode);
        if (activeName) {
            var activeIndex = [].concat(children).findIndex(function (item) { return item.props.name === activeName; });
            if (activeIndex >= 0) {
                this.setState({ activeIndex: activeIndex });
            }
        }
        this.updateLine(true);
        this.scrollIntoView(true);
        if (swipeable) {
            this.touchHandler = new TouchHandler(this.contentRef.current, { onTouchEnd: this.onTouchEnd.bind(this) });
        }
        if (scrollspy) {
            this.scroller = getScroller(this.containerRef.current);
            on(this.scroller, 'scroll', this.bindedOnScroll);
            this.onScroll();
        }
    };
    Tabs.prototype.componentDidUpdate = function () {
        this.updateLine();
        this.scrollIntoView();
    };
    Tabs.prototype.componentWillUnmount = function () {
        if (this.props.swipeable) {
            this.touchHandler.destroy();
            this.touchHandler = null;
        }
        if (this.scroller) {
            off(this.scroller, 'scroll', this.bindedOnScroll);
            this.scroller = null;
        }
    };
    Tabs.prototype.getCurrentIndexOnScroll = function () {
        var children = this.containerRef.current.querySelectorAll('.pant-tabs__pane');
        for (var index = 0; index < children.length; index++) {
            var top_1 = getVisibleTop(children[index]);
            var scrollOffset = this.props.sticky ? this.tabHeight : 0;
            if (top_1 > scrollOffset) {
                return index === 0 ? 0 : index - 1;
            }
        }
        return children.length - 1;
    };
    Tabs.prototype.onScroll = function () {
        if (this.props.scrollspy && !this.lockScroll) {
            var index = this.getCurrentIndexOnScroll();
            this.setActiveIndex(index);
        }
    };
    Tabs.prototype.onTouchEnd = function () {
        var activeIndex = this.state.activeIndex;
        var _a = this.touchHandler.state, direction = _a.direction, offsetX = _a.offsetX, deltaX = _a.deltaX;
        if (direction === 'horizontal' && offsetX >= MIN_SWIPE_DISTANCE) {
            if (deltaX > 0 && activeIndex !== 0) {
                this.setActiveIndex(activeIndex - 1);
            }
            else if (deltaX < 0 && activeIndex !== [].concat(this.props.children).length - 1) {
                this.setActiveIndex(activeIndex + 1);
            }
        }
    };
    Tabs.prototype.scrollIntoView = function (immediate) {
        var _a = this.props, type = _a.type, scrollable = _a.scrollable, duration = _a.duration;
        if (type !== 'line' || !scrollable) {
            return;
        }
        var tabListEl = this.tabListRef.current;
        var activeTitleEl = tabListEl.querySelector('.pant-tab--active');
        if (!activeTitleEl) {
            return;
        }
        var to = activeTitleEl.offsetLeft - (tabListEl.offsetWidth - activeTitleEl.offsetWidth) / 2;
        scrollLeftTo(tabListEl, to, immediate ? 0 : +duration);
    };
    Tabs.prototype.updateLine = function (immediate) {
        var _a = this.props, type = _a.type, lineWidth = _a.lineWidth, lineHeight = _a.lineHeight, duration = _a.duration;
        if (type !== 'line') {
            return;
        }
        var lineEl = this.lineRef.current;
        var activeTitleEl = this.tabListRef.current.querySelector('.pant-tab--active');
        if (!activeTitleEl) {
            return;
        }
        var width = isDef(lineWidth) ? lineWidth : activeTitleEl.offsetWidth / 2;
        var left = activeTitleEl.offsetLeft + activeTitleEl.offsetWidth / 2;
        lineEl.style.width = addUnit(width);
        lineEl.style.transform = "translateX(" + left + "px) translateX(-50%)";
        if (!immediate) {
            lineEl.style.transitionDuration = duration + "s";
        }
        if (isDef(lineHeight)) {
            var height = addUnit(lineHeight);
            lineEl.style.height = height;
            lineEl.style.borderRadius = height;
        }
    };
    Tabs.prototype.setActiveIndex = function (index) {
        var _this = this;
        if (this.state.activeIndex === index) {
            return;
        }
        this.setState({ activeIndex: index }, function () {
            var _a = _this.props, sticky = _a.sticky, scrollspy = _a.scrollspy;
            if (!scrollspy && sticky && _this.stickyRef.current.fixed) {
                setRootScrollTop(Math.ceil(getElementTop(_this.containerRef.current)));
            }
        });
    };
    Tabs.prototype.scrollToContent = function (index, immediate) {
        var _this = this;
        if (immediate === void 0) { immediate = false; }
        var _a = this.props, scrollspy = _a.scrollspy, sticky = _a.sticky, duration = _a.duration;
        if (scrollspy) {
            var el = this.containerRef.current.querySelectorAll('.pant-tabs__pane')[index];
            if (el) {
                var scrollOffset = sticky ? this.tabHeight : 0;
                var to = getElementTop(el, this.scroller) - scrollOffset;
                this.lockScroll = true;
                scrollTopTo(this.scroller, to, immediate ? 0 : +duration, function () {
                    _this.lockScroll = false;
                });
            }
        }
    };
    Tabs.prototype.onTitleClick = function (index, evt, props) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, onClick, onBeforeChange, tabInfo;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.props, onClick = _a.onClick, onBeforeChange = _a.onBeforeChange;
                        tabInfo = { index: index, title: props.title, name: props.name, disabled: props.disabled };
                        if (!!props.disabled) return [3 /*break*/, 4];
                        if (!onBeforeChange) return [3 /*break*/, 2];
                        return [4 /*yield*/, onBeforeChange(tabInfo)];
                    case 1:
                        if (_b.sent()) {
                            this.setActiveIndex(index);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        this.setActiveIndex(index);
                        _b.label = 3;
                    case 3:
                        this.scrollToContent(index);
                        _b.label = 4;
                    case 4:
                        onClick && onClick(evt, tabInfo);
                        return [2 /*return*/];
                }
            });
        });
    };
    Tabs.prototype.genNavs = function () {
        var _a;
        var _this = this;
        var props = this.props;
        var type = props.type, color = props.color, bordered = props.bordered, scrollable = props.scrollable, sticky = props.sticky, ellipsis = props.ellipsis, navLeft = props.navLeft, navRight = props.navRight;
        var navStyle = {
            borderColor: props.color,
            background: props.background,
        };
        var lineStyle = {
            backgroundColor: color,
        };
        var navs = [].concat(props.children).map(function (item, index) {
            var itemProps = item.props;
            return (_jsx(Title, { type: type, dot: itemProps.dot, info: itemProps.info, title: itemProps.title, titleNode: itemProps.titleNode, name: itemProps.name, color: color, isActive: index === _this.state.activeIndex, ellipsis: props.ellipsis, disabled: itemProps.disabled, scrollable: scrollable, activeColor: props.activeColor, inactiveColor: props.inactiveColor, swipeThreshold: props.swipeThreshold, onClick: _this.onTitleClick.bind(_this, index) }, index));
        });
        var wrap = (_jsx("div", __assign({ className: clsx(bem('wrap', { scrollable: scrollable }), (_a = {}, _a[BORDER_TOP_BOTTOM] = type === 'line' && bordered, _a)) }, { children: _jsxs("div", __assign({ ref: this.tabListRef, role: "tablist", className: bem('nav', [type, { complete: !ellipsis }]), style: navStyle }, { children: [navLeft, navs, type === 'line' && _jsx("div", { ref: this.lineRef, className: bem('line'), style: lineStyle }, void 0), navRight] }), void 0) }), void 0));
        return sticky ? (_jsx(Sticky, __assign({ ref: this.stickyRef, container: this.containerRef }, { children: wrap }), void 0)) : (wrap);
    };
    Tabs.prototype.warpAnimatedContents = function (contents) {
        var props = this.props;
        if (props.animated) {
            var style = {
                transform: "translate3d(" + -1 * this.state.activeIndex * 100 + "%, 0, 0)",
                transitionDuration: props.duration + "s",
            };
            return (_jsx("div", __assign({ className: bem('track'), style: style }, { children: contents }), void 0));
        }
        return contents;
    };
    Tabs.prototype.genContents = function () {
        var _this = this;
        var props = this.props;
        var animated = props.animated, scrollspy = props.scrollspy;
        var contents = [].concat(props.children).map(function (item, index) {
            var isActive = _this.state.activeIndex === index;
            if (animated) {
                return (_jsx("div", __assign({ role: "tabpanel", "aria-hidden": !isActive, className: bem('pane-wrapper', { inactive: !isActive }) }, { children: _jsx("div", __assign({ className: bem('pane') }, { children: React.cloneElement(item, { isActive: isActive }) }), void 0) }), index));
            }
            else {
                return (_jsx("div", __assign({ role: "tabpanel", className: bem('pane'), style: { display: scrollspy || isActive ? 'block' : 'none' } }, { children: React.cloneElement(item, { isActive: scrollspy || isActive }) }), index));
            }
        });
        var wrap = (_jsx("div", __assign({ ref: this.contentRef, className: bem('content', { animated: animated }) }, { children: animated ? this.warpAnimatedContents(contents) : contents }), void 0));
        return wrap;
    };
    Tabs.prototype.render = function () {
        var type = this.props.type;
        return (_jsxs("div", __assign({ ref: this.containerRef, className: bem([type]) }, { children: [this.genNavs(), this.genContents()] }), void 0));
    };
    Tabs.defaultProps = {
        type: 'line',
        bordered: true,
        activeIndex: 0,
        duration: 0.3,
    };
    return Tabs;
}(React.PureComponent));
export { Tabs };
