var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import clsx from 'clsx';
import { Info } from '../info';
import { createBEM } from '../utils/bem';
import './index.scss';
var bem = createBEM('pant-tab');
export var Title = function (props) {
    var dot = props.dot, type = props.type, info = props.info, color = props.color, title = props.title, titleNode = props.titleNode, scrollable = props.scrollable, disabled = props.disabled, isActive = props.isActive, ellipsis = props.ellipsis, activeColor = props.activeColor, inactiveColor = props.inactiveColor, swipeThreshold = props.swipeThreshold;
    var getStyle = function () {
        var style = {};
        var isCard = type === 'card';
        // card theme color
        if (color && isCard) {
            style.borderColor = color;
            if (!disabled) {
                if (isActive) {
                    style.backgroundColor = color;
                }
                else {
                    style.color = color;
                }
            }
        }
        var titleColor = isActive ? activeColor : inactiveColor;
        if (titleColor) {
            style.color = titleColor;
        }
        if (scrollable && ellipsis) {
            style.flexBasis = 88 / +swipeThreshold + "%";
        }
        return style;
    };
    var onClick = function (evt) {
        props.onClick(evt, props);
    };
    return (_jsx("div", __assign({ role: "tab", "aria-selected": isActive, className: clsx(bem({
            active: isActive,
            disabled: disabled,
        }), {
            'pant-ellipsis': ellipsis,
        }), style: getStyle(), onClick: onClick }, { children: _jsxs("span", __assign({ className: bem('text') }, { children: [titleNode || title, _jsx(Info, { dot: dot, info: info }, void 0)] }), void 0) }), void 0));
};
Title.defaultProps = {
    type: 'line',
};
