var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useRef } from 'react';
import clsx from 'clsx';
import { Overlay } from '../overlay';
import { Transition } from '../transition';
import { isDef, getIncrementalZIndex } from '../utils';
import { createBEM } from '../utils/bem';
import { Z_INDEX_TOAST_BASE } from '../utils/constant';
import { Icon } from '../icon';
import { Loading } from '../loading';
import './index.scss';
var bem = createBEM('pant-toast');
function genIcon(props) {
    var icon = props.icon, iconPrefix = props.iconPrefix, loading = props.loading, loadingType = props.loadingType;
    if (loading) {
        return _jsx(Loading, { className: bem('loading'), type: loadingType }, void 0);
    }
    else if (icon) {
        return _jsx(Icon, { className: bem('icon'), classPrefix: iconPrefix, name: icon }, void 0);
    }
}
function genMessage(props) {
    var html = props.html, message = props.message;
    if (!isDef(message) || message === '') {
        return;
    }
    if (html) {
        return _jsx("div", { className: bem('text'), dangerouslySetInnerHTML: { __html: message } }, void 0);
    }
    return _jsx("div", __assign({ className: bem('text') }, { children: message }), void 0);
}
export var Toast = function (props) {
    var _a;
    var containerRef = useRef();
    var show = props.show, zIndex = props.zIndex, overlay = props.overlay;
    var incZIndex = zIndex || getIncrementalZIndex(Z_INDEX_TOAST_BASE);
    return (_jsxs(React.Fragment, { children: [overlay ? _jsx(Overlay, { zIndex: incZIndex, style: { backgroundColor: 'rgba(0, 0, 0, 0)' }, show: show }, void 0) : null,
            _jsx(Transition, __assign({ name: "fade", stage: show ? 'enter' : 'leave', onAfterEnter: show ? props.onOpened : null, onAfterLeave: show ? null : props.onClosed }, { children: _jsxs("div", __assign({ ref: containerRef, className: clsx(bem([
                        props.position,
                        "align-" + props.textAlign,
                        (_a = {}, _a[props.html ? 'html' : 'text'] = !props.icon && !props.loading, _a),
                    ]), props.className), style: { zIndex: incZIndex }, onClick: props.onClick }, { children: [genIcon(props), genMessage(props)] }), void 0) }), void 0)] }, void 0));
};
Toast.defaultProps = {
    html: false,
    overlay: false,
    loading: false,
    position: 'middle',
    textAlign: 'center',
};
