import React from 'react';
import './index.scss';
export declare type TransitionableProps = {
    className?: string;
    style?: Record<string, string>;
};
export interface TransitionableComponent {
    addEventListener(type: string, listener: (this: HTMLElement, ev: Event) => any, options?: boolean | AddEventListenerOptions): void;
    removeEventListener(type: string, listener: (this: HTMLElement, ev: Event) => any, options?: boolean | EventListenerOptions): void;
}
export declare type TransitionEvents = {
    onAfterEnter?(): void;
    onAfterLeave?(): void;
};
export declare type TransitionName = 'fade' | 'slide-up' | 'slide-down' | 'slide-left' | 'slide-right';
export declare type TransitionStage = 'enter' | 'leave';
export declare type TransitionProps = {
    stage: TransitionStage;
    name?: TransitionName;
    customName?: string;
    duration?: number | string;
    children: JSX.Element;
} & TransitionEvents;
declare type TransitionState = {
    prevProps: TransitionProps;
    active: boolean;
};
export declare class Transition extends React.PureComponent<TransitionProps, TransitionState> {
    static defaultProps: {
        name: string;
        duration: string;
    };
    unmouted: boolean;
    childrenRef: TransitionableComponent;
    bindedOnAnimationEnd: any;
    state: {
        prevProps: Readonly<TransitionProps> & Readonly<{
            children?: React.ReactNode;
        }>;
        active: boolean;
    };
    static getDerivedStateFromProps(props: TransitionProps, state: TransitionState): TransitionState;
    private onAnimationEnd;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
export {};
