var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import React from 'react';
import './index.scss';
var animationEndEventName = window.onanimationend === undefined && window.onwebkitanimationend !== undefined
    ? 'webkitAnimationEnd'
    : 'animationend';
var Transition = /** @class */ (function (_super) {
    __extends(Transition, _super);
    function Transition() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.unmouted = false;
        _this.bindedOnAnimationEnd = _this.onAnimationEnd.bind(_this);
        _this.state = {
            prevProps: _this.props,
            active: _this.props.stage === 'enter',
        };
        return _this;
    }
    Transition.getDerivedStateFromProps = function (props, state) {
        if (props.stage !== state.prevProps.stage) {
            return {
                prevProps: props,
                active: true,
            };
        }
        return null;
    };
    Transition.prototype.onAnimationEnd = function () {
        var _this = this;
        if (this.unmouted) {
            return;
        }
        if (this.childrenRef) {
            this.childrenRef.removeEventListener(animationEndEventName, this.bindedOnAnimationEnd);
        }
        this.setState({ active: false }, function () {
            var _a = _this.props, stage = _a.stage, onAfterEnter = _a.onAfterEnter, onAfterLeave = _a.onAfterLeave;
            if (stage === 'enter') {
                onAfterEnter && onAfterEnter();
            }
            else {
                onAfterLeave && onAfterLeave();
            }
        });
    };
    Transition.prototype.componentDidMount = function () {
        this.childrenRef.addEventListener(animationEndEventName, this.bindedOnAnimationEnd);
    };
    Transition.prototype.componentDidUpdate = function () {
        this.childrenRef.addEventListener(animationEndEventName, this.bindedOnAnimationEnd);
    };
    Transition.prototype.componentWillUnmount = function () {
        this.unmouted = true;
    };
    Transition.prototype.render = function () {
        var _this = this;
        var _a = this.props, name = _a.name, customName = _a.customName, stage = _a.stage, duration = _a.duration, children = _a.children;
        var active = this.state.active;
        var transitionClassName = active ? "pant-" + (customName || name) + "-" + stage + "-active" : '';
        var childrenClassName = children.props.className;
        var className = transitionClassName
            ? childrenClassName
                ? childrenClassName + ' ' + transitionClassName
                : transitionClassName
            : childrenClassName;
        var childrenStyle = children.props.style;
        var style;
        if (stage === 'leave' && !active) {
            style = __assign(__assign({}, childrenStyle), { display: 'none' });
        }
        else {
            style = childrenStyle;
        }
        if (active) {
            style = __assign(__assign({}, style), { animationDuration: duration + "s", WebkitAnimationDuration: duration + "s" });
        }
        return (_jsx(React.Fragment, { children: React.cloneElement(children, {
                className: className,
                style: style,
                ref: function (el) {
                    _this.childrenRef = el;
                    var ref = children.ref;
                    if (ref) {
                        ref.current = el;
                    }
                },
            }) }, void 0));
    };
    Transition.defaultProps = {
        name: 'fade',
        duration: '0.3',
    };
    return Transition;
}(React.PureComponent));
export { Transition };
