import closestx from 'closest';
export function removeNode(el) {
    var parent = el.parentNode;
    if (parent) {
        parent.removeChild(el);
    }
}
export function isHidden(el) {
    var style = window.getComputedStyle(el);
    var hidden = style.display === 'none';
    // offsetParent returns null in the following situations:
    // 1. The element or its parent element has the display property set to none.
    // 2. The element has the position property set to fixed
    var parentHidden = el.offsetParent === null && style.position !== 'fixed';
    return hidden || parentHidden;
}
export function closest(element, selector, checkYoSelf) {
    return closestx(element, selector, checkYoSelf);
}
export function hasClass(el, className) {
    return el.className.split(/\s+/).some(function (c) { return c === className; });
}
export function addClass(el, className) {
    if (hasClass(el, className)) {
        return;
    }
    var oldClassName = el.className;
    el.className = oldClassName ? oldClassName + ' ' + className : className;
}
export function removeClass(el, className) {
    var has = false;
    var cs = el.className.split(/\s+/).filter(function (c) {
        if (c === className) {
            has = true;
            return false;
        }
        return true;
    });
    if (has) {
        el.className = cs.join(' ');
    }
}
