import { pantConfig } from '../';
var isServer = pantConfig('isServer');
export var supportsPassive = false;
if (!isServer) {
    try {
        var opts = {};
        Object.defineProperty(opts, 'passive', {
            get: function () {
                supportsPassive = true;
            },
        });
        window.addEventListener('test-passive', null, opts);
    }
    catch (e) {
        //
    }
}
export function on(target, event, handler, passive) {
    if (passive === void 0) { passive = false; }
    if (!isServer) {
        target.addEventListener(event, handler, supportsPassive ? { capture: false, passive: passive } : false);
    }
}
export function off(target, event, handler) {
    if (!isServer) {
        target.removeEventListener(event, handler);
    }
}
export function stopPropagation(event) {
    event.stopPropagation();
}
export function preventDefault(event) {
    if (typeof event.cancelable !== 'boolean' || event.cancelable) {
        event.preventDefault();
    }
}
export function preventDefaultAndStopPropagation(event) {
    preventDefault(event);
    stopPropagation(event);
}
