import { pantConfig } from '../';
import { Z_INDEX_INCREMENTAL_START } from './constant';
export var inBrowser = typeof window !== 'undefined';
export function isDef(val) {
    return val !== undefined && val !== null;
}
export function isObject(val) {
    return val !== null && typeof val === 'object';
}
export function isNumeric(val) {
    return /^\d+(\.\d+)?$/.test(val);
}
export function isNaN(val) {
    if (Number.isNaN) {
        return Number.isNaN(val);
    }
    return val !== val;
}
export function addUnit(value) {
    if (!isDef(value)) {
        return undefined;
    }
    var viewportWidth = pantConfig('viewportWidth');
    value = value + '';
    if (isNumeric(value)) {
        if (viewportWidth > 0) {
            return (+value * 100) / viewportWidth + 'vw';
        }
        else {
            return value + 'px';
        }
    }
    else {
        return value;
    }
}
export function removeUnit(value) {
    if (!isDef(value)) {
        return undefined;
    }
    if (typeof value === 'number') {
        return value;
    }
    else {
        var n = parseFloat(value);
        if (inBrowser && /vw$/.test(value)) {
            return (screen.availWidth * n) / 100;
        }
        else {
            return n;
        }
    }
}
export function omit(obj, keys) {
    var res = {};
    Object.keys(obj)
        .filter(function (key) {
        return !keys.includes(key);
    })
        .forEach(function (key) {
        res[key] = obj[key];
    });
    return res;
}
var zIndex = Z_INDEX_INCREMENTAL_START;
export function getIncrementalZIndex(base) {
    if (base === void 0) { base = 0; }
    return base + zIndex++;
}
export function interpolate(text, data) {
    return (text &&
        text.replace(/\{(.*?)\}/g, function (full, key) {
            var res = data && data[key];
            return isDef(res) ? res : full;
        }));
}
