import React from 'react';
import { LoadingType } from '../loading';
import './index.scss';
export declare type ButtonType = 'default' | 'primary' | 'info' | 'warning' | 'danger';
export declare type ButtonSize = 'large' | 'normal' | 'small' | 'mini';
export declare type ButtonProps = {
    type?: ButtonType;
    size?: ButtonSize;
    url?: string;
    text?: string;
    icon?: string;
    color?: string;
    block?: boolean;
    plain?: boolean;
    round?: boolean;
    square?: boolean;
    loading?: boolean;
    hairline?: boolean;
    disabled?: boolean;
    targetBlank?: boolean;
    nativeType?: 'button' | 'submit' | 'reset';
    loadingSize?: number | string;
    loadingType?: LoadingType;
    loadingText?: string;
    className?: string;
    style?: Record<string, string>;
    onClick?(event: React.MouseEvent): void;
};
export declare const Button: React.FC<ButtonProps>;
