"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Card = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var clsx_1 = __importDefault(require("clsx"));
var tag_1 = require("../tag");
var img_1 = require("../img");
var utils_1 = require("../utils");
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-card');
var Card = function (props) {
    var thumb = props.thumb;
    var showNum = utils_1.isDef(props.num);
    var showPrice = utils_1.isDef(props.price);
    var showOriginPrice = utils_1.isDef(props.originPrice);
    var showBottom = showNum || showPrice || showOriginPrice || utils_1.isDef(props.bottomNode);
    function ThumbTag() {
        if (props.tagNode || props.tag) {
            return (jsx_runtime_1.jsx("div", __assign({ className: bem('tag') }, { children: props.tagNode ? (props.tagNode) : (jsx_runtime_1.jsx(tag_1.Tag, __assign({ mark: true, type: "danger" }, { children: props.tag }), void 0)) }), void 0));
        }
    }
    function Thumb() {
        if (props.thumbNode || thumb) {
            return (jsx_runtime_1.jsxs("a", __assign({ href: props.thumbLink, className: bem('thumb'), onClick: props.onClickThumb }, { children: [props.thumbNode ? (props.thumbNode) : (jsx_runtime_1.jsx(img_1.Img, { src: thumb, width: "100%", height: "100%", fit: "cover", lazyLoad: props.lazyLoad }, void 0)), ThumbTag()] }), void 0));
        }
    }
    function Title() {
        if (props.titleNode) {
            return props.titleNode;
        }
        if (props.title) {
            return jsx_runtime_1.jsx("div", __assign({ className: clsx_1.default(bem('title'), 'van-multi-ellipsis--l2') }, { children: props.title }), void 0);
        }
    }
    function Desc() {
        if (props.descNode) {
            return props.descNode;
        }
        if (props.desc) {
            return jsx_runtime_1.jsx("div", __assign({ className: clsx_1.default(bem('desc'), 'van-ellipsis') }, { children: props.desc }), void 0);
        }
    }
    function PriceContent() {
        var priceArr = props.price.toString().split('.');
        return (jsx_runtime_1.jsxs("div", { children: [jsx_runtime_1.jsx("span", __assign({ className: bem('price-currency') }, { children: props.currency }), void 0),
                jsx_runtime_1.jsx("span", __assign({ className: bem('price-integer') }, { children: priceArr[0] }), void 0), ".", jsx_runtime_1.jsx("span", __assign({ className: bem('price-decimal') }, { children: priceArr[1] }), void 0)] }, void 0));
    }
    function Price() {
        if (showPrice) {
            return jsx_runtime_1.jsx("div", __assign({ className: bem('price') }, { children: props.priceNode ? props.priceNode : PriceContent() }), void 0);
        }
    }
    function OriginPrice() {
        if (showOriginPrice) {
            return (jsx_runtime_1.jsx("div", __assign({ className: bem('origin-price') }, { children: props.originPriceNode ? props.originPriceNode : props.currency + " " + props.originPrice }), void 0));
        }
    }
    function Num() {
        if (showNum) {
            return jsx_runtime_1.jsx("div", __assign({ className: bem('num') }, { children: props.numNode ? props.numNode : "x" + props.num }), void 0);
        }
    }
    function Footer() {
        if (props.footerNode) {
            return jsx_runtime_1.jsx("div", __assign({ className: bem('footer') }, { children: props.footerNode }), void 0);
        }
    }
    return (jsx_runtime_1.jsxs("div", __assign({ className: bem() }, { children: [jsx_runtime_1.jsxs("div", __assign({ className: bem('header') }, { children: [Thumb(), jsx_runtime_1.jsxs("div", __assign({ className: bem('content', { centered: props.centered }) }, { children: [jsx_runtime_1.jsxs("div", { children: [Title(), Desc(), props.tagsNode] }, void 0),
                            showBottom && (jsx_runtime_1.jsxs("div", __assign({ className: "van-card__bottom" }, { children: [props.priceTopNode, Price(), OriginPrice(), Num(), props.bottomNode] }), void 0))] }), void 0)] }), void 0), Footer()] }), void 0));
};
exports.Card = Card;
exports.Card.defaultProps = {
    currency: '¥',
};
