"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Cell = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var clsx_1 = __importDefault(require("clsx"));
var icon_1 = require("../icon");
var utils_1 = require("../utils");
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-cell');
var Cell = function (props) {
    var icon = props.icon, title = props.title, label = props.label, rightIcon = props.rightIcon;
    var showTitle = utils_1.isDef(title);
    function Label() {
        if (utils_1.isDef(label)) {
            return jsx_runtime_1.jsx("div", __assign({ className: bem('label') }, { children: label }), void 0);
        }
    }
    function Title() {
        if (showTitle) {
            return (jsx_runtime_1.jsxs("div", __assign({ className: clsx_1.default(bem('title'), props.titleClassName), style: props.titleStyle }, { children: [typeof title === 'string' ? jsx_runtime_1.jsx("span", { children: title }, void 0) : title, Label()] }), void 0));
        }
    }
    function Value() {
        if (utils_1.isDef(props.children)) {
            return jsx_runtime_1.jsx("div", __assign({ className: clsx_1.default(bem('value', { alone: !showTitle }), props.valueClassName) }, { children: props.children }), void 0);
        }
    }
    function LeftIcon() {
        if (typeof icon === 'string') {
            return jsx_runtime_1.jsx(icon_1.Icon, { className: bem('left-icon'), name: icon }, void 0);
        }
        else if (icon) {
            return icon;
        }
    }
    function RightIcon() {
        if (typeof rightIcon === 'string') {
            return jsx_runtime_1.jsx(icon_1.Icon, { className: bem('right-icon'), name: rightIcon }, void 0);
        }
        else if (rightIcon) {
            return rightIcon;
        }
    }
    function onClick(event) {
        props.onClick && props.onClick(event);
    }
    var clickable = !!props.onClick;
    var classes = {
        clickable: clickable,
        large: props.size === 'large',
        center: props.center,
        required: props.required,
        borderless: !props.border,
    };
    return (jsx_runtime_1.jsxs("div", __assign({ className: clsx_1.default(bem(classes), props.className), role: clickable ? 'button' : null, tabIndex: clickable ? 0 : null, onClick: onClick, style: props.style }, { children: [LeftIcon(), Title(), Value(), RightIcon()] }), void 0));
};
exports.Cell = Cell;
exports.Cell.defaultProps = {
    border: true,
};
