"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Checkbox = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var icon_1 = require("../icon");
var utils_1 = require("../utils");
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-checkbox');
var Checkbox = function (props) {
    function iconStyle() {
        var checkedColor = props.checkedColor;
        if (checkedColor && props.checked && !props.disabled) {
            return {
                borderColor: checkedColor,
                backgroundColor: checkedColor,
            };
        }
    }
    function onClick(event) {
        if (props.disabled) {
            return;
        }
        if (props.role == 'radio' && props.checked) {
            return;
        }
        props.onClick && props.onClick(event, props);
    }
    function genIcon() {
        var checked = props.checked, iconSize = props.iconSize;
        return (jsx_runtime_1.jsx("div", __assign({ className: bem('icon', [props.shape, { disabled: props.disabled, checked: checked }]), style: { fontSize: utils_1.addUnit(iconSize) }, onClick: props.labelDisabled ? onClick : null }, { children: (checked && props.activeIconNode) || (!checked && props.inactiveIconNode) || props.iconNode || (jsx_runtime_1.jsx(icon_1.Icon, { name: "success", style: iconStyle() }, void 0)) }), "icon"));
    }
    function genLabel() {
        if (props.children) {
            return (jsx_runtime_1.jsx("span", __assign({ className: bem('label', [props.labelPosition, { disabled: props.disabled }]) }, { children: props.children }), "label"));
        }
    }
    function tabindex() {
        if (props.disabled || (props.role === 'radio' && !props.checked)) {
            return -1;
        }
        return 0;
    }
    var Children = [genIcon()];
    if (props.labelPosition === 'left') {
        Children.unshift(genLabel());
    }
    else {
        Children.push(genLabel());
    }
    return (jsx_runtime_1.jsx("div", __assign({ role: props.role, className: bem([
            {
                disabled: props.disabled,
                'label-disabled': props.labelDisabled,
            },
            props.direction,
        ]), tabIndex: tabindex(), "aria-checked": props.checked, onClick: props.labelDisabled ? null : onClick }, { children: Children }), void 0));
};
exports.Checkbox = Checkbox;
exports.Checkbox.defaultProps = {
    checked: false,
    disabled: false,
    labelPosition: 'right',
    role: 'checkbox',
    shape: 'round',
    direction: 'vertical',
};
