"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.batchActions = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var button_1 = require("../../../button");
var action_sheet_1 = require("../../../action-sheet");
var locale_1 = require("../../../locale");
var selectable_1 = require("../selectable");
require("./index.scss");
function batchActions(options) {
    return {
        onInjectToolbar: function (render) { return function (props) {
            return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [render(props), jsx_runtime_1.jsx(BatchActions, __assign({}, options), void 0)] }, void 0));
        }; },
    };
}
exports.batchActions = batchActions;
function BatchActions(_a) {
    var render = _a.render, getActions = _a.getActions, cancelText = _a.cancelText;
    var selectable = react_1.useContext(selectable_1.SelectableContext);
    var showActions = function () {
        if (!getActions) {
            return;
        }
        var actions = getActions(selectable);
        action_sheet_1.actionSheet({
            position: 'top',
            round: false,
            actions: actions.slice(1),
            cancelText: typeof cancelText === 'undefined' ? locale_1.i18n().cancel : cancelText,
            onSelect: function (_a) {
                var action = _a.action;
                action(selectable);
            },
        });
    };
    if (render) {
        return jsx_runtime_1.jsx("div", __assign({ className: "pant-data-list__batch-actions" }, { children: render(selectable, showActions) }), void 0);
    }
    var actions = getActions(selectable);
    var firstAction = actions[0];
    var secondAction = actions[1];
    var performFirstAction = function () {
        firstAction.action(selectable);
    };
    var performSecondAction = function () {
        secondAction.action(selectable);
    };
    return (jsx_runtime_1.jsxs("div", __assign({ className: "pant-data-list__batch-actions" }, { children: [firstAction ? (jsx_runtime_1.jsx(button_1.Button, __assign({ size: "small", type: "info", plain: true, onClick: performFirstAction }, { children: firstAction.name }), void 0)) : null,
            actions.length > 2 ? (jsx_runtime_1.jsx(button_1.Button, __assign({ size: "small", onClick: showActions }, { children: "More ..." }), void 0)) : secondAction ? (jsx_runtime_1.jsx(button_1.Button, __assign({ size: "small", onClick: performSecondAction }, { children: secondAction.name }), void 0)) : null] }), void 0));
}
