"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterable = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var icon_1 = require("../../../icon");
var popup_1 = require("../../../popup");
var toolbar_1 = require("../../../popup/toolbar");
var form_1 = require("../../../form");
var field_1 = require("../../../field");
var datetime_picker_1 = require("../../../datetime-picker");
var cascader_1 = require("../../../cascader");
var searchable_picker_1 = require("../../../searchable-picker");
var bem_1 = require("../../../utils/bem");
var dom_1 = require("../../../utils/dom");
var locale_1 = require("../../../locale");
require("./index.scss");
function filterable(options) {
    return {
        onInjectToolbar: function (render) { return function (props) {
            return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [render(props), jsx_runtime_1.jsx(Filterable, __assign({}, options), void 0)] }, void 0));
        }; },
    };
}
exports.filterable = filterable;
var bem = bem_1.createBEM('pant-data-list__filter');
function formatDatetime(date, type) {
    var y = date.getFullYear();
    var m = date.getMonth() + 1;
    var d = date.getDate();
    var h = date.getHours();
    var mm = date.getMinutes();
    var dd = y + "-" + (m < 10 ? '0' + m : m) + "-" + (d < 10 ? '0' + d : d);
    var tt = (h < 10 ? '0' + h : h) + ":" + (mm < 10 ? '0' + mm : mm);
    if (type === 'datetime') {
        return dd + ' ' + tt;
    }
    else if (type === 'time') {
        return tt;
    }
    else {
        return dd;
    }
}
function Filterable(_a) {
    var _b = _a.columns, columns = _b === void 0 ? [] : _b, _c = _a.value, value = _c === void 0 ? {} : _c, filterButton = _a.filterButton, filterTitle = _a.filterTitle, cancelButtonText = _a.cancelButtonText, confirmButtonText = _a.confirmButtonText, onPopup = _a.onPopup, onChange = _a.onChange;
    var submitBtnRef = react_1.useRef();
    var _d = react_1.useState(false), show = _d[0], setShow = _d[1];
    var onClick = function (event) {
        if (onPopup && onPopup(event) === false) {
            return;
        }
        setShow(true);
        dom_1.addClass(document.body, 'pant-overflow-hidden');
    };
    var hide = function () {
        dom_1.removeClass(document.body, 'pant-overflow-hidden');
        setShow(false);
    };
    var confirm = function () {
        submitBtnRef.current.click();
        hide();
    };
    react_1.useEffect(function () {
        return function () {
            if (show) {
                dom_1.removeClass(document.body, 'pant-overflow-hidden');
            }
        };
    }, [show]);
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx("div", __assign({ className: bem(), onClick: onClick }, { children: filterButton || (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx("span", { children: locale_1.i18n().filter }, void 0),
                        jsx_runtime_1.jsx(icon_1.Icon, { name: "filter-o" }, void 0)] }, void 0)) }), void 0),
            jsx_runtime_1.jsx(popup_1.Popup, __assign({ show: show, position: "right", onClickClose: hide, style: { width: '85%', height: '100%' }, lazyRender: true }, { children: jsx_runtime_1.jsxs("div", __assign({ className: bem('popup') }, { children: [jsx_runtime_1.jsx(toolbar_1.PopupToolbar, { className: bem('title'), title: filterTitle || locale_1.i18n().filter }, void 0),
                        jsx_runtime_1.jsx("div", __assign({ className: bem('list') }, { children: jsx_runtime_1.jsxs(form_1.Form, __assign({ onSubmit: function (promise) {
                                    promise.then(function (res) {
                                        onChange && onChange(res.data);
                                    });
                                } }, { children: [columns.map(function (_a) {
                                        var key = _a.key, header = _a.header, _b = _a.type, type = _b === void 0 ? 'input' : _b, CustomComponent = _a.component, _c = _a.componentProps, componentProps = _c === void 0 ? {} : _c, placeholder = _a.placeholder;
                                        if (type === 'cascader') {
                                            var Comp = CustomComponent || cascader_1.Cascader;
                                            return (jsx_runtime_1.jsx(field_1.Field, __assign({ name: key, title: header, placeholder: placeholder, direction: "column", clearable: true, displayValueFormatter: function (value) {
                                                    if (!value || !value.length) {
                                                        return '';
                                                    }
                                                    if (typeof value[0] === 'string') {
                                                        return value.join('/');
                                                    }
                                                    else if (Array.isArray(value[0])) {
                                                        return value.map(function (item) { return item.join('/'); }).join(', ');
                                                    }
                                                    return '';
                                                } }, { children: jsx_runtime_1.jsx(popup_1.Popup, __assign({ position: "bottom", closeOnClickOverlay: true }, { children: jsx_runtime_1.jsx(Comp, __assign({}, componentProps, { defaultValue: value[key] }), void 0) }), void 0) }), key));
                                        }
                                        else if (type === 'searchable-picker') {
                                            var Comp = CustomComponent || searchable_picker_1.SearchablePicker;
                                            return (jsx_runtime_1.jsx(field_1.Field, __assign({ name: key, title: header, placeholder: placeholder, direction: "column", clearable: true, displayValueFormatter: function (value) {
                                                    if (typeof value === 'string') {
                                                        return value;
                                                    }
                                                    else if (Array.isArray(value)) {
                                                        return value && value.join(', ');
                                                    }
                                                    return '';
                                                } }, { children: jsx_runtime_1.jsx(popup_1.Popup, __assign({ position: "bottom", closeOnClickOverlay: true }, { children: jsx_runtime_1.jsx(Comp, __assign({}, componentProps, { defaultValue: value[key] }), void 0) }), void 0) }), key));
                                        }
                                        else if (type === 'datetime') {
                                            var Comp = CustomComponent || datetime_picker_1.DatetimePicker;
                                            var props = componentProps;
                                            var datetimeType_1 = props.type || 'date';
                                            return (jsx_runtime_1.jsx(field_1.Field, __assign({ name: key, title: header, placeholder: placeholder, direction: "column", clearable: true, displayValueFormatter: function (value) {
                                                    return value && formatDatetime(value, datetimeType_1);
                                                } }, { children: jsx_runtime_1.jsx(popup_1.Popup, __assign({ position: "bottom", closeOnClickOverlay: true }, { children: jsx_runtime_1.jsx(Comp, __assign({}, props, { defaultValue: value[key] }), void 0) }), void 0) }), key));
                                        }
                                        else if (type === 'datetime-range') {
                                            var Comp = CustomComponent || datetime_picker_1.DatetimeRange;
                                            var props = componentProps;
                                            var datetimeType_2 = props.type || 'date';
                                            return (jsx_runtime_1.jsx(field_1.Field, __assign({ name: key, title: header, placeholder: placeholder, direction: "column", clearable: true, displayValueFormatter: function (value) {
                                                    return (value &&
                                                        value.length &&
                                                        formatDatetime(value[0], datetimeType_2) + " ~ " + formatDatetime(value[1], datetimeType_2));
                                                } }, { children: jsx_runtime_1.jsx(Comp, __assign({}, props, { defaultValue: value[key] }), void 0) }), key));
                                        }
                                        else if (type === 'switch') {
                                            return (jsx_runtime_1.jsx(field_1.Field, { className: "flex-direction-row", type: "switch", inputAlign: "right", defaultValue: value[key], name: key, title: header }, key));
                                        }
                                        return (jsx_runtime_1.jsx(field_1.Field, { defaultValue: value[key], placeholder: placeholder, name: key, title: header, clearable: true, clearTrigger: "always", direction: "column" }, key));
                                    }),
                                    jsx_runtime_1.jsx("button", { ref: submitBtnRef, type: "submit", style: { display: 'none' } }, void 0)] }), void 0) }), void 0),
                        jsx_runtime_1.jsx(toolbar_1.PopupToolbar, { className: bem('footer'), onCancel: hide, onConfirm: confirm, cancelButtonText: cancelButtonText, confirmButtonText: confirmButtonText }, void 0)] }), void 0) }), void 0)] }, void 0));
}
