"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.pageable = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var button_1 = require("../../../button");
var sticky_1 = require("../../../sticky");
var locale_1 = require("../../../locale");
require("./index.scss");
function pageable(options) {
    if (options === void 0) { options = {}; }
    return {
        onInjectDataList: function (render) { return function (props) {
            var records = props.records;
            var _a = options.recordCount, recordCount = _a === void 0 ? records.length : _a, paginationProps = __rest(options, ["recordCount"]);
            return (jsx_runtime_1.jsx(DataListPagination, __assign({ dataListProps: props, dataListRender: render }, paginationProps, { recordCount: recordCount }), void 0));
        }; },
    };
}
exports.pageable = pageable;
function DataListPagination(_a) {
    var dataListRender = _a.dataListRender, dataListProps = _a.dataListProps, sticky = _a.sticky, stickyContainer = _a.stickyContainer, pageIndex = _a.pageIndex, pageSize = _a.pageSize, recordCount = _a.recordCount, onPagingChange = _a.onPagingChange, props = __rest(_a, ["dataListRender", "dataListProps", "sticky", "stickyContainer", "pageIndex", "pageSize", "recordCount", "onPagingChange"]);
    var _b = react_1.useState({
        pageIndex: 1,
        pageSize: 20,
    }), internalPaging = _b[0], setInternalPaging = _b[1];
    if (typeof pageIndex === 'undefined') {
        pageIndex = internalPaging.pageIndex;
    }
    if (typeof pageSize === 'undefined') {
        pageSize = internalPaging.pageSize;
    }
    onPagingChange = (function (onPagingChange) { return function (query) {
        setInternalPaging(query);
        onPagingChange && onPagingChange(query);
    }; })(onPagingChange);
    var records = dataListProps.records;
    var pagination = (jsx_runtime_1.jsx(Pagination, __assign({ recordCount: recordCount, pageIndex: pageIndex, pageSize: pageSize, onPagingChange: onPagingChange }, props), void 0));
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [dataListRender(__assign(__assign({}, dataListProps), { records: records.length < recordCount ? records : records.slice((pageIndex - 1) * pageSize, pageIndex * pageSize) })),
            recordCount === 0 ? null : sticky ? (jsx_runtime_1.jsx(sticky_1.Sticky, __assign({ container: stickyContainer, offsetTop: 60, stickBottom: true }, { children: pagination }), void 0)) : (pagination)] }, void 0));
}
function Pagination(_a) {
    var recordCount = _a.recordCount, pageSize = _a.pageSize, pageIndex = _a.pageIndex, prevPageText = _a.prevPageText, nextPageText = _a.nextPageText, onPagingChange = _a.onPagingChange;
    var pages = Math.ceil(recordCount / pageSize);
    if (pages <= 1) {
        return null;
    }
    return (jsx_runtime_1.jsxs("div", __assign({ className: "pant-data-list__pagination pant-hairline--top" }, { children: [jsx_runtime_1.jsx(button_1.Button, __assign({ className: "pant-data-list__pagination__prev", size: "small", disabled: pageIndex === 1, onClick: function () { return onPagingChange({ pageSize: pageSize, pageIndex: pageIndex - 1 }); } }, { children: prevPageText || locale_1.i18n().prevPage }), void 0),
            jsx_runtime_1.jsxs("span", __assign({ className: "pant-data-list__pagination__text" }, { children: [pageIndex, " / ", pages] }), void 0),
            jsx_runtime_1.jsx(button_1.Button, __assign({ className: "pant-data-list__pagination__next", size: "small", disabled: pageIndex >= pages, onClick: function () { return onPagingChange({ pageSize: pageSize, pageIndex: pageIndex + 1 }); } }, { children: nextPageText || locale_1.i18n().nextPage }), void 0)] }), void 0));
}
