"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.recordActions = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var icon_1 = require("../../../icon");
var action_sheet_1 = require("../../../action-sheet");
var locale_1 = require("../../../locale");
function recordActions(options) {
    return {
        onInjectRecord: function (render) { return function (props) {
            return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [render(props), jsx_runtime_1.jsx(RecordActions, __assign({ record: props.record, recordIndex: props.recordIndex }, options), void 0)] }, void 0));
        }; },
    };
}
exports.recordActions = recordActions;
function RecordActions(_a) {
    var getActions = _a.getActions, record = _a.record, recordIndex = _a.recordIndex, actionIcon = _a.actionIcon, cancelText = _a.cancelText;
    var actions = getActions(record, recordIndex);
    if (!actions || !actions.length) {
        return null;
    }
    var showActions = function () {
        action_sheet_1.actionSheet({
            round: false,
            actions: actions,
            cancelText: typeof cancelText === 'undefined' ? locale_1.i18n().cancel : cancelText,
            onSelect: function (_a) {
                var action = _a.action;
                action(record, recordIndex);
            },
        });
    };
    return (jsx_runtime_1.jsx("div", __assign({ className: "pant-data-list__record__actions" }, { children: (actionIcon && react_1.default.cloneElement(actionIcon, { onClick: showActions })) || (jsx_runtime_1.jsx(icon_1.Icon, { name: "ellipsis", onClick: showActions }, void 0)) }), void 0));
}
