"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.selectable = exports.SelectableContext = exports.SelectableManager = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importStar(require("react"));
var icon_1 = require("../../../icon");
var bem_1 = require("../../../utils/bem");
var key_selector_1 = require("../../key-selector");
var manager_1 = require("./manager");
Object.defineProperty(exports, "SelectableManager", { enumerable: true, get: function () { return manager_1.SelectableManager; } });
require("./index.scss");
exports.SelectableContext = react_1.default.createContext(null);
function selectable(options) {
    return {
        onInjectRecord: function (render) { return function (props) {
            return jsx_runtime_1.jsx(DataListSelectable, __assign({ dataListRecordProps: props, dataListRecordRender: render }, options), void 0);
        }; },
        onInjectDataList: function (render) { return function (props) {
            return (jsx_runtime_1.jsx(exports.SelectableContext.Provider, __assign({ value: new manager_1.SelectableManager(props.records, options.value, props.recordKey, options.maxSelection, options.maxSelectionMsg, options.onChange) }, { children: render(props) }), void 0));
        }; },
    };
}
exports.selectable = selectable;
function DataListSelectable(_a) {
    var dataListRecordRender = _a.dataListRecordRender, dataListRecordProps = _a.dataListRecordProps, options = __rest(_a, ["dataListRecordRender", "dataListRecordProps"]);
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx(Selectable, __assign({}, dataListRecordProps, options), void 0),
            dataListRecordRender(__assign({}, dataListRecordProps))] }, void 0));
}
var bem = bem_1.createBEM('pant-data-list__select');
function Selectable(_a) {
    var record = _a.record, recordIndex = _a.recordIndex, recordKey = _a.recordKey, maxSelection = _a.maxSelection, checkedIcon = _a.checkedIcon, uncheckedIcon = _a.uncheckedIcon, singleCheckedIcon = _a.singleCheckedIcon, singleUncheckedIcon = _a.singleUncheckedIcon;
    var manager = react_1.useContext(exports.SelectableContext);
    var key = key_selector_1.select(recordKey)(record, recordIndex);
    var toggle = function () { return manager.toggle(key); };
    var icon;
    if (manager.hasKey(key)) {
        icon =
            maxSelection === 1 && singleCheckedIcon
                ? react_1.default.cloneElement(singleCheckedIcon, { onClick: toggle })
                : (checkedIcon && react_1.default.cloneElement(checkedIcon, { onClick: toggle })) || (jsx_runtime_1.jsx(icon_1.Icon, { name: "passed", onClick: toggle }, void 0));
    }
    else {
        icon =
            maxSelection === 1 && singleUncheckedIcon
                ? react_1.default.cloneElement(singleUncheckedIcon, { onClick: toggle })
                : (uncheckedIcon && react_1.default.cloneElement(uncheckedIcon, { onClick: toggle })) || (jsx_runtime_1.jsx(icon_1.Icon, { name: "circle", onClick: toggle }, void 0));
    }
    return jsx_runtime_1.jsx("div", __assign({ className: bem() }, { children: icon }), void 0);
}
