import React from 'react';
import { DataListAddon } from '../..';
import './index.scss';
declare type SortOrder = 'desc' | 'asc';
export declare type SortableColumn = {
    key: string;
    header: React.ReactNode;
    prefer?: SortOrder;
};
export declare type SortBy = {
    by: string;
    order: SortOrder;
};
export declare type SortableOptions = {
    columns: SortableColumn[];
    value?: SortBy[];
    multiple?: boolean;
    sortButton?: JSX.Element;
    ascIcon?: JSX.Element;
    descIcon?: JSX.Element;
    sortIcon?: JSX.Element;
    cancelButtonText?: string;
    confirmButtonText?: string;
    onChange: (value: SortBy[]) => void;
};
export declare function sortable(options: SortableOptions): DataListAddon;
declare type SortableState = {
    show: boolean;
    value?: SortBy[];
    prevProps: SortableOptions;
};
export declare class Sortable extends React.PureComponent<SortableOptions, SortableState> {
    static defaultProps: {
        value: SortBy[];
    };
    constructor(props: React.PropsWithChildren<SortableOptions>);
    static getDerivedStateFromProps(props: React.PropsWithChildren<SortableOptions>, state: SortableState): SortableState;
    show(): void;
    hide(): void;
    confirm(): void;
    sort(by: string, prefer?: SortOrder, order?: string): void;
    render(): JSX.Element;
}
export {};
