"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sortable = exports.sortable = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var icon_1 = require("../../../icon");
var popup_1 = require("../../../popup");
var toolbar_1 = require("../../../popup/toolbar");
var bem_1 = require("../../../utils/bem");
var locale_1 = require("../../../locale");
require("./index.scss");
function sortable(options) {
    return {
        onInjectToolbar: function (render) { return function (props) {
            return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [render(props), jsx_runtime_1.jsx(Sortable, __assign({}, options), void 0)] }, void 0));
        }; },
    };
}
exports.sortable = sortable;
var bem = bem_1.createBEM('pant-data-list__sort');
var Sortable = /** @class */ (function (_super) {
    __extends(Sortable, _super);
    function Sortable(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            show: false,
            value: props.value,
            prevProps: props,
        };
        _this.show = _this.show.bind(_this);
        _this.hide = _this.hide.bind(_this);
        _this.confirm = _this.confirm.bind(_this);
        return _this;
    }
    Sortable.getDerivedStateFromProps = function (props, state) {
        var prevProps = state.prevProps;
        if (prevProps.value !== props.value) {
            return __assign(__assign({}, state), { value: props.value, prevProps: props });
        }
        else {
            return null;
        }
    };
    Sortable.prototype.show = function () {
        this.setState({ show: true });
    };
    Sortable.prototype.hide = function () {
        this.setState({ show: false, value: this.props.value });
    };
    Sortable.prototype.confirm = function () {
        var _this = this;
        var value = __spreadArray([], this.state.value);
        this.setState({ show: false, value: this.props.value }, function () {
            var onChange = _this.props.onChange;
            onChange && onChange(value);
        });
    };
    Sortable.prototype.sort = function (by, prefer, order) {
        if (prefer === void 0) { prefer = 'desc'; }
        var newItem;
        if (order === prefer) {
            if (prefer === 'desc') {
                newItem = { by: by, order: 'asc' };
            }
            else {
                newItem = { by: by, order: 'desc' };
            }
        }
        else if (!order) {
            newItem = { by: by, order: prefer };
        }
        var value;
        if (this.props.multiple === false) {
            value = [];
        }
        else {
            value = this.state.value.filter(function (v) { return v.by !== by; });
        }
        if (newItem) {
            value.push(newItem);
        }
        this.setState({ value: value });
    };
    Sortable.prototype.render = function () {
        var _this = this;
        var _a = this.props, columns = _a.columns, sortButton = _a.sortButton, ascIcon = _a.ascIcon, descIcon = _a.descIcon, sortIcon = _a.sortIcon, cancelButtonText = _a.cancelButtonText, confirmButtonText = _a.confirmButtonText;
        var _b = this.state, show = _b.show, _c = _b.value, value = _c === void 0 ? [] : _c;
        return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx("div", __assign({ className: bem(), onClick: this.show }, { children: sortButton || (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx("span", { children: locale_1.i18n().sorting }, void 0),
                            jsx_runtime_1.jsx(icon_1.Icon, { name: "sort" }, void 0)] }, void 0)) }), void 0),
                jsx_runtime_1.jsx(popup_1.Popup, __assign({ className: bem('popup'), show: show, position: "top", onClickClose: this.hide }, { children: jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx("div", __assign({ className: bem('list') }, { children: columns.map(function (_a) {
                                    var key = _a.key, prefer = _a.prefer, header = _a.header;
                                    var sortBy = value.find(function (v) { return v.by === key; });
                                    var order = sortBy === null || sortBy === void 0 ? void 0 : sortBy.order;
                                    return (jsx_runtime_1.jsxs("div", __assign({ className: bem('item', { active: order === 'desc' || order === 'asc' }), onClick: function () { return _this.sort(key, prefer, order); } }, { children: [jsx_runtime_1.jsx("div", __assign({ className: bem('by') }, { children: header }), void 0),
                                            jsx_runtime_1.jsx("div", __assign({ className: bem('order', { empty: !order }) }, { children: order === 'desc' && descIcon ? (descIcon) : order === 'asc' && ascIcon ? (ascIcon) : sortIcon ? (sortIcon) : (jsx_runtime_1.jsx(icon_1.Icon, { name: order === 'desc' ? 'descending' : order === 'asc' ? 'ascending' : 'sort' }, void 0)) }), void 0)] }), key));
                                }) }), void 0),
                            jsx_runtime_1.jsx(toolbar_1.PopupToolbar, { className: bem('footer'), onCancel: this.hide, onConfirm: this.confirm, cancelButtonText: cancelButtonText, confirmButtonText: confirmButtonText }, void 0)] }, void 0) }), void 0)] }, void 0));
    };
    Sortable.defaultProps = {
        value: [],
    };
    return Sortable;
}(react_1.default.PureComponent));
exports.Sortable = Sortable;
