"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataListRecord = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var icon_1 = require("../icon");
var bem_1 = require("../utils/bem");
var locale_1 = require("../locale");
var use_middleware_1 = require("./use-middleware");
var bem = bem_1.createBEM('pant-data-list__record');
var DataListRecord = function (props) {
    var addons = props.addons;
    var _a = react_1.useState(true), collapsed = _a[0], setCollapsed = _a[1];
    var toggle = function () {
        setCollapsed(!collapsed);
    };
    var defaultColumnRender = function (_a) {
        var record = _a.record, column = _a.column;
        return record[column.key];
    };
    var renderRecord = use_middleware_1.useMiddleware(addons, 'onInjectRecord')(function (_a) {
        var columns = _a.columns, recordRender = _a.recordRender, expandButton = _a.expandButton, collapseButton = _a.collapseButton, record = _a.record, recordIndex = _a.recordIndex;
        if (recordRender) {
            return jsx_runtime_1.jsx("div", __assign({ className: bem('fields-wrapper') }, { children: recordRender(record, recordIndex) }), void 0);
        }
        if (!columns) {
            return;
        }
        var expandable = columns.length > 4;
        return (jsx_runtime_1.jsxs("div", __assign({ className: bem('fields-wrapper') }, { children: [jsx_runtime_1.jsx("div", __assign({ className: bem('fields') }, { children: columns
                        .map(function (column, columnIndex) {
                        if (expandable && collapsed && columnIndex >= 3) {
                            return;
                        }
                        var columnRender = column.render || defaultColumnRender;
                        return (jsx_runtime_1.jsxs("div", __assign({ className: bem('field') }, { children: [jsx_runtime_1.jsx("div", __assign({ className: bem('title') }, { children: typeof column.header === 'function' ? column.header(column) : column.header }), void 0),
                                jsx_runtime_1.jsx("div", __assign({ className: bem('value') }, { children: columnRender({ record: record, recordIndex: recordIndex, column: column, columnIndex: columnIndex }) }), void 0)] }), column.key));
                    })
                        .filter(Boolean) }), void 0),
                expandable ? (jsx_runtime_1.jsx("div", __assign({ className: bem('expand'), onClick: toggle }, { children: expandButton && collapsed ? (expandButton) : collapseButton && !collapsed ? (collapseButton) : (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsx("span", { children: collapsed ? locale_1.i18n().expand : locale_1.i18n().collapse }, void 0),
                            jsx_runtime_1.jsx(icon_1.Icon, { name: collapsed ? 'arrow-down' : 'arrow-up' }, void 0)] }, void 0)) }), void 0)) : null] }), void 0));
    });
    return jsx_runtime_1.jsx("div", __assign({ className: bem() }, { children: renderRecord(props) }), void 0);
};
exports.DataListRecord = DataListRecord;
