import React from 'react';
import { RowRenderOptions } from './data-list-record';
import { RecordKey } from './key-selector';
import { DataListAddon } from '.';
import './index.scss';
export declare type DataListColumn<T = Record<string, any>> = {
    key: string;
    header: React.ReactNode | ((column: DataListColumn<T>) => React.ReactNode);
    render?: (options: RowRenderOptions<T>) => React.ReactNode;
};
export declare type DataListProps<T = Record<string, any>> = {
    records: T[];
    recordKey?: RecordKey<T>;
    recordRender?: (record: T, recordIndex: number) => JSX.Element;
    listRender?: (records: T[]) => JSX.Element;
    expandButton?: JSX.Element;
    collapseButton?: JSX.Element;
    columns?: DataListColumn<T>[];
    addons?: DataListAddon[];
    topTip?: React.ReactNode;
    noDataMsg?: React.ReactNode;
};
declare type DataListState = Record<string, any>;
export declare class DataList<T = Record<string, any>> extends React.PureComponent<DataListProps<T>, DataListState> {
    static defaultProps: {};
    constructor(props: DataListProps<T>);
    render(): JSX.Element;
}
export {};
