import React from 'react';
import { StandardColumnItem, PickerProps } from '../picker';
import './index.scss';
export declare type DatetimeType = 'date' | 'datetime' | 'time' | 'yearmonth';
export declare type DatetimePickerProps = Pick<PickerProps, 'showToolbar' | 'toolbarPosition' | 'cancelButtonText' | 'confirmButtonText'> & {
    type?: DatetimeType;
    seconds?: boolean;
    min?: Date;
    max?: Date;
    defaultValue?: Date;
    title?: string;
    prefixZero?: boolean;
    seperator?: boolean;
    formatter?: (text: string, type: 'y' | 'm' | 'd' | 'h' | 'mm' | 's') => string;
    closePopup?: (confirm?: boolean) => void;
    onChange?: (value: Date) => void;
    onConfirm?: (value: Date) => void;
    onCancel?: () => void;
};
declare type DatetimePickerState = {
    columns: StandardColumnItem[][];
    pickerValue: string[];
    viewPickerValue: string[];
};
export declare class DatetimePicker extends React.PureComponent<DatetimePickerProps, DatetimePickerState> {
    static defaultProps: {
        type: string;
        showToolbar: boolean;
        toolbarPosition: string;
        seconds: boolean;
        prefixZero: boolean;
        seperator: boolean;
        formatter: (text: string) => string;
        min: Date;
        max: Date;
    };
    constructor(props: DatetimePickerProps);
    getValue(value?: string[]): Date;
    clearValue(cb: () => void): void;
    range(start: number, end: number): number[];
    prefixZero(n: string | number): string;
    getMonthDays(year: string | number, month: string | number): number;
    genTimePickerColumns(pickerValue: string[]): StandardColumnItem[][];
    genColumns(pickerValue: string[]): StandardColumnItem[][];
    genPickerValue(date?: Date): string[];
    onChange(pickerValue: string[]): void;
    onConfirm(): void;
    onCancel(): void;
    render(): JSX.Element;
}
export {};
