"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dialog = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importStar(require("react"));
var clsx_1 = __importDefault(require("clsx"));
var button_1 = require("../button");
var overlay_1 = require("../overlay");
var transition_1 = require("../transition");
var utils_1 = require("../utils");
var locale_1 = require("../locale");
var bem_1 = require("../utils/bem");
var constant_1 = require("../utils/constant");
require("./index.scss");
var bem = bem_1.createBEM('pant-dialog');
function genButtons(props) {
    var _a;
    var showConfirmButton = props.showConfirmButton, showCancelButton = props.showCancelButton;
    var multiple = showConfirmButton && showCancelButton;
    if (!showConfirmButton && !showCancelButton) {
        return;
    }
    return (jsx_runtime_1.jsxs("div", __assign({ className: clsx_1.default(constant_1.BORDER_TOP, bem('footer', { buttons: multiple })) }, { children: [props.showCancelButton && (jsx_runtime_1.jsx(button_1.Button, { size: "large", className: bem('cancel'), loading: props.cancelLoading, text: props.cancelButtonText || locale_1.i18n().cancel, style: { color: props.cancelButtonColor }, onClick: props.onCancelClick }, void 0)),
            props.showConfirmButton && (jsx_runtime_1.jsx(button_1.Button, { size: "large", className: clsx_1.default(bem('confirm'), (_a = {}, _a[constant_1.BORDER_LEFT] = multiple, _a)), loading: props.confirmLoading, text: props.confirmButtonText || locale_1.i18n().confirm, style: { color: props.confirmButtonColor }, onClick: props.onConfirmClick }, void 0))] }), void 0));
}
var Dialog = function (props) {
    var _a;
    var containerRef = react_1.useRef();
    var show = props.show, zIndex = props.zIndex, html = props.html, message = props.message, messageAlign = props.messageAlign;
    var messageNode = props.messageNode;
    var title = props.titleNode || props.title;
    var zIndexRef = react_1.useRef();
    if (!zIndexRef.current) {
        zIndexRef.current = zIndex || utils_1.getIncrementalZIndex();
    }
    var Title = title && jsx_runtime_1.jsx("div", __assign({ className: bem('header', { isolated: !message && !messageNode }) }, { children: title }), void 0);
    var messageClassName = bem('message', (_a = {
            'has-title': title
        },
        _a[messageAlign] = messageAlign,
        _a));
    var Content = (messageNode || message) && (jsx_runtime_1.jsx("div", __assign({ className: bem('content') }, { children: messageNode ? (messageNode) : html ? (jsx_runtime_1.jsx("div", { dangerouslySetInnerHTML: { __html: message }, className: messageClassName }, void 0)) : (jsx_runtime_1.jsx("div", __assign({ className: messageClassName }, { children: message }), void 0)) }), void 0));
    return (jsx_runtime_1.jsxs(react_1.default.Fragment, { children: [props.overlay ? (jsx_runtime_1.jsx(overlay_1.Overlay, { show: show, zIndex: zIndexRef.current, lockScroll: props.lockScroll, onClick: props.cancelOnClickOverlay ? props.onCancelClick : null }, void 0)) : null,
            jsx_runtime_1.jsx(transition_1.Transition, __assign({ customName: props.transition, stage: show ? 'enter' : 'leave', onAfterEnter: show ? props.onOpened : null, onAfterLeave: show ? null : props.onClosed }, { children: jsx_runtime_1.jsxs("div", __assign({ ref: containerRef, role: "dialog", "aria-labelledby": props.title || message, className: clsx_1.default(bem(), props.className), style: { width: utils_1.addUnit(props.width), zIndex: zIndexRef.current } }, { children: [Title, Content, genButtons(props)] }), void 0) }), void 0)] }, void 0));
};
exports.Dialog = Dialog;
exports.Dialog.defaultProps = {
    transition: 'dialog-bounce',
    lockScroll: true,
    overlay: true,
    showConfirmButton: true,
    cancelOnClickOverlay: false,
};
