"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Icon = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var clsx_1 = __importDefault(require("clsx"));
var utils_1 = require("../utils");
var bem_1 = require("../utils/bem");
var info_1 = require("../info");
require("./index.scss");
var bem = bem_1.createBEM('pant-icon');
function isImage(name) {
    return name ? name.indexOf('/') !== -1 : false;
}
var Icon = function (props) {
    var name = props.name;
    var imageIcon = isImage(name);
    return (jsx_runtime_1.jsxs("i", __assign({ className: clsx_1.default(props.classPrefix + (imageIcon ? '' : " " + props.classPrefix + "-" + name), props.className), style: __assign({ color: props.color, fontSize: utils_1.addUnit(props.size) }, props.style), onClick: props.onClick, onTouchStart: props.onTouchStart }, { children: [imageIcon && jsx_runtime_1.jsx("img", { className: bem('image'), src: name }, void 0),
            jsx_runtime_1.jsx(info_1.Info, { dot: props.dot, info: props.info }, void 0)] }), void 0));
};
exports.Icon = Icon;
exports.Icon.defaultProps = {
    classPrefix: 'pant-icon',
};
