"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Loading = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var clsx_1 = __importDefault(require("clsx"));
var utils_1 = require("../utils");
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-loading');
var LoadingIcon = function (props) {
    if (props.type === 'spinner') {
        var Spin = [];
        for (var i = 0; i < 12; i++) {
            Spin.push(jsx_runtime_1.jsx("i", {}, i));
        }
        return jsx_runtime_1.jsx(react_1.default.Fragment, { children: Spin }, void 0);
    }
    return (jsx_runtime_1.jsx("svg", __assign({ className: bem('circular'), viewBox: "25 25 50 50" }, { children: jsx_runtime_1.jsx("circle", { cx: "50", cy: "50", r: "20", fill: "none" }, void 0) }), void 0));
};
var LoadingText = function (props) {
    var children = props.children;
    if (children) {
        var style = props.textSize && {
            fontSize: utils_1.addUnit(props.textSize),
        };
        return (jsx_runtime_1.jsx("span", __assign({ className: bem('text'), style: style }, { children: children }), void 0));
    }
    return null;
};
var Loading = function (props) {
    var color = props.color, size = props.size, type = props.type;
    var style = { color: color };
    if (size) {
        var iconSize = utils_1.addUnit(size);
        style.width = iconSize;
        style.height = iconSize;
    }
    return (jsx_runtime_1.jsxs("div", __assign({ className: clsx_1.default(bem([type, { vertical: props.vertical }]), props.className) }, { children: [jsx_runtime_1.jsx("span", __assign({ className: bem('spinner', type), style: style }, { children: jsx_runtime_1.jsx(LoadingIcon, __assign({}, props), void 0) }), void 0),
            jsx_runtime_1.jsx(LoadingText, __assign({}, props), void 0)] }), void 0));
};
exports.Loading = Loading;
exports.Loading.defaultProps = {
    type: 'circular',
};
