"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.clearAllNotifies = exports.notify = exports.Notify = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_dom_1 = __importDefault(require("react-dom"));
var notify_1 = require("./notify");
require("./index.scss");
var notify_2 = require("./notify");
Object.defineProperty(exports, "Notify", { enumerable: true, get: function () { return notify_2.Notify; } });
var notifyReturnList = [];
function notify(options, type) {
    var opt;
    if (typeof options === 'string') {
        opt = { message: options };
    }
    else {
        opt = options;
    }
    if (type) {
        opt.type = type;
    }
    var message = opt.message;
    var container = document.createElement('div');
    container.className = 'pant-notify-container';
    var onClick = function (event) {
        if (opt.onClick) {
            opt.onClick(event);
        }
        else if (opt.clearOnClick) {
            res.clear();
        }
    };
    var res = {
        clear: function () {
            if (!container) {
                return;
            }
            react_dom_1.default.render(jsx_runtime_1.jsx(notify_1.Notify, __assign({}, opt, { message: message, onClick: onClick, onClosed: function () {
                    document.body.removeChild(container);
                    container = null;
                    opt.onClosed && opt.onClosed();
                } }), void 0), container);
            var index = notifyReturnList.indexOf(res);
            index >= 0 && notifyReturnList.splice(index, 1);
        },
        setMessage: function (msg) {
            if (!container) {
                return;
            }
            message = msg;
            react_dom_1.default.render(jsx_runtime_1.jsx(notify_1.Notify, __assign({}, opt, { message: message, onClick: onClick, show: true }), void 0), container);
        },
    };
    notifyReturnList.push(res);
    document.body.appendChild(container);
    react_dom_1.default.render(jsx_runtime_1.jsx(notify_1.Notify, __assign({}, opt, { onClick: onClick, show: true }), void 0), container);
    if (opt.duration !== 0) {
        setTimeout(res.clear, opt.duration > 0 ? opt.duration : 2000);
    }
    return res;
}
exports.notify = notify;
function clearAllNotifies() {
    notifyReturnList.forEach(function (item) { return item.clear(); });
}
exports.clearAllNotifies = clearAllNotifies;
