import React from 'react';
import './index.scss';
declare type NumberKeyboardProps = {
    title?: string;
    theme?: 'default' | 'custom';
    show?: boolean;
    zIndex?: number;
    extraKey?: string | string[];
    closeButtonText?: string;
    deleteButtonText?: string;
    showDeleteKey?: boolean;
    hideOnClickOutside?: boolean;
    safeAreaInsetBottom?: boolean;
    onClose?: () => void;
    onBlur?: () => void;
    onInput?: (key: string) => void;
    onDelete?: () => void;
    onShow?: () => void;
    onHide?: () => void;
};
declare type NumberKeyboardState = {
    prevShow: boolean;
    prevTitle: string;
    transition: boolean;
};
export declare class NumberKeyboard extends React.PureComponent<NumberKeyboardProps, NumberKeyboardState> {
    static defaultProps: {
        title: string;
        theme: string;
        show: boolean;
        zIndex: number;
        extraKey: string;
        closeButtonText: string;
        showDeleteKey: boolean;
        hideOnClickOutside: boolean;
        safeAreaInsetBottom: boolean;
    };
    static getDerivedStateFromProps(nextProps: NumberKeyboardProps, state: NumberKeyboardState): NumberKeyboardState;
    constructor(props: NumberKeyboardProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    onClickOutside(event: Event): void;
    onTouchStart(event: React.TouchEvent): void;
    onBlur(): void;
    onClose(): void;
    onPress(text: string, type: string): void;
    genBasicKeys(): any[];
    genDefaultKeys(): any[];
    genCustomKeys(): any[];
    onAnimationEnd(): void;
    genTitle(): JSX.Element;
    genKeys(): JSX.Element[];
    genSidebar(): JSX.Element;
    render(): JSX.Element;
}
export {};
