"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Key = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var bem_1 = require("../utils/bem");
var delete_icon_1 = require("./delete-icon");
var collapse_icon_1 = require("./collapse-icon");
var touch_handler_1 = require("../utils/touch-handler");
require("./index.scss");
var bem = bem_1.createBEM('pant-key');
var Key = /** @class */ (function (_super) {
    __extends(Key, _super);
    function Key(props) {
        var _this = _super.call(this, props) || this;
        _this.elRef = react_1.default.createRef();
        _this.state = {
            active: false,
        };
        return _this;
    }
    Key.prototype.componentDidMount = function () {
        this.touchHandler = new touch_handler_1.TouchHandler(this.elRef.current, {
            onTouchStart: this.onTouchStart.bind(this),
            onTouchMove: this.onTouchMove.bind(this),
            onTouchEnd: this.onTouchEnd.bind(this),
        });
    };
    Key.prototype.componentWillUnmount = function () {
        this.touchHandler.destroy();
        this.touchHandler = null;
    };
    Key.prototype.onTouchStart = function (event) {
        // compatible with Vue 2.6 event bubble bug
        event.stopPropagation();
        this.setState({
            active: true,
        });
    };
    Key.prototype.onTouchMove = function () {
        if (this.touchHandler.state.direction) {
            this.setState({
                active: false,
            });
        }
    };
    Key.prototype.onTouchEnd = function () {
        var _a = this.props, text = _a.text, type = _a.type;
        if (this.state.active) {
            // eliminate tap delay on safari
            event.preventDefault();
            this.setState({
                active: false,
            });
            this.props.onPress && this.props.onPress(text, type);
        }
    };
    Key.prototype.genContent = function () {
        var _a = this.props, type = _a.type, text = _a.text;
        var isExtra = type === 'extra';
        var isDelete = type === 'delete';
        if (isDelete) {
            return text || jsx_runtime_1.jsx(delete_icon_1.DeleteIcon, { className: bem('delete-icon') }, void 0);
        }
        if (isExtra) {
            return text || jsx_runtime_1.jsx(collapse_icon_1.CollapseIcon, { className: bem('collapse-icon') }, void 0);
        }
        return text;
    };
    Key.prototype.render = function () {
        var _a = this.props, wider = _a.wider, color = _a.color, large = _a.large, type = _a.type;
        var active = this.state.active;
        return (jsx_runtime_1.jsx("div", __assign({ ref: this.elRef, className: bem('wrapper', { wider: wider }) }, { children: jsx_runtime_1.jsx("div", __assign({ role: "button", className: bem([
                    color,
                    {
                        large: large,
                        active: active,
                        delete: type === 'delete',
                    },
                ]) }, { children: this.genContent() }), void 0) }), void 0));
    };
    return Key;
}(react_1.default.PureComponent));
exports.Key = Key;
