"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Overlay = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var clsx_1 = __importDefault(require("clsx"));
var transition_1 = require("../transition");
var bem_1 = require("../utils/bem");
var dom_1 = require("../utils/dom");
var __1 = require("../");
require("./index.scss");
var bem = bem_1.createBEM('pant-overlay');
var count = 1;
var Overlay = function (props) {
    var countRef = react_1.useRef();
    if (!countRef.current) {
        countRef.current = count++;
    }
    var style = __assign(__assign({ backgroundColor: __1.pantConfig('defaultOverlayBgColor') }, props.style), { zIndex: props.zIndex });
    if (props.duration > 0) {
        style.animationDuration = props.duration + "s";
    }
    react_1.useEffect(function () {
        if (props.lockScroll) {
            return function () { return dom_1.removeClass(document.body, "pant-overflow-hidden-" + countRef.current); };
        }
    }, []);
    var onAfterEnter = react_1.useCallback(function () {
        props.lockScroll && dom_1.addClass(document.body, "pant-overflow-hidden-" + countRef.current);
        props.onAfterEnter && props.onAfterEnter();
    }, [props.onAfterEnter]);
    var onAfterLeave = react_1.useCallback(function () {
        props.lockScroll && dom_1.removeClass(document.body, "pant-overflow-hidden-" + countRef.current);
        props.onAfterLeave && props.onAfterLeave();
    }, [props.onAfterLeave]);
    return (jsx_runtime_1.jsx(transition_1.Transition, __assign({ name: "fade", stage: props.show ? 'enter' : 'leave', onAfterEnter: onAfterEnter, onAfterLeave: onAfterLeave }, { children: jsx_runtime_1.jsx("div", __assign({ style: style, className: clsx_1.default(bem(), props.className), onClick: props.onClick }, { children: props.children }), void 0) }), void 0));
};
exports.Overlay = Overlay;
exports.Overlay.defaultProps = {
    lockScroll: true,
};
