import React from 'react';
import './index.scss';
declare type PasswordInputProps = {
    gutter?: number | string;
    value?: string;
    focused?: boolean;
    mask?: boolean;
    length?: number;
    pointClassName?: string;
    onFocuse?: () => void;
};
declare type PasswordInputState = {
    prevValue: string;
    prevFocused: boolean;
    points: React.ReactNode;
};
export declare class PasswordInput extends React.PureComponent<PasswordInputProps, PasswordInputState> {
    static defaultProps: {
        gutter: number;
        value: string;
        focused: boolean;
        mask: boolean;
        length: number;
    };
    private listEle;
    private touchHandler;
    constructor(props: PasswordInputProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    static getDerivedStateFromProps(nextProps: PasswordInputProps, state: PasswordInputState): PasswordInputState;
    onTouchStart(event: TouchEvent): void;
    render(): JSX.Element;
}
export {};
