"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PasswordInput = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var clsx_1 = __importDefault(require("clsx"));
var utils_1 = require("../utils");
var bem_1 = require("../utils/bem");
var touch_handler_1 = require("../utils/touch-handler");
var constant_1 = require("../utils/constant");
require("./index.scss");
var bem = bem_1.createBEM('pant-password-input');
var getPoints = function (value, length, gutter, focused, mask, pointClassName) {
    var _a;
    var newPoints = [];
    for (var i = 0; i < length; i++) {
        var char = value[i];
        var showBorder = i !== 0 && !gutter;
        var showCursor = focused && i === value.length;
        var style = void 0;
        if (i !== 0 && gutter) {
            style = { marginLeft: utils_1.addUnit(gutter) };
        }
        newPoints.push(jsx_runtime_1.jsxs("li", __assign({ className: clsx_1.default(bem('item', { focus: showCursor }), (_a = {}, _a[constant_1.BORDER_LEFT] = showBorder, _a), pointClassName), style: style }, { children: [mask ? jsx_runtime_1.jsx("i", { style: { visibility: char ? 'visible' : 'hidden' } }, void 0) : char,
                showCursor && jsx_runtime_1.jsx("div", { className: bem('cursor') }, void 0)] }), i));
    }
    return newPoints;
};
var PasswordInput = /** @class */ (function (_super) {
    __extends(PasswordInput, _super);
    function PasswordInput(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            prevValue: '',
            prevFocused: true,
            points: getPoints(props.value, props.length, props.gutter, props.focused, props.mask),
        };
        _this.onTouchStart = _this.onTouchStart.bind(_this);
        return _this;
    }
    PasswordInput.prototype.componentDidMount = function () {
        this.touchHandler = new touch_handler_1.TouchHandler(this.listEle, {
            onTouchStart: this.onTouchStart.bind(this),
        });
    };
    PasswordInput.prototype.componentWillUnmount = function () {
        this.touchHandler.destroy();
        this.touchHandler = null;
    };
    PasswordInput.getDerivedStateFromProps = function (nextProps, state) {
        var value = nextProps.value, length = nextProps.length, gutter = nextProps.gutter, focused = nextProps.focused, mask = nextProps.mask, pointClassName = nextProps.pointClassName;
        var prevValue = state.prevValue, prevFocused = state.prevFocused;
        if (value !== prevValue || focused !== prevFocused) {
            var newPoints = getPoints(value, length, gutter, focused, mask, pointClassName);
            return {
                prevValue: value,
                prevFocused: focused,
                points: newPoints,
            };
        }
        else {
            return null;
        }
    };
    PasswordInput.prototype.onTouchStart = function (event) {
        event.stopPropagation();
        this.props.onFocuse && this.props.onFocuse();
    };
    PasswordInput.prototype.render = function () {
        var _a;
        var _this = this;
        var gutter = this.props.gutter;
        return (jsx_runtime_1.jsx("div", __assign({ className: bem() }, { children: jsx_runtime_1.jsx("ul", __assign({ ref: function (el) {
                    _this.listEle = el;
                }, className: clsx_1.default(bem('security'), (_a = {}, _a[constant_1.BORDER_SURROUND] = !gutter, _a)) }, { children: this.state.points }), void 0) }), void 0));
    };
    PasswordInput.defaultProps = {
        gutter: 0,
        value: '',
        focused: true,
        mask: true,
        length: 6,
    };
    return PasswordInput;
}(react_1.default.PureComponent));
exports.PasswordInput = PasswordInput;
