import React from 'react';
import { StandardColumnItem } from '.';
import './index.scss';
export declare type PickerProps = {
    visibleItemCount: number;
    options: StandardColumnItem[];
    className?: string;
    itemHeight?: number;
    value?: string;
    onChange?: (value: number) => void;
    swipeDuration?: number;
    injectChildren?: (column: PickerColumn) => void;
    disabledValue?: string;
};
declare type PickerState = {
    currentIndex: number;
    offset: number;
    baseOffset: number;
    duration: number;
    moving: boolean;
    prevOptions: StandardColumnItem[];
    prevValue: string;
};
export declare class PickerColumn extends React.PureComponent<PickerProps, PickerState> {
    private listRef;
    private transitionEndTrigger;
    private touchHandler;
    startOffset: number;
    touchStartTime: number;
    momentumOffset: number;
    constructor(props: PickerProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    static getDerivedStateFromProps(nextProps: PickerProps, state: PickerState): PickerState;
    onClickItem(index: number): void;
    adjustIndex(index: number): number;
    setIndex(index: number): void;
    getIndexByOffset(offset: number): number;
    onTouchStart(): void;
    onTouchMove(event: React.TouchEvent): void;
    onTouchEnd(): void;
    momentum(distance: number, duration: number): void;
    genOptions(): any;
    onTransitionEnd(): void;
    stopMomentum(): void;
    render(): JSX.Element;
}
export {};
