import React from 'react';
import './index.scss';
export declare type PopupPosition = 'center' | 'top' | 'bottom' | 'left' | 'right';
export declare type PopupCloseIconPosition = 'top-left' | 'top-right' | 'bottom-left' | 'bottom-right';
export declare type PopupProps = {
    name?: string;
    show?: boolean;
    lazyRender?: boolean;
    round?: boolean;
    duration?: number | string;
    closeable?: boolean;
    closeIcon?: string;
    closeIconPosition?: PopupCloseIconPosition;
    safeAreaInsetBottom?: boolean;
    position?: PopupPosition;
    fadeLeave?: boolean;
    overlay?: boolean;
    closeOnClickOverlay?: boolean;
    lockScroll?: boolean;
    style?: Record<string, string>;
    zIndex?: number | string;
    className?: string;
    children?: React.ReactElement;
    closePopup?(confirm?: boolean): void;
    onClosed?(): void;
    onOpened?(): void;
    onClick?(event: React.MouseEvent, props: PopupProps): void;
    onClickClose?(event: React.MouseEvent, props: PopupProps): void;
};
declare type PopupState = {
    active: boolean;
};
export declare class Popup extends React.PureComponent<PopupProps, PopupState> {
    private id;
    private zIndex;
    private containerRef;
    private childRef;
    private bindedOnClick;
    private bindedOnClickClose;
    private bindedOnClosed;
    private bindedOnOpened;
    state: {
        active: boolean;
    };
    static readonly __FIELD_BEHAVIOR__ = "Popup";
    static defaultProps: {
        closeIcon: string;
        closeIconPosition: string;
        position: string;
        overlay: boolean;
        closeOnClickOverlay: boolean;
        lockScroll: boolean;
    };
    static getDerivedStateFromProps(props: PopupProps): PopupState;
    private onClick;
    private onClickClose;
    private onClosed;
    private onOpened;
    private genChildren;
    getValue(): any;
    clearValue(cb: () => void): void;
    render(): JSX.Element;
}
export {};
