"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Popup = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var clsx_1 = __importDefault(require("clsx"));
var icon_1 = require("../icon");
var overlay_1 = require("../overlay");
var transition_1 = require("../transition");
var utils_1 = require("../utils");
var event_bus_1 = require("../utils/event-bus");
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-popup');
var idStart = Math.floor(Math.random() * 10000);
var Popup = /** @class */ (function (_super) {
    __extends(Popup, _super);
    function Popup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.id = ++idStart;
        _this.zIndex = _this.props.zIndex || utils_1.getIncrementalZIndex();
        _this.containerRef = react_1.default.createRef();
        _this.childRef = react_1.default.createRef();
        _this.bindedOnClick = _this.onClick.bind(_this);
        _this.bindedOnClickClose = _this.onClickClose.bind(_this);
        _this.bindedOnClosed = _this.onClosed.bind(_this);
        _this.bindedOnOpened = _this.onOpened.bind(_this);
        _this.state = {
            active: !!_this.props.show,
        };
        return _this;
    }
    Popup.getDerivedStateFromProps = function (props) {
        if (props.show) {
            return { active: true };
        }
        return null;
    };
    Popup.prototype.onClick = function (event) {
        var props = this.props;
        props.onClick && props.onClick(event, props);
    };
    Popup.prototype.onClickClose = function (event) {
        var props = this.props;
        var onClickClose = props.onClickClose, closePopup = props.closePopup;
        onClickClose && onClickClose(event, props);
        var child = this.childRef.current;
        if (child === null || child === void 0 ? void 0 : child.onCancel) {
            child.onCancel();
        }
        else {
            closePopup && closePopup();
        }
    };
    Popup.prototype.onClosed = function () {
        this.setState({ active: false });
        this.props.onClosed && this.props.onClosed();
    };
    Popup.prototype.onOpened = function () {
        event_bus_1.eventBus.emit('popup.opened', this.id);
        this.props.onOpened && this.props.onOpened();
    };
    Popup.prototype.genChildren = function () {
        var _a = this.props, closePopup = _a.closePopup, children = _a.children;
        if (!children || typeof children === 'string' || typeof children.type === 'string') {
            return children;
        }
        this.childRef = children.ref || this.childRef;
        return react_1.default.cloneElement(children, {
            _popupId: this.id,
            key: children.key,
            ref: this.childRef,
            closePopup: closePopup,
        });
    };
    Popup.prototype.getValue = function () {
        var child = this.childRef.current;
        return child && child.getValue && child.getValue();
    };
    Popup.prototype.clearValue = function (cb) {
        var child = this.childRef.current;
        return child && child.clearValue && child.clearValue(cb);
    };
    Popup.prototype.render = function () {
        var _a;
        var props = this.props;
        if (props.lazyRender && !this.state.active) {
            return null;
        }
        var show = props.show, round = props.round, position = props.position, duration = props.duration;
        var isCenter = position === 'center';
        var transitionName = isCenter || (!show && props.fadeLeave) ? 'fade' : "popup-slide-" + position;
        var style = __assign(__assign({}, props.style), { zIndex: this.zIndex });
        return react_dom_1.default.createPortal(jsx_runtime_1.jsxs(react_1.default.Fragment, { children: [props.overlay ? (jsx_runtime_1.jsx(overlay_1.Overlay, { show: show, zIndex: this.zIndex, lockScroll: props.lockScroll, onClick: props.closeOnClickOverlay ? this.bindedOnClickClose : null }, void 0)) : null,
                jsx_runtime_1.jsx(transition_1.Transition, __assign({ customName: transitionName, stage: show ? 'enter' : 'leave', duration: duration, onAfterEnter: this.bindedOnOpened, onAfterLeave: this.bindedOnClosed }, { children: jsx_runtime_1.jsxs("div", __assign({ ref: this.containerRef, style: style, className: clsx_1.default(bem((_a = {
                                round: round
                            },
                            _a[position] = position,
                            _a['safe-area-inset-bottom'] = props.safeAreaInsetBottom,
                            _a)), props.className), onClick: this.bindedOnClick }, { children: [this.genChildren(), props.closeable && (jsx_runtime_1.jsx(icon_1.Icon, { name: props.closeIcon, className: bem('close-icon', props.closeIconPosition), onClick: this.bindedOnClickClose }, void 0))] }), void 0) }), void 0)] }, void 0), document.body);
    };
    Popup.__FIELD_BEHAVIOR__ = 'Popup';
    Popup.defaultProps = {
        closeIcon: 'cross',
        closeIconPosition: 'top-right',
        position: 'center',
        overlay: true,
        closeOnClickOverlay: true,
        lockScroll: true,
    };
    return Popup;
}(react_1.default.PureComponent));
exports.Popup = Popup;
