"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PopupToolbar = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var clsx_1 = __importDefault(require("clsx"));
var locale_1 = require("../../locale");
var bem_1 = require("../../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-popup-toolbar');
var PopupToolbar = function (props) {
    var className = props.className, title = props.title, cancelButtonText = props.cancelButtonText, confirmButtonText = props.confirmButtonText, onCancel = props.onCancel, onConfirm = props.onConfirm;
    var onlyTitle = !onCancel && !onConfirm;
    return (jsx_runtime_1.jsxs("div", __assign({ className: clsx_1.default(bem({ title: onlyTitle }), className) }, { children: [!onlyTitle ? (jsx_runtime_1.jsx("button", __assign({ type: "button", className: bem('cancel'), onClick: onCancel }, { children: cancelButtonText || locale_1.i18n().cancel }), "cancel")) : null,
            jsx_runtime_1.jsx("div", __assign({ className: clsx_1.default(bem('title'), 'pant-ellipsis') }, { children: title }), "title"),
            !onlyTitle ? (jsx_runtime_1.jsx("button", __assign({ type: "button", className: bem('confirm'), onClick: onConfirm }, { children: confirmButtonText || locale_1.i18n().confirm }), "confirm")) : null] }), void 0));
};
exports.PopupToolbar = PopupToolbar;
