"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Row = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-row');
var Row = function (props) {
    var _a;
    var align = props.align, justify = props.justify;
    var flex = props.type === 'flex';
    var margin = "-" + Number(props.gutter) / 2 + "px";
    var style = props.gutter ? { marginLeft: margin, marginRight: margin } : {};
    var childrenWithProps = []
        .concat(props.children)
        .map(function (child, i) { return react_1.default.cloneElement(child, { key: i, gutter: props.gutter }); });
    return (jsx_runtime_1.jsx("div", __assign({ style: style, className: bem((_a = {
                flex: flex
            },
            _a["align-" + align] = flex && align,
            _a["justify-" + justify] = flex && justify,
            _a)), onClick: props.onClick }, { children: childrenWithProps }), void 0));
};
exports.Row = Row;
exports.Row.defaultProps = {
    gutter: 0,
};
