"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Search = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var field_1 = require("../field");
var locale_1 = require("../locale");
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-search');
var Search = function (props) {
    var fieldRef = react_1.useRef();
    function Label() {
        if (props.label) {
            return jsx_runtime_1.jsx("div", __assign({ className: bem('label') }, { children: props.label }), void 0);
        }
    }
    function Action() {
        if (!props.showAction) {
            return;
        }
        function onSearch() {
            if (props.disabled) {
                return;
            }
            props.onSearch && props.onSearch(fieldRef.current.getValue());
        }
        if (props.actionNode) {
            return (jsx_runtime_1.jsx("div", __assign({ className: bem('custom-action'), onClick: onSearch }, { children: props.actionNode }), void 0));
        }
        return (jsx_runtime_1.jsx("div", __assign({ className: bem('action', { disabled: props.disabled }), role: "button", tabIndex: 0, onClick: onSearch }, { children: props.actionText || locale_1.i18n().search }), void 0));
    }
    return (jsx_runtime_1.jsxs("div", __assign({ className: bem({ 'show-action': props.showAction }), style: { background: props.background } }, { children: [jsx_runtime_1.jsxs("div", __assign({ className: bem('content', props.shape) }, { children: [Label(), jsx_runtime_1.jsx(field_1.Field, { ref: fieldRef, name: "search", type: "search", border: false, placeholder: props.placeholder, inputAlign: props.inputAlign, disabled: props.disabled, defaultValue: props.defaultValue, icon: props.icon || undefined, clearable: props.clearable, clearTrigger: props.clearTrigger, onChange: props.onChange }, void 0)] }), void 0), Action()] }), void 0));
};
exports.Search = Search;
exports.Search.defaultProps = {
    shape: 'sqaure',
    icon: 'search',
    clearable: true,
};
