"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchablePicker = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var clsx_1 = __importDefault(require("clsx"));
var lodash_es_1 = require("lodash-es");
var react_virtualized_1 = require("react-virtualized"); /* eslint-disable-line */
var toast_1 = require("../toast");
var icon_1 = require("../icon");
var loading_1 = require("../loading");
var toolbar_1 = require("../popup/toolbar");
var search_1 = require("../search");
var locale_1 = require("../locale");
var utils_1 = require("../utils");
var event_bus_1 = require("../utils/event-bus");
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-searchable-picker');
var SearchablePicker = /** @class */ (function (_super) {
    __extends(SearchablePicker, _super);
    function SearchablePicker(props) {
        var _a, _b;
        var _this = _super.call(this, props) || this;
        _this.contentRef = react_1.default.createRef();
        var defaultValue = typeof props.defaultValue === 'string'
            ? props.defaultValue
                ? [props.defaultValue]
                : undefined
            : props.defaultValue;
        _this.state = {
            pickerValue: __spreadArray([], (defaultValue || [])),
            rollbackPickerValue: __spreadArray([], (defaultValue || [])),
            contentWidth: 0,
            contentHeight: 0,
            searchText: '',
            loading: false,
            data: props.data || [],
            total: (_b = (_a = props.data) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0,
            prevProps: props,
        };
        _this.select = _this.select.bind(_this);
        _this.setLoadResult = _this.setLoadResult.bind(_this);
        _this.showLoading = _this.showLoading.bind(_this);
        _this.hideLoading = _this.hideLoading.bind(_this);
        _this.onSearchChange = lodash_es_1.debounce(_this.onSearchChange.bind(_this), 500);
        _this.onPopupOpened = _this.onPopupOpened.bind(_this);
        _this.rowRenderer = _this.rowRenderer.bind(_this);
        _this.isRowLoaded = _this.isRowLoaded.bind(_this);
        _this.loadMoreRows = _this.loadMoreRows.bind(_this);
        _this.onCancel = _this.onCancel.bind(_this);
        _this.onConfirm = _this.onConfirm.bind(_this);
        return _this;
    }
    SearchablePicker.getDerivedStateFromProps = function (props, state) {
        var _a, _b;
        var prevProps = state.prevProps;
        if (props.data !== prevProps.data || props.defaultValue !== prevProps.defaultValue) {
            var defaultValue = typeof props.defaultValue === 'string'
                ? props.defaultValue
                    ? [props.defaultValue]
                    : undefined
                : props.defaultValue;
            return __assign(__assign(__assign(__assign({}, state), { pickerValue: __spreadArray([], (defaultValue || [])), rollbackPickerValue: __spreadArray([], (defaultValue || [])) }), (props.data !== prevProps.data
                ? {
                    data: props.data || [],
                    total: (_b = (_a = props.data) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0,
                }
                : {})), { prevProps: props });
        }
        return null;
    };
    SearchablePicker.prototype.componentDidMount = function () {
        event_bus_1.eventBus.on('popup.opened', this.onPopupOpened);
        var _a = this.props, _popupId = _a._popupId, data = _a.data, onLoad = _a.onLoad, firstLoadLimit = _a.firstLoadLimit;
        if (!_popupId) {
            this.setState({
                contentWidth: this.contentRef.current.clientWidth,
                contentHeight: this.contentRef.current.clientHeight,
            });
        }
        if (onLoad) {
            this.showLoading();
            onLoad({ text: '', prevData: __spreadArray([], data), offset: 0, limit: firstLoadLimit })
                .then(this.setLoadResult)
                .finally(this.hideLoading);
        }
    };
    SearchablePicker.prototype.componentWillUnmount = function () {
        event_bus_1.eventBus.off('popup.opened', this.onPopupOpened);
    };
    SearchablePicker.prototype.getValue = function () {
        var maxSelection = this.props.maxSelection;
        var pickerValue = this.state.pickerValue;
        if (maxSelection === 1) {
            return pickerValue[0];
        }
        return __spreadArray([], pickerValue);
    };
    SearchablePicker.prototype.clearValue = function (cb) {
        var _this = this;
        this.setState({ pickerValue: [], rollbackPickerValue: [] }, function () {
            _this.listInstance && _this.listInstance.forceUpdateGrid();
            cb();
        });
    };
    SearchablePicker.prototype.getDataList = function () {
        return __spreadArray([], this.state.data);
    };
    SearchablePicker.prototype.setLoadResult = function (res) {
        var data = res.data, total = res.total, _a = res.params, loadMore = _a.loadMore, offset = _a.offset, limit = _a.limit;
        var newData = data || [];
        if (loadMore) {
            var prevData = this.state.data;
            var len = prevData.length;
            if (len < offset) {
                newData = __spreadArray(__spreadArray(__spreadArray([], prevData), new Array(offset - len).fill(null)), data);
            }
            else {
                newData = __spreadArray(__spreadArray([], prevData.slice(0, offset)), data);
                if (len > offset + limit) {
                    newData = __spreadArray(__spreadArray([], newData), prevData.slice(offset + limit));
                }
            }
        }
        this.setState({ data: newData, total: total, loading: false });
    };
    SearchablePicker.prototype.showLoading = function () {
        this.setState({ loading: true });
    };
    SearchablePicker.prototype.hideLoading = function () {
        this.setState({ loading: false });
    };
    SearchablePicker.prototype.onSearchChange = function (text) {
        var _this = this;
        var _a = this.props, onLoad = _a.onLoad, firstLoadLimit = _a.firstLoadLimit;
        var data = this.state.data;
        if (onLoad) {
            this.setState({ searchText: text }, function () {
                _this.showLoading();
                onLoad({ text: text, prevData: __spreadArray([], data), offset: 0, limit: firstLoadLimit })
                    .then(_this.setLoadResult)
                    .finally(_this.hideLoading);
            });
        }
        else {
            var data_1;
            if (!text) {
                data_1 = this.props.data;
            }
            else {
                text = text.toLocaleLowerCase();
                data_1 = this.props.data.filter(function (item) {
                    item = _this.normalizeItem(item);
                    if (item.label.toLowerCase().indexOf(text) >= 0) {
                        return true;
                    }
                    else {
                        if (item.label === item.value) {
                            return false;
                        }
                        else if (item.value.toLowerCase().indexOf(text) >= 0) {
                            return true;
                        }
                    }
                });
            }
            this.setState({ data: data_1, total: data_1.length, searchText: text });
        }
    };
    SearchablePicker.prototype.onPopupOpened = function (id) {
        if (id === this.props._popupId) {
            this.setState({ contentWidth: this.contentRef.current.clientWidth });
            this.setState({ contentHeight: this.contentRef.current.clientHeight });
            this.listInstance && this.listInstance.forceUpdateGrid();
        }
    };
    SearchablePicker.prototype.genToolbar = function (top) {
        var props = this.props;
        if (!props.showToolbar) {
            if (!props.title || !top) {
                return;
            }
            if (top) {
                return (jsx_runtime_1.jsx("div", __assign({ className: bem('toolbar', { title: true }) }, { children: jsx_runtime_1.jsx("div", __assign({ className: clsx_1.default(bem('title'), 'pant-ellipsis') }, { children: props.title }), "title") }), void 0));
            }
        }
        if (props.toolbarPosition === 'top') {
            if (top) {
                return (jsx_runtime_1.jsx(toolbar_1.PopupToolbar, { title: props.title, cancelButtonText: props.cancelButtonText || locale_1.i18n().cancel, confirmButtonText: props.confirmButtonText || locale_1.i18n().confirm, onCancel: this.onCancel, onConfirm: this.onConfirm }, void 0));
            }
        }
        else {
            if (top) {
                if (props.title) {
                    return jsx_runtime_1.jsx(toolbar_1.PopupToolbar, { title: props.title }, void 0);
                }
            }
            else {
                return (jsx_runtime_1.jsx(toolbar_1.PopupToolbar, { cancelButtonText: props.cancelButtonText || locale_1.i18n().cancel, confirmButtonText: props.confirmButtonText || locale_1.i18n().confirm, onCancel: this.onCancel, onConfirm: this.onConfirm }, void 0));
            }
        }
    };
    SearchablePicker.prototype.onConfirm = function () {
        var _this = this;
        this.setState({ rollbackPickerValue: __spreadArray([], this.state.pickerValue) }, function () {
            _this.listInstance && _this.listInstance.forceUpdateGrid();
            var _a = _this.props, closePopup = _a.closePopup, onConfirm = _a.onConfirm;
            onConfirm && onConfirm(_this.getValue());
            closePopup && closePopup(true);
        });
    };
    SearchablePicker.prototype.onCancel = function () {
        var _this = this;
        this.setState({ pickerValue: __spreadArray([], this.state.rollbackPickerValue) }, function () {
            _this.listInstance && _this.listInstance.forceUpdateGrid();
            var _a = _this.props, closePopup = _a.closePopup, onCancel = _a.onCancel;
            onCancel && onCancel();
            closePopup && closePopup();
        });
    };
    SearchablePicker.prototype.normalizeItem = function (item) {
        if (typeof item === 'string') {
            return {
                value: item,
                label: item,
            };
        }
        var _a = this.props, valueKey = _a.valueKey, labelKey = _a.labelKey;
        var value = lodash_es_1.get(item, valueKey, '') + '';
        return __assign(__assign({}, item), { value: value, label: lodash_es_1.get(item, labelKey, value) });
    };
    SearchablePicker.prototype.select = function (index) {
        var _this = this;
        var _a = this.props, maxSelection = _a.maxSelection, onChange = _a.onChange, onSelectionExceeds = _a.onSelectionExceeds, maxSelectionMsg = _a.maxSelectionMsg;
        var _b = this.state, pickerValue = _b.pickerValue, data = _b.data;
        var item = this.normalizeItem(data[index]);
        var newPickerValue;
        if (pickerValue.indexOf(item.value) >= 0) {
            if (maxSelection <= 1) {
                newPickerValue = [];
            }
            else {
                newPickerValue = pickerValue.filter(function (val) { return val !== item.value; });
            }
        }
        else {
            if (maxSelection <= 1) {
                newPickerValue = [item.value];
            }
            else if (pickerValue.length < maxSelection) {
                newPickerValue = __spreadArray(__spreadArray([], pickerValue), [item.value]);
            }
            else {
                newPickerValue = pickerValue;
                if (onSelectionExceeds) {
                    onSelectionExceeds();
                }
                else {
                    toast_1.toast(utils_1.interpolate(maxSelectionMsg || locale_1.i18n().maxSelection, [maxSelection]));
                }
                return;
            }
        }
        this.setState({ pickerValue: newPickerValue }, function () {
            _this.listInstance && _this.listInstance.forceUpdateGrid();
            onChange && onChange(_this.getValue());
        });
    };
    SearchablePicker.prototype.rowRenderer = function (rowProps) {
        var _this = this;
        var key = rowProps.key, // Unique key within array of rows
        index = rowProps.index, // Index of row within collection
        style = rowProps.style;
        var _a = this.state, data = _a.data, pickerValue = _a.pickerValue;
        var rawItem = data[index];
        if (!rawItem) {
            return jsx_runtime_1.jsx("div", { style: style, className: bem('item') }, key);
        }
        var item = this.normalizeItem(rawItem);
        var selected = pickerValue.indexOf(item.value) >= 0;
        var _b = this.props, rowRenderer = _b.rowRenderer, checkedIcon = _b.checkedIcon, uncheckedIcon = _b.uncheckedIcon;
        if (rowRenderer) {
            return rowRenderer(__assign(__assign({}, rowProps), { selected: selected, item: item, select: this.select }));
        }
        return (jsx_runtime_1.jsxs("div", __assign({ style: style, className: bem('item', { selected: selected }), onClick: function () { return _this.select(index); } }, { children: [jsx_runtime_1.jsx("span", { children: item.label }, void 0),
                selected ? (checkedIcon !== undefined ? (checkedIcon) : (jsx_runtime_1.jsx(icon_1.Icon, { name: "passed" }, void 0))) : uncheckedIcon !== undefined ? (uncheckedIcon) : (jsx_runtime_1.jsx(icon_1.Icon, { name: "circle" }, void 0))] }), key));
    };
    SearchablePicker.prototype.isRowLoaded = function (_a) {
        var index = _a.index;
        var data = this.state.data;
        return !!data[index];
    };
    SearchablePicker.prototype.loadMoreRows = function (_a) {
        var startIndex = _a.startIndex, stopIndex = _a.stopIndex;
        var onLoad = this.props.onLoad;
        var _b = this.state, data = _b.data, searchText = _b.searchText;
        if (!onLoad) {
            return;
        }
        this.setState({ loading: true });
        return onLoad({
            text: searchText,
            offset: startIndex,
            limit: stopIndex - startIndex + 1,
            prevData: data,
            loadMore: true,
        })
            .then(this.setLoadResult)
            .finally(this.hideLoading);
    };
    SearchablePicker.prototype.render = function () {
        var _this = this;
        var _a = this.props, _popupId = _a._popupId, height = _a.height, rowHeight = _a.rowHeight, fullscreen = _a.fullscreen, searchable = _a.searchable, noDataMsg = _a.noDataMsg;
        var _b = this.state, contentWidth = _b.contentWidth, contentHeight = _b.contentHeight, loading = _b.loading, data = _b.data, total = _b.total;
        return (jsx_runtime_1.jsxs("div", __assign({ className: bem({ fullscreen: fullscreen }), style: { height: fullscreen ? '100%' : _popupId ? 'auto' : utils_1.addUnit(height) } }, { children: [this.genToolbar(true), searchable ? (jsx_runtime_1.jsx(search_1.Search, { onChange: this.onSearchChange, icon: loading ? jsx_runtime_1.jsx(loading_1.Loading, { size: 16 }, void 0) : undefined }, void 0)) : null,
                jsx_runtime_1.jsx("div", __assign({ className: bem('content-wrapper') }, { children: jsx_runtime_1.jsx("div", __assign({ ref: this.contentRef, className: bem('content') }, { children: data.length ? (jsx_runtime_1.jsx(react_virtualized_1.InfiniteLoader, __assign({ isRowLoaded: this.isRowLoaded, loadMoreRows: this.loadMoreRows, rowCount: total }, { children: function (_a) {
                                var onRowsRendered = _a.onRowsRendered, registerChild = _a.registerChild;
                                return (jsx_runtime_1.jsx(react_virtualized_1.List, { ref: function (list) {
                                        _this.listInstance = list;
                                        registerChild(list);
                                    }, onRowsRendered: onRowsRendered, width: contentWidth, height: contentHeight, rowCount: total, rowHeight: rowHeight, rowRenderer: _this.rowRenderer }, void 0));
                            } }), void 0)) : loading ? null : (jsx_runtime_1.jsx("div", __assign({ className: bem('msg') }, { children: noDataMsg || locale_1.i18n().noData }), void 0)) }), void 0) }), void 0), this.genToolbar()] }), void 0));
    };
    SearchablePicker.defaultProps = {
        height: 300,
        rowHeight: 36,
        maxSelection: 1,
        firstLoadLimit: 20,
        searchable: true,
        showToolbar: true,
        toolbarPosition: 'top',
        valueKey: 'value',
        labelKey: 'label',
        data: [],
    };
    return SearchablePicker;
}(react_1.default.PureComponent));
exports.SearchablePicker = SearchablePicker;
