"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Skeleton = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var utils_1 = require("../utils");
var bem_1 = require("../utils/bem");
require("./index.scss");
var DEFAULT_ROW_WIDTH = '100%';
var DEFAULT_LAST_ROW_WIDTH = '60%';
var bem = bem_1.createBEM('pant-skeleton');
var Skeleton = function (props) {
    if (!props.loading) {
        return jsx_runtime_1.jsx(react_1.default.Fragment, { children: props.children }, void 0);
    }
    function Title() {
        if (props.title) {
            return jsx_runtime_1.jsx("h3", { className: bem('title'), style: { width: utils_1.addUnit(props.titleWidth) } }, void 0);
        }
    }
    function Rows() {
        var Rows = [];
        var rowWidth = props.rowWidth;
        function getRowWidth(index) {
            if (rowWidth === DEFAULT_ROW_WIDTH && index === +props.row - 1) {
                return DEFAULT_LAST_ROW_WIDTH;
            }
            if (Array.isArray(rowWidth)) {
                return rowWidth[index];
            }
            return rowWidth;
        }
        for (var i = 0; i < props.row; i++) {
            Rows.push(jsx_runtime_1.jsx("div", { className: bem('row'), style: { width: utils_1.addUnit(getRowWidth(i)) } }, i));
        }
        return Rows;
    }
    function Avatar() {
        if (props.avatar) {
            var size = utils_1.addUnit(props.avatarSize);
            return jsx_runtime_1.jsx("div", { className: bem('avatar', props.avatarShape), style: { width: size, height: size } }, void 0);
        }
    }
    return (jsx_runtime_1.jsxs("div", __assign({ className: bem({ animate: props.animate }) }, { children: [Avatar(), jsx_runtime_1.jsxs("div", __assign({ className: bem('content') }, { children: [Title(), Rows()] }), void 0)] }), void 0));
};
exports.Skeleton = Skeleton;
exports.Skeleton.defaultProps = {
    row: 0,
    loading: true,
    animate: true,
    avatarSize: '32px',
    avatarShape: 'round',
    titleWidth: '40%',
    rowWidth: DEFAULT_ROW_WIDTH,
};
