"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubmitBar = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var icon_1 = require("../icon");
var button_1 = require("../button");
var locale_1 = require("../locale");
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-submit-bar');
var SubmitBar = function (props) {
    var tip = props.tip, price = props.price, tipIcon = props.tipIcon;
    function Text() {
        if (typeof price === 'number') {
            var priceArr = (price / 100).toFixed(props.decimalLength).split('.');
            var decimalStr = props.decimalLength ? "." + priceArr[1] : '';
            return (jsx_runtime_1.jsxs("div", __assign({ style: { textAlign: props.textAlign ? props.textAlign : undefined }, className: bem('text') }, { children: [jsx_runtime_1.jsx("span", { children: props.label }, void 0),
                    jsx_runtime_1.jsxs("span", __assign({ className: bem('price') }, { children: [props.currency, jsx_runtime_1.jsx("span", __assign({ className: bem('price', 'integer') }, { children: priceArr[0] }), void 0), decimalStr] }), void 0),
                    props.suffixLabel && jsx_runtime_1.jsx("span", __assign({ className: bem('suffix-label') }, { children: props.suffixLabel }), void 0)] }), void 0));
        }
    }
    function Tip() {
        if (props.tip || props.tipNode) {
            return (jsx_runtime_1.jsxs("div", __assign({ className: bem('tip') }, { children: [tipIcon && jsx_runtime_1.jsx(icon_1.Icon, { className: bem('tip-icon'), name: tipIcon }, void 0),
                    tip && jsx_runtime_1.jsx("span", __assign({ className: bem('tip-text') }, { children: tip }), void 0), props.tipNode] }), void 0));
        }
    }
    return (jsx_runtime_1.jsxs("div", __assign({ className: bem({ 'safe-area-inset-bottom': props.safeAreaInsetBottom }) }, { children: [props.topNode, Tip(), jsx_runtime_1.jsxs("div", __assign({ className: bem('bar') }, { children: [props.children, Text(), jsx_runtime_1.jsx(button_1.Button, { round: true, className: bem('button', props.buttonType), type: props.buttonType, loading: props.loading, disabled: props.disabled, text: props.loading ? '' : props.buttonText || locale_1.i18n().submit, onClick: props.onSubmit }, void 0)] }), void 0)] }), void 0));
};
exports.SubmitBar = SubmitBar;
exports.SubmitBar.defaultProps = {
    decimalLength: 2,
    currency: '¥',
    buttonType: 'danger',
};
