"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Switch = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var loading_1 = require("../loading");
var utils_1 = require("../utils");
var bem_1 = require("../utils/bem");
var constant_1 = require("../utils/constant");
require("./index.scss");
var bem = bem_1.createBEM('pant-switch');
var Switch = function (props) {
    var on = props.on, loading = props.loading, disabled = props.disabled;
    var style = __assign(__assign({}, props.style), { fontSize: utils_1.addUnit(props.size), backgroundColor: on ? props.activeColor : props.inactiveColor });
    function onClick(event) {
        if (loading || disabled) {
            return;
        }
        props.onClick && props.onClick(event, props);
    }
    function genLoading() {
        if (props.loading) {
            var color = on ? props.activeColor || constant_1.BLUE : props.inactiveColor || '';
            return jsx_runtime_1.jsx(loading_1.Loading, { className: bem('loading'), color: color }, void 0);
        }
    }
    return (jsx_runtime_1.jsx("div", __assign({ className: bem({
            on: on,
            loading: loading,
            disabled: disabled,
        }), role: "switch", style: style, "aria-checked": !!on, onClick: onClick }, { children: jsx_runtime_1.jsx("div", __assign({ className: bem('node') }, { children: genLoading() }), void 0) }), void 0));
};
exports.Switch = Switch;
