"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Title = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var clsx_1 = __importDefault(require("clsx"));
var info_1 = require("../info");
var bem_1 = require("../utils/bem");
require("./index.scss");
var bem = bem_1.createBEM('pant-tab');
var Title = function (props) {
    var dot = props.dot, type = props.type, info = props.info, color = props.color, title = props.title, titleNode = props.titleNode, scrollable = props.scrollable, disabled = props.disabled, isActive = props.isActive, ellipsis = props.ellipsis, activeColor = props.activeColor, inactiveColor = props.inactiveColor, swipeThreshold = props.swipeThreshold;
    var getStyle = function () {
        var style = {};
        var isCard = type === 'card';
        // card theme color
        if (color && isCard) {
            style.borderColor = color;
            if (!disabled) {
                if (isActive) {
                    style.backgroundColor = color;
                }
                else {
                    style.color = color;
                }
            }
        }
        var titleColor = isActive ? activeColor : inactiveColor;
        if (titleColor) {
            style.color = titleColor;
        }
        if (scrollable && ellipsis) {
            style.flexBasis = 88 / +swipeThreshold + "%";
        }
        return style;
    };
    var onClick = function (evt) {
        props.onClick(evt, props);
    };
    return (jsx_runtime_1.jsx("div", __assign({ role: "tab", "aria-selected": isActive, className: clsx_1.default(bem({
            active: isActive,
            disabled: disabled,
        }), {
            'pant-ellipsis': ellipsis,
        }), style: getStyle(), onClick: onClick }, { children: jsx_runtime_1.jsxs("span", __assign({ className: bem('text') }, { children: [titleNode || title, jsx_runtime_1.jsx(info_1.Info, { dot: dot, info: info }, void 0)] }), void 0) }), void 0));
};
exports.Title = Title;
exports.Title.defaultProps = {
    type: 'line',
};
