"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tag = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var clsx_1 = __importDefault(require("clsx"));
var icon_1 = require("../icon");
var bem_1 = require("../utils/bem");
var constant_1 = require("../utils/constant");
require("./index.scss");
var bem = bem_1.createBEM('pant-tag');
var Tag = function (props) {
    var _a, _b;
    var type = props.type, mark = props.mark, plain = props.plain, color = props.color, round = props.round, size = props.size;
    var key = plain ? 'color' : 'backgroundColor';
    var style = (_a = {}, _a[key] = color, _a);
    if (props.textColor) {
        style.color = props.textColor;
    }
    var classes = { mark: mark, plain: plain, round: round };
    if (size) {
        classes[size] = size;
    }
    var CloseIcon = props.closeable && (jsx_runtime_1.jsx(icon_1.Icon, { name: "cross", className: bem('close'), onClick: function (event) {
            event.stopPropagation();
            props.onClose && props.onClose();
        } }, void 0));
    return (jsx_runtime_1.jsxs("span", __assign({ style: style, className: clsx_1.default(bem([classes, type]), (_b = {}, _b[constant_1.BORDER_SURROUND] = plain, _b)) }, { children: [props.children, CloseIcon] }), "content"));
};
exports.Tag = Tag;
exports.Tag.defaultProps = {
    type: 'default',
};
