"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.clearAllToasts = exports.toast = exports.Toast = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_dom_1 = __importDefault(require("react-dom"));
var toast_1 = require("./toast");
require("./index.scss");
var toast_2 = require("./toast");
Object.defineProperty(exports, "Toast", { enumerable: true, get: function () { return toast_2.Toast; } });
var toastReturnList = [];
function toast(options) {
    var opt;
    if (typeof options === 'string') {
        opt = { message: options };
    }
    else {
        opt = options;
    }
    var message = opt.message;
    var container = document.createElement('div');
    container.className = 'pant-toast-container';
    var onClick = function (event) {
        if (opt.onClick) {
            opt.onClick(event);
        }
        else if (opt.clearOnClick) {
            res.clear();
        }
    };
    var res = {
        clear: function () {
            if (!container) {
                return;
            }
            react_dom_1.default.render(jsx_runtime_1.jsx(toast_1.Toast, __assign({}, opt, { message: message, onClick: onClick, onClosed: function () {
                    document.body.removeChild(container);
                    container = null;
                    opt.onClosed && opt.onClosed();
                } }), void 0), container);
            var index = toastReturnList.indexOf(res);
            index >= 0 && toastReturnList.splice(index, 1);
        },
        setMessage: function (msg) {
            if (!container) {
                return;
            }
            message = msg;
            react_dom_1.default.render(jsx_runtime_1.jsx(toast_1.Toast, __assign({}, opt, { message: message, onClick: onClick, show: true }), void 0), container);
        },
    };
    toastReturnList.push(res);
    document.body.appendChild(container);
    react_dom_1.default.render(jsx_runtime_1.jsx(toast_1.Toast, __assign({}, opt, { onClick: onClick, show: true }), void 0), container);
    if (opt.duration !== 0) {
        setTimeout(res.clear, opt.duration > 0 ? opt.duration : opt.loading ? 60 * 1000 : 2000);
    }
    return res;
}
exports.toast = toast;
function clearAllToasts() {
    toastReturnList.forEach(function (item) { return item.clear(); });
}
exports.clearAllToasts = clearAllToasts;
