import React from 'react';
import { LoadingType } from '../loading';
import './index.scss';
export declare type ToastPosition = 'top' | 'middle' | 'bottom';
export declare type ToastTextAlign = 'left' | 'center' | 'right';
export declare type ToastProps = {
    show?: boolean;
    zIndex?: number;
    message: string;
    icon?: string;
    html?: boolean;
    className?: string;
    overlay?: boolean;
    iconPrefix?: string;
    position?: ToastPosition;
    loading?: boolean;
    loadingType?: LoadingType;
    textAlign?: ToastTextAlign;
    onClosed?(): void;
    onOpened?(): void;
    onClick?(event: React.MouseEvent): void;
};
export declare const Toast: React.FC<ToastProps>;
