"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Toast = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importStar(require("react"));
var clsx_1 = __importDefault(require("clsx"));
var overlay_1 = require("../overlay");
var transition_1 = require("../transition");
var utils_1 = require("../utils");
var bem_1 = require("../utils/bem");
var constant_1 = require("../utils/constant");
var icon_1 = require("../icon");
var loading_1 = require("../loading");
require("./index.scss");
var bem = bem_1.createBEM('pant-toast');
function genIcon(props) {
    var icon = props.icon, iconPrefix = props.iconPrefix, loading = props.loading, loadingType = props.loadingType;
    if (loading) {
        return jsx_runtime_1.jsx(loading_1.Loading, { className: bem('loading'), type: loadingType }, void 0);
    }
    else if (icon) {
        return jsx_runtime_1.jsx(icon_1.Icon, { className: bem('icon'), classPrefix: iconPrefix, name: icon }, void 0);
    }
}
function genMessage(props) {
    var html = props.html, message = props.message;
    if (!utils_1.isDef(message) || message === '') {
        return;
    }
    if (html) {
        return jsx_runtime_1.jsx("div", { className: bem('text'), dangerouslySetInnerHTML: { __html: message } }, void 0);
    }
    return jsx_runtime_1.jsx("div", __assign({ className: bem('text') }, { children: message }), void 0);
}
var Toast = function (props) {
    var _a;
    var containerRef = react_1.useRef();
    var show = props.show, zIndex = props.zIndex, overlay = props.overlay;
    var incZIndex = zIndex || utils_1.getIncrementalZIndex(constant_1.Z_INDEX_TOAST_BASE);
    return (jsx_runtime_1.jsxs(react_1.default.Fragment, { children: [overlay ? jsx_runtime_1.jsx(overlay_1.Overlay, { zIndex: incZIndex, style: { backgroundColor: 'rgba(0, 0, 0, 0)' }, show: show }, void 0) : null,
            jsx_runtime_1.jsx(transition_1.Transition, __assign({ name: "fade", stage: show ? 'enter' : 'leave', onAfterEnter: show ? props.onOpened : null, onAfterLeave: show ? null : props.onClosed }, { children: jsx_runtime_1.jsxs("div", __assign({ ref: containerRef, className: clsx_1.default(bem([
                        props.position,
                        "align-" + props.textAlign,
                        (_a = {}, _a[props.html ? 'html' : 'text'] = !props.icon && !props.loading, _a),
                    ]), props.className), style: { zIndex: incZIndex }, onClick: props.onClick }, { children: [genIcon(props), genMessage(props)] }), void 0) }), void 0)] }, void 0));
};
exports.Toast = Toast;
exports.Toast.defaultProps = {
    html: false,
    overlay: false,
    loading: false,
    position: 'middle',
    textAlign: 'center',
};
