"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepAssign = void 0;
var _1 = require(".");
var hasOwnProperty = Object.prototype.hasOwnProperty;
function assignKey(to, from, key) {
    var val = from[key];
    if (!_1.isDef(val)) {
        return;
    }
    if (!hasOwnProperty.call(to, key) || !_1.isObject(val)) {
        to[key] = val;
    }
    else {
        to[key] = deepAssign(Object(to[key]), from[key]);
    }
}
function deepAssign(to, from) {
    Object.keys(from).forEach(function (key) {
        assignKey(to, from, key);
    });
    return to;
}
exports.deepAssign = deepAssign;
