"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.preventDefaultAndStopPropagation = exports.preventDefault = exports.stopPropagation = exports.off = exports.on = exports.supportsPassive = void 0;
var __1 = require("../");
var isServer = __1.pantConfig('isServer');
exports.supportsPassive = false;
if (!isServer) {
    try {
        var opts = {};
        Object.defineProperty(opts, 'passive', {
            get: function () {
                exports.supportsPassive = true;
            },
        });
        window.addEventListener('test-passive', null, opts);
    }
    catch (e) {
        //
    }
}
function on(target, event, handler, passive) {
    if (passive === void 0) { passive = false; }
    if (!isServer) {
        target.addEventListener(event, handler, exports.supportsPassive ? { capture: false, passive: passive } : false);
    }
}
exports.on = on;
function off(target, event, handler) {
    if (!isServer) {
        target.removeEventListener(event, handler);
    }
}
exports.off = off;
function stopPropagation(event) {
    event.stopPropagation();
}
exports.stopPropagation = stopPropagation;
function preventDefault(event) {
    if (typeof event.cancelable !== 'boolean' || event.cancelable) {
        event.preventDefault();
    }
}
exports.preventDefault = preventDefault;
function preventDefaultAndStopPropagation(event) {
    preventDefault(event);
    stopPropagation(event);
}
exports.preventDefaultAndStopPropagation = preventDefaultAndStopPropagation;
