declare type TouchHandlerOptions = {
    onBeforeTouchStart?(event: TouchEvent): boolean | void;
    onTouchStart?(event: TouchEvent): void;
    onBeforeTouchMove?(event: TouchEvent): boolean | void;
    onTouchMove?(event: TouchEvent): void;
    onTouchEnd?(event: TouchEvent): void;
    onTouchCancel?(event: TouchEvent): void;
};
export declare type TouchDirection = 'horizontal' | 'vertical' | '';
export declare type TouchHandlerState = {
    startX: number;
    startY: number;
    deltaX: number;
    deltaY: number;
    offsetX: number;
    offsetY: number;
    direction: TouchDirection;
};
export declare class TouchHandler {
    private el;
    private opt;
    private startX;
    private startY;
    private deltaX;
    private deltaY;
    private offsetX;
    private offsetY;
    private direction;
    constructor(el: HTMLElement, opt?: TouchHandlerOptions);
    private getDirection;
    touchStart(event: TouchEvent): void;
    touchMove(event: TouchEvent): void;
    private onTouchStart;
    private onTouchMove;
    private onTouchEnd;
    private onTouchCancel;
    private resetTouchState;
    private bindTouchEvent;
    get state(): TouchHandlerState;
    destroy(): void;
}
export {};
